=== modified file '.rsyncexclude'
--- .rsyncexclude	2005-10-13 07:08:44 +0000
+++ .rsyncexclude	2005-11-22 04:30:14 +0000
@@ -18,3 +18,6 @@
 /build
 test*.tmp
 .*.swp
+*.orig
+.*.orig
+.bzr-shelf*

=== modified file 'HACKING'
--- HACKING	2005-11-02 22:57:39 +0000
+++ HACKING	2005-11-08 20:16:02 +0000
@@ -38,13 +38,13 @@
   the user should really pay attention to - which includes trivial shell
   pipelines.
 
-  Recommanded values are 
+  Recommended values are 
     0- OK, 
     1- Conflicts in merge-like operations, or changes are present in
        diff-like operations. 
     2- Unrepresentable diff changes (i.e. binary files that we cannot show 
        a diff of).
-    3- An error or exception has occured.
+    3- An error or exception has occurred.
 
 Evolving interfaces
 -------------------
@@ -53,10 +53,10 @@
 be sure to change its name as well. For instance, if I add a keyword
 parameter to branch.commit - that's fine. On the other hand, if I add
 a keyword parameter to branch.commit which is a *required* transaction
-object, I should rename the api - i.e. to 'branch.commit_transaction'.
+object, I should rename the API - i.e. to 'branch.commit_transaction'.
 
-This will prevent users of the old api getting surprising results. 
-Instead, they will get an Attribute error as the api is missing, and
+This will prevent users of the old API getting surprising results. 
+Instead, they will get an Attribute error as the API is missing, and
 will know to update their code. If in doubt, just ask on #bzr.
 
 Documentation
@@ -65,6 +65,9 @@
 If you change the behaviour of a command, please update its docstring
 in bzrlib/commands.py.  This is displayed by the 'bzr help' command.
 
+NEWS file
+---------
+
 If you make a user-visible change, please add a note to the NEWS file.
 The description should be written to make sense to someone who's just
 a user of bzr, not a developer: new functions or classes shouldn't be
@@ -72,6 +75,20 @@
 bugs should be listed.  See the existing entries for an idea of what
 should be done.
 
+Within each release, entries in the news file should have the most
+user-visible changes first.  So the order should be approximately:
+
+ * changes to existing behaviour - the highest priority because the 
+   user's existing knowledge is incorrect
+ * new features - should be brought to their attention
+ * bug fixes - may be of interest if the bug was affecting them, and
+   should include the bug number if any
+ * major documentation changes
+ * changes to internal interfaces
+
+People who made significant contributions to each change are listed in
+parenthesis.  This can include reporting bugs (particularly with good
+details or reproduction recipes), submitting patches, etc.
 
 API documentation
 -----------------

=== modified file 'NEWS'
--- NEWS	2005-11-18 01:13:19 +0000
+++ NEWS	2005-11-23 07:18:42 +0000
@@ -1,10 +1,31 @@
 UNRELEASED CHANGES
 
+  CHANGES:
+
+    * .bzrignore is excluded from exports, on the grounds that it's a bzr 
+      internal-use file and may not be wanted.  (Jamie Wilkinson)
+
+    * The "bzr directories" command were removed in favor of the new
+      --kind option to the "bzr inventory" command.  To list all 
+      versioned directories, now use "bzr inventory --kind directory".  
+      (Johan Rydberg)
+
+    * Under Windows configuration directory is now %APPDATA%\bazaar\2.0
+      by default. (John Arbash Meinel)
+
+    * The parent of Bzr configuration directory can be set by BZR_HOME
+      environment variable. Now the path for it is searched in BZR_HOME, then
+      in HOME. Under Windows the order is: BZR_HOME, APPDATA (usually
+      points to C:\Documents and Settings\User Name\Application Data), HOME.
+      (John Arbash Meinel)
+
   IMPROVEMENTS:
 
     * "bzr INIT dir" now initializes the specified directory, and creates 
       it if it does not exist.  (John Arbash Meinel)
 
+    * New remerge command (Aaron Bentley)
+
     * Better zsh completion script.  (Steve Borho)
 
     * 'bzr diff' now returns 1 when there are changes in the working 
@@ -15,18 +36,56 @@
       location in the ~/.bazaar/branches.conf configuration file.
       (Robert Collins)
 
+    * Test directories are only kept if the test fails and the user requests
+      that they be kept.
+
+    * Tweaks to short log printing
+
+    * Added branch nicks, new nick command, printing them in log output. 
+      (Aaron Bentley)
+
+    * If $BZR_PDB is set, pop into the debugger when an uncaught exception 
+      occurs.  (Martin Pool)
+
+    * Accept 'bzr resolved' (an alias for 'bzr resolve'), as this is
+      the same as Subversion.  (Martin Pool)
+
+    * New ftp transport support (on ftplib), for ftp:// and aftp:// 
+      URLs.  (Daniel Silverstone)
+
   BUG FIXES:
 
     * SFTP can walk up to the root path without index errors. (Robert Collins)
 
     * Fix bugs in running bzr with 'python -O'.  (Martin Pool)
 
+    * Error when run with -OO
+
     * Fix bug in reporting http errors that don't have an http error code.
       (Martin Pool)
 
+    * Handle more cases of pipe errors in display commands
+
+    * Change status to 3 for all errors
+
+    * Files that are added and unlinked before committing are completely
+      ignored by diff and status
+
     * Stores with some compressed texts and some uncompressed texts are now
       able to be used. (John A Meinel)
 
+    * Show files which are both renamed and modified as such in 'bzr 
+      status' output.  (#4503, Daniel Silverstone)
+
+    * Make annotate cope better with revisions committed without a valid 
+      email address.  (Marien Zwart)
+
+    * Fix representation of tab characters in commit messages.  (Harald 
+      Meland)
+
+    * List of plugin directories in BZR_PLUGIN_PASS environment variable is
+      now parsed properly under Windows. (Alexander Belchenko)
+
   TESTING:
 
     * Fix selftest asking for passwords when there are no SFTP keys.  
@@ -34,6 +93,19 @@
 
     * Fix selftest run with 'python -O'.  (Martin Pool)
 
+    * Fix HTTP tests under Windows. (John Arbash Meinel)
+
+    * Make tests work even if HOME is not set (Aaron Bentley)
+
+    * Updated build_tree to use fixed line-endings for tests which read 
+      the file cotents and compare. Make some tests use this to pass under
+      Windows. (John Arbash Meinel)
+
+    * Skip stat and symlink tests under Windows. (Alexander Belchenko)
+
+    * Delay in selftest/testhashcash is now issued under win32 and Cygwin.
+      (John Arbash Meinel)
+
   INTERNALS:
 
     * WorkingTree.pull has been split across Branch and WorkingTree,
@@ -80,6 +152,7 @@
 
     * bzrlib.add.smart_add_branch is now smart_add_tree. (Robert Collins)
 
+
 bzr 0.6 2005-10-28
 
   IMPROVEMENTS:

=== modified file 'TODO'
--- TODO	2005-10-17 23:48:28 +0000
+++ TODO	2005-11-18 08:10:07 +0000
@@ -17,13 +17,6 @@
 Small things
 ------------
 
-* ``bzr status`` should show some description of patches that are merged but 
-  not yet committed.  Preferably in a very compact format so that they
-  just fit on a single line; this could also be used for say ``log
-  --tiny``::
-
-  2005-11-05      mbp  Flowers for stephane
-
 * Fix tests so that import errors caused by modules don't produce false reports
   that the tests themselves don't exist.
 
@@ -59,8 +52,6 @@
 
 * -r option should take a revision-id as well as a revno.
 
-* allow ``bzr st -r 300`` to show a summary of changes since then.
-
 * ``bzr info`` should count only people with distinct email addresses as
   different committers.  (Or perhaps only distinct userids?)
 
@@ -145,10 +136,6 @@
   methods return object, but what we really want is the raw XML, which
   can be popped into our own store.  That needs to be refactored.
 
-* ``bzr status FOO`` where foo is ignored should say so.
-
-* ``bzr mkdir A...`` should just create and add A.
-
 * Guard against repeatedly merging any particular patch.
 
 * More options for diff:
@@ -206,14 +193,9 @@
 
 * BZRDIR should be in branch.py not __init__.py.
 
-* ``status `` should accept a -r option to show changes relative to a revision,
-  or between revisions
-
 Medium things
 -------------
 
-* ~/.bzr.log is not written anymore for some reason.
-
 * merge should add all revision and inventory XML to the local store.
 
 * check should give a warning for revisions that are named in the
@@ -226,9 +208,6 @@
   just get the id for the selected files, look up their location and
   diff just those files.  No need to traverse the entire inventories.
 
-* ``bzr status DIR`` or ``bzr diff DIR`` should report on all changes
-  under that directory.
-
 * Fix up Inventory objects to represent root object as an entry.
 
 * Don't convert entire entry from ElementTree to an object when it is
@@ -339,7 +318,7 @@
 
   - Hold the ElementTree in memory in the Inventory object and work
     directly on that, rather than converting into Python objects every
-    time it is read in.  Probably still exposoe it through some kind of
+    time it is read in.  Probably still expose it through some kind of
     object interface though, but perhaps that should just be a proxy
     for the elements.
 
@@ -351,7 +330,7 @@
 
 * stat cache should perhaps only stat files as necessary, rather than
   doing them all up-front.  On the other hand, that disallows the
-  opimization of stating them in inode order.
+  optimization of stating them in inode order.
 
 * It'd be nice to pipeline multiple HTTP requests.  Often we can
   predict what will be wanted in future: all revisions, or all texts
@@ -382,7 +361,7 @@
   function.
 
 * Function to list a directory, saying in which revision each file was
-  last modified.  Useful for web and gui interfaces, and slow to
+  last modified.  Useful for web and GUI interfaces, and slow to
   compute one file at a time.
   
   This will be done when we track file texts by referring to the

=== modified file 'bzr'
--- bzr	2005-10-31 17:21:15 +0000
+++ bzr	2005-11-04 23:22:54 +0000
@@ -15,9 +15,11 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
+"""Bazaar-NG -- a free distributed version-control tool"""
 import os, sys
-
+if __doc__ is None:
+    print "bzr does not support python -OO."
+    sys.exit(2)
 try:
     version_info = sys.version_info
 except AttributeError:

=== modified file 'bzrlib/annotate.py'
--- bzrlib/annotate.py	2005-11-18 07:29:40 +0000
+++ bzrlib/annotate.py	2005-11-23 07:18:42 +0000
@@ -33,6 +33,7 @@
 
 import bzrlib.weave
 from bzrlib.config import extract_email_address
+from bzrlib.errors import BzrError
 
 
 def annotate_file(branch, rev_id, file_id, verbose=False, full=False,

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2005-11-17 22:59:33 +0000
+++ bzrlib/branch.py	2005-11-23 07:18:42 +0000
@@ -50,6 +50,7 @@
 from bzrlib.transport import Transport, get_transport
 import bzrlib.xml5
 import bzrlib.ui
+from config import TreeConfig
 
 
 BZR_BRANCH_FORMAT_4 = "Bazaar-NG branch, format 0.0.4\n"
@@ -109,14 +110,14 @@
         """Open a branch which may be of an old format.
         
         Only local branches are supported."""
-        return _Branch(get_transport(base), relax_version_check=True)
+        return BzrBranch(get_transport(base), relax_version_check=True)
         
     @staticmethod
     def open(base):
         """Open an existing branch, rooted at 'base' (url)"""
         t = get_transport(base)
         mutter("trying to open %r with transport %r", base, t)
-        return _Branch(t)
+        return BzrBranch(t)
 
     @staticmethod
     def open_containing(url):
@@ -131,7 +132,7 @@
         t = get_transport(url)
         while True:
             try:
-                return _Branch(t), t.relpath(url)
+                return BzrBranch(t), t.relpath(url)
             except NotBranchError:
                 pass
             new_t = t.clone('..')
@@ -144,7 +145,7 @@
     def initialize(base):
         """Create a new branch, rooted at 'base' (url)"""
         t = get_transport(base)
-        return _Branch(t, init=True)
+        return BzrBranch(t, init=True)
 
     def setup_caching(self, cache_root):
         """Subclasses that care about caching should override this, and set
@@ -152,8 +153,367 @@
         """
         self.cache_root = cache_root
 
-
-class _Branch(Branch):
+    def _get_nick(self):
+        cfg = self.tree_config()
+        return cfg.get_option(u"nickname", default=self.base.split('/')[-1])
+
+    def _set_nick(self, nick):
+        cfg = self.tree_config()
+        cfg.set_option(nick, "nickname")
+        assert cfg.get_option("nickname") == nick
+
+    nick = property(_get_nick, _set_nick)
+        
+    def push_stores(self, branch_to):
+        """Copy the content of this branches store to branch_to."""
+        raise NotImplementedError('push_stores is abstract')
+
+    def get_transaction(self):
+        """Return the current active transaction.
+
+        If no transaction is active, this returns a passthrough object
+        for which all data is immediately flushed and no caching happens.
+        """
+        raise NotImplementedError('get_transaction is abstract')
+
+    def lock_write(self):
+        raise NotImplementedError('lock_write is abstract')
+        
+    def lock_read(self):
+        raise NotImplementedError('lock_read is abstract')
+
+    def unlock(self):
+        raise NotImplementedError('unlock is abstract')
+
+    def abspath(self, name):
+        """Return absolute filename for something in the branch
+        
+        XXX: Robert Collins 20051017 what is this used for? why is it a branch
+        method and not a tree method.
+        """
+        raise NotImplementedError('abspath is abstract')
+
+    def controlfilename(self, file_or_path):
+        """Return location relative to branch."""
+        raise NotImplementedError('controlfilename is abstract')
+
+    def controlfile(self, file_or_path, mode='r'):
+        """Open a control file for this branch.
+
+        There are two classes of file in the control directory: text
+        and binary.  binary files are untranslated byte streams.  Text
+        control files are stored with Unix newlines and in UTF-8, even
+        if the platform or locale defaults are different.
+
+        Controlfiles should almost never be opened in write mode but
+        rather should be atomically copied and replaced using atomicfile.
+        """
+        raise NotImplementedError('controlfile is abstract')
+
+    def put_controlfile(self, path, f, encode=True):
+        """Write an entry as a controlfile.
+
+        :param path: The path to put the file, relative to the .bzr control
+                     directory
+        :param f: A file-like or string object whose contents should be copied.
+        :param encode:  If true, encode the contents as utf-8
+        """
+        raise NotImplementedError('put_controlfile is abstract')
+
+    def put_controlfiles(self, files, encode=True):
+        """Write several entries as controlfiles.
+
+        :param files: A list of [(path, file)] pairs, where the path is the directory
+                      underneath the bzr control directory
+        :param encode:  If true, encode the contents as utf-8
+        """
+        raise NotImplementedError('put_controlfiles is abstract')
+
+    def get_root_id(self):
+        """Return the id of this branches root"""
+        raise NotImplementedError('get_root_id is abstract')
+
+    def print_file(self, file, revno):
+        """Print `file` to stdout."""
+        raise NotImplementedError('print_file is abstract')
+
+    def append_revision(self, *revision_ids):
+        raise NotImplementedError('append_revision is abstract')
+
+    def set_revision_history(self, rev_history):
+        raise NotImplementedError('set_revision_history is abstract')
+
+    def has_revision(self, revision_id):
+        """True if this branch has a copy of the revision.
+
+        This does not necessarily imply the revision is merge
+        or on the mainline."""
+        raise NotImplementedError('has_revision is abstract')
+
+    def get_revision_xml_file(self, revision_id):
+        """Return XML file object for revision object."""
+        raise NotImplementedError('get_revision_xml_file is abstract')
+
+    def get_revision_xml(self, revision_id):
+        raise NotImplementedError('get_revision_xml is abstract')
+
+    def get_revision(self, revision_id):
+        """Return the Revision object for a named revision"""
+        raise NotImplementedError('get_revision is abstract')
+
+    def get_revision_delta(self, revno):
+        """Return the delta for one revision.
+
+        The delta is relative to its mainline predecessor, or the
+        empty tree for revision 1.
+        """
+        assert isinstance(revno, int)
+        rh = self.revision_history()
+        if not (1 <= revno <= len(rh)):
+            raise InvalidRevisionNumber(revno)
+
+        # revno is 1-based; list is 0-based
+
+        new_tree = self.revision_tree(rh[revno-1])
+        if revno == 1:
+            old_tree = EmptyTree()
+        else:
+            old_tree = self.revision_tree(rh[revno-2])
+
+        return compare_trees(old_tree, new_tree)
+
+    def get_revision_sha1(self, revision_id):
+        """Hash the stored value of a revision, and return it."""
+        raise NotImplementedError('get_revision_sha1 is abstract')
+
+    def get_ancestry(self, revision_id):
+        """Return a list of revision-ids integrated by a revision.
+        
+        This currently returns a list, but the ordering is not guaranteed:
+        treat it as a set.
+        """
+        raise NotImplementedError('get_ancestry is abstract')
+
+    def get_inventory(self, revision_id):
+        """Get Inventory object by hash."""
+        raise NotImplementedError('get_inventory is abstract')
+
+    def get_inventory_xml(self, revision_id):
+        """Get inventory XML as a file object."""
+        raise NotImplementedError('get_inventory_xml is abstract')
+
+    def get_inventory_sha1(self, revision_id):
+        """Return the sha1 hash of the inventory entry."""
+        raise NotImplementedError('get_inventory_sha1 is abstract')
+
+    def get_revision_inventory(self, revision_id):
+        """Return inventory of a past revision."""
+        raise NotImplementedError('get_revision_inventory is abstract')
+
+    def revision_history(self):
+        """Return sequence of revision hashes on to this branch."""
+        raise NotImplementedError('revision_history is abstract')
+
+    def revno(self):
+        """Return current revision number for this branch.
+
+        That is equivalent to the number of revisions committed to
+        this branch.
+        """
+        return len(self.revision_history())
+
+    def last_revision(self):
+        """Return last patch hash, or None if no history."""
+        ph = self.revision_history()
+        if ph:
+            return ph[-1]
+        else:
+            return None
+
+    def missing_revisions(self, other, stop_revision=None, diverged_ok=False):
+        """Return a list of new revisions that would perfectly fit.
+        
+        If self and other have not diverged, return a list of the revisions
+        present in other, but missing from self.
+
+        >>> from bzrlib.commit import commit
+        >>> bzrlib.trace.silent = True
+        >>> br1 = ScratchBranch()
+        >>> br2 = ScratchBranch()
+        >>> br1.missing_revisions(br2)
+        []
+        >>> commit(br2, "lala!", rev_id="REVISION-ID-1")
+        >>> br1.missing_revisions(br2)
+        [u'REVISION-ID-1']
+        >>> br2.missing_revisions(br1)
+        []
+        >>> commit(br1, "lala!", rev_id="REVISION-ID-1")
+        >>> br1.missing_revisions(br2)
+        []
+        >>> commit(br2, "lala!", rev_id="REVISION-ID-2A")
+        >>> br1.missing_revisions(br2)
+        [u'REVISION-ID-2A']
+        >>> commit(br1, "lala!", rev_id="REVISION-ID-2B")
+        >>> br1.missing_revisions(br2)
+        Traceback (most recent call last):
+        DivergedBranches: These branches have diverged.
+        """
+        self_history = self.revision_history()
+        self_len = len(self_history)
+        other_history = other.revision_history()
+        other_len = len(other_history)
+        common_index = min(self_len, other_len) -1
+        if common_index >= 0 and \
+            self_history[common_index] != other_history[common_index]:
+            raise DivergedBranches(self, other)
+
+        if stop_revision is None:
+            stop_revision = other_len
+        else:
+            assert isinstance(stop_revision, int)
+            if stop_revision > other_len:
+                raise bzrlib.errors.NoSuchRevision(self, stop_revision)
+        return other_history[self_len:stop_revision]
+    
+    def update_revisions(self, other, stop_revision=None):
+        """Pull in new perfect-fit revisions."""
+        raise NotImplementedError('update_revisions is abstract')
+
+    def pullable_revisions(self, other, stop_revision):
+        raise NotImplementedError('pullable_revisions is abstract')
+        
+    def revision_id_to_revno(self, revision_id):
+        """Given a revision id, return its revno"""
+        if revision_id is None:
+            return 0
+        history = self.revision_history()
+        try:
+            return history.index(revision_id) + 1
+        except ValueError:
+            raise bzrlib.errors.NoSuchRevision(self, revision_id)
+
+    def get_rev_id(self, revno, history=None):
+        """Find the revision id of the specified revno."""
+        if revno == 0:
+            return None
+        if history is None:
+            history = self.revision_history()
+        elif revno <= 0 or revno > len(history):
+            raise bzrlib.errors.NoSuchRevision(self, revno)
+        return history[revno - 1]
+
+    def revision_tree(self, revision_id):
+        """Return Tree for a revision on this branch.
+
+        `revision_id` may be None for the null revision, in which case
+        an `EmptyTree` is returned."""
+        raise NotImplementedError('revision_tree is abstract')
+
+    def working_tree(self):
+        """Return a `Tree` for the working copy if this is a local branch."""
+        raise NotImplementedError('working_tree is abstract')
+
+    def pull(self, source, overwrite=False):
+        raise NotImplementedError('pull is abstract')
+
+    def basis_tree(self):
+        """Return `Tree` object for last revision.
+
+        If there are no revisions yet, return an `EmptyTree`.
+        """
+        return self.revision_tree(self.last_revision())
+
+    def rename_one(self, from_rel, to_rel):
+        """Rename one file.
+
+        This can change the directory or the filename or both.
+        """
+        raise NotImplementedError('rename_one is abstract')
+
+    def move(self, from_paths, to_name):
+        """Rename files.
+
+        to_name must exist as a versioned directory.
+
+        If to_name exists and is a directory, the files are moved into
+        it, keeping their old names.  If it is a directory, 
+
+        Note that to_name is only the last component of the new name;
+        this doesn't change the directory.
+
+        This returns a list of (from_path, to_path) pairs for each
+        entry that is moved.
+        """
+        raise NotImplementedError('move is abstract')
+
+    def revert(self, filenames, old_tree=None, backups=True):
+        """Restore selected files to the versions from a previous tree.
+
+        backups
+            If true (default) backups are made of files before
+            they're renamed.
+        """
+        raise NotImplementedError('revert is abstract')
+
+    def pending_merges(self):
+        """Return a list of pending merges.
+
+        These are revisions that have been merged into the working
+        directory but not yet committed.
+        """
+        raise NotImplementedError('pending_merges is abstract')
+
+    def add_pending_merge(self, *revision_ids):
+        # TODO: Perhaps should check at this point that the
+        # history of the revision is actually present?
+        raise NotImplementedError('add_pending_merge is abstract')
+
+    def set_pending_merges(self, rev_list):
+        raise NotImplementedError('set_pending_merges is abstract')
+
+    def get_parent(self):
+        """Return the parent location of the branch.
+
+        This is the default location for push/pull/missing.  The usual
+        pattern is that the user can override it by specifying a
+        location.
+        """
+        raise NotImplementedError('get_parent is abstract')
+
+    def get_push_location(self):
+        """Return the None or the location to push this branch to."""
+        raise NotImplementedError('get_push_location is abstract')
+
+    def set_push_location(self, location):
+        """Set a new push location for this branch."""
+        raise NotImplementedError('set_push_location is abstract')
+
+    def set_parent(self, url):
+        raise NotImplementedError('set_parent is abstract')
+
+    def check_revno(self, revno):
+        """\
+        Check whether a revno corresponds to any revision.
+        Zero (the NULL revision) is considered valid.
+        """
+        if revno != 0:
+            self.check_real_revno(revno)
+            
+    def check_real_revno(self, revno):
+        """\
+        Check whether a revno corresponds to a real revision.
+        Zero (the NULL revision) is considered invalid
+        """
+        if revno < 1 or revno > self.revno():
+            raise InvalidRevisionNumber(revno)
+        
+    def sign_revision(self, revision_id, gpg_strategy):
+        raise NotImplementedError('sign_revision is abstract')
+
+    def store_revision_signature(self, gpg_strategy, plaintext, revision_id):
+        raise NotImplementedError('store_revision_signature is abstract')
+
+class BzrBranch(Branch):
     """A branch stored in the actual filesystem.
 
     Note that it's "local" in the context of the filesystem; it doesn't
@@ -185,7 +545,7 @@
     REVISION_NAMESPACES = {}
 
     def push_stores(self, branch_to):
-        """Copy the content of this branches store to branch_to."""
+        """See Branch.push_stores."""
         if (self._branch_format != branch_to._branch_format
             or self._branch_format != 4):
             from bzrlib.fetch import greedy_fetch
@@ -308,11 +668,7 @@
         transaction.finish()
 
     def get_transaction(self):
-        """Return the current active transaction.
-
-        If no transaction is active, this returns a passthrough object
-        for which all data is immediately flushed and no caching happens.
-        """
+        """See Branch.get_transaction."""
         if self._transaction is None:
             return transactions.PassThroughTransaction()
         else:
@@ -370,11 +726,7 @@
             self._lock_mode = self._lock_count = None
 
     def abspath(self, name):
-        """Return absolute filename for something in the branch
-        
-        XXX: Robert Collins 20051017 what is this used for? why is it a branch
-        method and not a tree method.
-        """
+        """See Branch.abspath."""
         return self._transport.abspath(name)
 
     def _rel_controlfilename(self, file_or_path):
@@ -385,20 +737,11 @@
         return bzrlib.transport.urlescape(bzrlib.BZRDIR + '/' + file_or_path)
 
     def controlfilename(self, file_or_path):
-        """Return location relative to branch."""
+        """See Branch.controlfilename."""
         return self._transport.abspath(self._rel_controlfilename(file_or_path))
 
     def controlfile(self, file_or_path, mode='r'):
-        """Open a control file for this branch.
-
-        There are two classes of file in the control directory: text
-        and binary.  binary files are untranslated byte streams.  Text
-        control files are stored with Unix newlines and in UTF-8, even
-        if the platform or locale defaults are different.
-
-        Controlfiles should almost never be opened in write mode but
-        rather should be atomically copied and replaced using atomicfile.
-        """
+        """See Branch.controlfile."""
         import codecs
 
         relpath = self._rel_controlfilename(file_or_path)
@@ -420,22 +763,11 @@
             raise BzrError("invalid controlfile mode %r" % mode)
 
     def put_controlfile(self, path, f, encode=True):
-        """Write an entry as a controlfile.
-
-        :param path: The path to put the file, relative to the .bzr control
-                     directory
-        :param f: A file-like or string object whose contents should be copied.
-        :param encode:  If true, encode the contents as utf-8
-        """
+        """See Branch.put_controlfile."""
         self.put_controlfiles([(path, f)], encode=encode)
 
     def put_controlfiles(self, files, encode=True):
-        """Write several entries as controlfiles.
-
-        :param files: A list of [(path, file)] pairs, where the path is the directory
-                      underneath the bzr control directory
-        :param encode:  If true, encode the contents as utf-8
-        """
+        """See Branch.put_controlfiles."""
         import codecs
         ctrl_files = []
         for path, f in files:
@@ -511,14 +843,15 @@
                             'or remove the .bzr directory'
                             ' and "bzr init" again'])
 
+    @needs_read_lock
     def get_root_id(self):
-        """Return the id of this branches root"""
+        """See Branch.get_root_id."""
         inv = self.get_inventory(self.last_revision())
         return inv.root.file_id
 
     @needs_read_lock
     def print_file(self, file, revno):
-        """Print `file` to stdout."""
+        """See Branch.print_file."""
         tree = self.revision_tree(self.get_rev_id(revno))
         # use inventory as it was in that revision
         file_id = tree.inventory.path2id(file)
@@ -528,6 +861,7 @@
 
     @needs_write_lock
     def append_revision(self, *revision_ids):
+        """See Branch.append_revision."""
         for revision_id in revision_ids:
             mutter("add {%s} to revision-history" % revision_id)
         rev_history = self.revision_history()
@@ -536,19 +870,17 @@
 
     @needs_write_lock
     def set_revision_history(self, rev_history):
+        """See Branch.set_revision_history."""
         self.put_controlfile('revision-history', '\n'.join(rev_history))
 
     def has_revision(self, revision_id):
-        """True if this branch has a copy of the revision.
-
-        This does not necessarily imply the revision is merge
-        or on the mainline."""
+        """See Branch.has_revision."""
         return (revision_id is None
                 or self.revision_store.has_id(revision_id))
 
     @needs_read_lock
     def get_revision_xml_file(self, revision_id):
-        """Return XML file object for revision object."""
+        """See Branch.get_revision_xml_file."""
         if not revision_id or not isinstance(revision_id, basestring):
             raise InvalidRevisionId(revision_id=revision_id, branch=self)
         try:
@@ -560,11 +892,12 @@
     get_revision_xml = get_revision_xml_file
 
     def get_revision_xml(self, revision_id):
+        """See Branch.get_revision_xml."""
         return self.get_revision_xml_file(revision_id).read()
 
 
     def get_revision(self, revision_id):
-        """Return the Revision object for a named revision"""
+        """See Branch.get_revision."""
         xml_file = self.get_revision_xml_file(revision_id)
 
         try:
@@ -577,29 +910,8 @@
         assert r.revision_id == revision_id
         return r
 
-    def get_revision_delta(self, revno):
-        """Return the delta for one revision.
-
-        The delta is relative to its mainline predecessor, or the
-        empty tree for revision 1.
-        """
-        assert isinstance(revno, int)
-        rh = self.revision_history()
-        if not (1 <= revno <= len(rh)):
-            raise InvalidRevisionNumber(revno)
-
-        # revno is 1-based; list is 0-based
-
-        new_tree = self.revision_tree(rh[revno-1])
-        if revno == 1:
-            old_tree = EmptyTree()
-        else:
-            old_tree = self.revision_tree(rh[revno-2])
-
-        return compare_trees(old_tree, new_tree)
-
     def get_revision_sha1(self, revision_id):
-        """Hash the stored value of a revision, and return it."""
+        """See Branch.get_revision_sha1."""
         # In the future, revision entries will be signed. At that
         # point, it is probably best *not* to include the signature
         # in the revision hash. Because that lets you re-sign
@@ -609,42 +921,37 @@
         return bzrlib.osutils.sha_file(self.get_revision_xml_file(revision_id))
 
     def get_ancestry(self, revision_id):
-        """Return a list of revision-ids integrated by a revision.
-        
-        This currently returns a list, but the ordering is not guaranteed:
-        treat it as a set.
-        """
+        """See Branch.get_ancestry."""
         if revision_id is None:
             return [None]
-        w = self.get_inventory_weave()
+        w = self._get_inventory_weave()
         return [None] + map(w.idx_to_name,
                             w.inclusions([w.lookup(revision_id)]))
 
-    def get_inventory_weave(self):
+    def _get_inventory_weave(self):
         return self.control_weaves.get_weave('inventory',
                                              self.get_transaction())
 
     def get_inventory(self, revision_id):
-        """Get Inventory object by hash."""
+        """See Branch.get_inventory."""
         xml = self.get_inventory_xml(revision_id)
         return bzrlib.xml5.serializer_v5.read_inventory_from_string(xml)
 
     def get_inventory_xml(self, revision_id):
-        """Get inventory XML as a file object."""
+        """See Branch.get_inventory_xml."""
         try:
             assert isinstance(revision_id, basestring), type(revision_id)
-            iw = self.get_inventory_weave()
+            iw = self._get_inventory_weave()
             return iw.get_text(iw.lookup(revision_id))
         except IndexError:
             raise bzrlib.errors.HistoryMissing(self, 'inventory', revision_id)
 
     def get_inventory_sha1(self, revision_id):
-        """Return the sha1 hash of the inventory entry
-        """
+        """See Branch.get_inventory_sha1."""
         return self.get_revision(revision_id).inventory_sha1
 
     def get_revision_inventory(self, revision_id):
-        """Return inventory of a past revision."""
+        """See Branch.get_revision_inventory."""
         # TODO: Unify this with get_inventory()
         # bzr 0.0.6 and later imposes the constraint that the inventory_id
         # must be the same as its revision, so this is trivial.
@@ -660,7 +967,7 @@
 
     @needs_read_lock
     def revision_history(self):
-        """Return sequence of revision hashes on to this branch."""
+        """See Branch.revision_history."""
         transaction = self.get_transaction()
         history = transaction.map.find_revision_history()
         if history is not None:
@@ -674,70 +981,8 @@
         # transaction.register_clean(history, precious=True)
         return list(history)
 
-    def revno(self):
-        """Return current revision number for this branch.
-
-        That is equivalent to the number of revisions committed to
-        this branch.
-        """
-        return len(self.revision_history())
-
-    def last_revision(self):
-        """Return last patch hash, or None if no history.
-        """
-        ph = self.revision_history()
-        if ph:
-            return ph[-1]
-        else:
-            return None
-
-    def missing_revisions(self, other, stop_revision=None, diverged_ok=False):
-        """Return a list of new revisions that would perfectly fit.
-        
-        If self and other have not diverged, return a list of the revisions
-        present in other, but missing from self.
-
-        >>> from bzrlib.commit import commit
-        >>> bzrlib.trace.silent = True
-        >>> br1 = ScratchBranch()
-        >>> br2 = ScratchBranch()
-        >>> br1.missing_revisions(br2)
-        []
-        >>> commit(br2, "lala!", rev_id="REVISION-ID-1")
-        >>> br1.missing_revisions(br2)
-        [u'REVISION-ID-1']
-        >>> br2.missing_revisions(br1)
-        []
-        >>> commit(br1, "lala!", rev_id="REVISION-ID-1")
-        >>> br1.missing_revisions(br2)
-        []
-        >>> commit(br2, "lala!", rev_id="REVISION-ID-2A")
-        >>> br1.missing_revisions(br2)
-        [u'REVISION-ID-2A']
-        >>> commit(br1, "lala!", rev_id="REVISION-ID-2B")
-        >>> br1.missing_revisions(br2)
-        Traceback (most recent call last):
-        DivergedBranches: These branches have diverged.
-        """
-        self_history = self.revision_history()
-        self_len = len(self_history)
-        other_history = other.revision_history()
-        other_len = len(other_history)
-        common_index = min(self_len, other_len) -1
-        if common_index >= 0 and \
-            self_history[common_index] != other_history[common_index]:
-            raise DivergedBranches(self, other)
-
-        if stop_revision is None:
-            stop_revision = other_len
-        else:
-            assert isinstance(stop_revision, int)
-            if stop_revision > other_len:
-                raise bzrlib.errors.NoSuchRevision(self, stop_revision)
-        return other_history[self_len:stop_revision]
-
     def update_revisions(self, other, stop_revision=None):
-        """Pull in new perfect-fit revisions."""
+        """See Branch.update_revisions."""
         from bzrlib.fetch import greedy_fetch
         if stop_revision is None:
             stop_revision = other.last_revision()
@@ -752,6 +997,7 @@
             self.append_revision(*pullable_revs)
 
     def pullable_revisions(self, other, stop_revision):
+        """See Branch.pullable_revisions."""
         other_revno = other.revision_id_to_revno(stop_revision)
         try:
             return self.missing_revisions(other, other_revno)
@@ -788,10 +1034,7 @@
         return history[revno - 1]
 
     def revision_tree(self, revision_id):
-        """Return Tree for a revision on this branch.
-
-        `revision_id` may be None for the null revision, in which case
-        an `EmptyTree` is returned."""
+        """See Branch.revision_tree."""
         # TODO: refactor this to use an existing revision object
         # so we don't need to read it in twice.
         if revision_id == None or revision_id == NULL_REVISION:
@@ -801,7 +1044,7 @@
             return RevisionTree(self.weave_store, inv, revision_id)
 
     def working_tree(self):
-        """Return a `Tree` for the working copy if this is a local branch."""
+        """See Branch.working_tree."""
         from bzrlib.workingtree import WorkingTree
         if self._transport.base.find('://') != -1:
             raise NoWorkingTree(self.base)
@@ -809,6 +1052,7 @@
 
     @needs_write_lock
     def pull(self, source, overwrite=False):
+        """See Branch.pull."""
         source.lock_read()
         try:
             try:
@@ -820,20 +1064,8 @@
         finally:
             source.unlock()
 
-    def basis_tree(self):
-        """Return `Tree` object for last revision.
-
-        If there are no revisions yet, return an `EmptyTree`.
-        """
-        return self.revision_tree(self.last_revision())
-
     def get_parent(self):
-        """Return the parent location of the branch.
-
-        This is the default location for push/pull/missing.  The usual
-        pattern is that the user can override it by specifying a
-        location.
-        """
+        """See Branch.get_parent."""
         import errno
         _locs = ['parent', 'pull', 'x-pull']
         for l in _locs:
@@ -845,18 +1077,19 @@
         return None
 
     def get_push_location(self):
-        """Return the None or the location to push this branch to."""
+        """See Branch.get_push_location."""
         config = bzrlib.config.BranchConfig(self)
         push_loc = config.get_user_option('push_location')
         return push_loc
 
     def set_push_location(self, location):
-        """Set a new push location for this branch."""
+        """See Branch.set_push_location."""
         config = bzrlib.config.LocationConfig(self.base)
         config.set_user_option('push_location', location)
 
     @needs_write_lock
     def set_parent(self, url):
+        """See Branch.set_parent."""
         # TODO: Maybe delete old location files?
         from bzrlib.atomicfile import AtomicFile
         f = AtomicFile(self.controlfilename('parent'))
@@ -866,6 +1099,9 @@
         finally:
             f.close()
 
+    def tree_config(self):
+        return TreeConfig(self)
+
     def check_revno(self, revno):
         """\
         Check whether a revno corresponds to any revision.
@@ -883,16 +1119,18 @@
             raise InvalidRevisionNumber(revno)
         
     def sign_revision(self, revision_id, gpg_strategy):
+        """See Branch.sign_revision."""
         plaintext = Testament.from_revision(self, revision_id).as_short_text()
         self.store_revision_signature(gpg_strategy, plaintext, revision_id)
 
     @needs_write_lock
     def store_revision_signature(self, gpg_strategy, plaintext, revision_id):
+        """See Branch.store_revision_signature."""
         self.revision_store.add(StringIO(gpg_strategy.sign(plaintext)), 
                                 revision_id, "sig")
 
 
-class ScratchBranch(_Branch):
+class ScratchBranch(BzrBranch):
     """Special test class: a branch that cleans up after itself.
 
     >>> b = ScratchBranch()

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2005-11-17 22:57:58 +0000
+++ bzrlib/builtins.py	2005-11-23 07:18:42 +0000
@@ -26,8 +26,10 @@
 from bzrlib import BZRDIR
 from bzrlib.commands import Command, display_command
 from bzrlib.branch import Branch
-from bzrlib.errors import BzrError, BzrCheckError, BzrCommandError, NotBranchError
-from bzrlib.errors import DivergedBranches, NoSuchFile, NoWorkingTree
+from bzrlib.revision import common_ancestor
+from bzrlib.errors import (BzrError, BzrCheckError, BzrCommandError, 
+                           NotBranchError, DivergedBranches, NotConflicted,
+                           NoSuchFile, NoWorkingTree, FileInWrongBranch)
 from bzrlib.option import Option
 from bzrlib.revisionspec import RevisionSpec
 import bzrlib.trace
@@ -36,6 +38,13 @@
 
 
 def tree_files(file_list, default_branch='.'):
+    try:
+        return internal_tree_files(file_list, default_branch)
+    except FileInWrongBranch, e:
+        raise BzrCommandError("%s is not in the same branch as %s" %
+                             (e.path, file_list[0]))
+
+def internal_tree_files(file_list, default_branch='.'):
     """\
     Return a branch and list of branch-relative paths.
     If supplied file_list is empty or None, the branch default will be used,
@@ -49,8 +58,7 @@
         try:
             new_list.append(tree.relpath(filename))
         except NotBranchError:
-            raise BzrCommandError("%s is not in the same tree as %s" % 
-                                  (filename, file_list[0]))
+            raise FileInWrongBranch(tree.branch, filename)
     return tree, new_list
 
 
@@ -100,13 +108,10 @@
     that revision, or between two revisions if two are provided.
     """
     
-    # XXX: FIXME: bzr status should accept a -r option to show changes
-    # relative to a revision, or between revisions
-
     # TODO: --no-recurse, --recurse options
     
     takes_args = ['file*']
-    takes_options = ['all', 'show-ids']
+    takes_options = ['all', 'show-ids', 'revision']
     aliases = ['st', 'stat']
     
     @display_command
@@ -246,11 +251,17 @@
 
 
 class cmd_inventory(Command):
-    """Show inventory of the current working copy or a revision."""
-    takes_options = ['revision', 'show-ids']
+    """Show inventory of the current working copy or a revision.
+
+    It is possible to limit the output to a particular entry
+    type using the --kind option.  For example; --kind file.
+    """
+    takes_options = ['revision', 'show-ids', 'kind']
     
     @display_command
-    def run(self, revision=None, show_ids=False):
+    def run(self, revision=None, show_ids=False, kind=None):
+        if kind and kind not in ['file', 'directory', 'symlink']:
+            raise BzrCommandError('invalid kind specified')
         tree = WorkingTree.open_containing('.')[0]
         if revision is None:
             inv = tree.read_working_inventory()
@@ -262,6 +273,8 @@
                 revision[0].in_history(tree.branch).rev_id)
 
         for path, entry in inv.entries():
+            if kind and kind != entry.kind:
+                continue
             if show_ids:
                 print '%-50s %s' % (path, entry.file_id)
             else:
@@ -659,18 +672,6 @@
             print revision_id
 
 
-class cmd_directories(Command):
-    """Display list of versioned directories in this tree."""
-    @display_command
-    def run(self):
-        for name, ie in (WorkingTree.open_containing('.')[0].
-                         read_working_inventory().directories()):
-            if name == '':
-                print '.'
-            else:
-                print name
-
-
 class cmd_init(Command):
     """Make a directory into a versioned branch.
 
@@ -732,9 +733,23 @@
     @display_command
     def run(self, revision=None, file_list=None, diff_options=None):
         from bzrlib.diff import show_diff
-        
-        tree, file_list = tree_files(file_list)
+        try:
+            tree, file_list = internal_tree_files(file_list)
+            b = None
+            b2 = None
+        except FileInWrongBranch:
+            if len(file_list) != 2:
+                raise BzrCommandError("Files are in different branches")
+
+            b, file1 = Branch.open_containing(file_list[0])
+            b2, file2 = Branch.open_containing(file_list[1])
+            if file1 != "" or file2 != "":
+                # FIXME diff those two files. rbc 20051123
+                raise BzrCommandError("Files are in different branches")
+            file_list = None
         if revision is not None:
+            if b2 is not None:
+                raise BzrCommandError("Can't specify -r with two branches")
             if len(revision) == 1:
                 return show_diff(tree.branch, revision[0], specific_files=file_list,
                                  external_diff_options=diff_options)
@@ -745,8 +760,12 @@
             else:
                 raise BzrCommandError('bzr diff --revision takes exactly one or two revision identifiers')
         else:
-            return show_diff(tree.branch, None, specific_files=file_list,
-                             external_diff_options=diff_options)
+            if b is not None:
+                return show_diff(b, None, specific_files=file_list,
+                                 external_diff_options=diff_options, b2=b2)
+            else:
+                return show_diff(tree.branch, None, specific_files=file_list,
+                                 external_diff_options=diff_options)
 
 
 class cmd_deleted(Command):
@@ -888,10 +907,11 @@
         else:
             raise BzrCommandError('bzr log --revision takes one or two values.')
 
-        if rev1 == 0:
-            rev1 = None
-        if rev2 == 0:
-            rev2 = None
+        # By this point, the revision numbers are converted to the +ve
+        # form if they were supplied in the -ve form, so we can do
+        # this comparison in relative safety
+        if rev1 > rev2:
+            (rev2, rev1) = (rev1, rev2)
 
         mutter('encoding log as %r', bzrlib.user_encoding)
 
@@ -1316,6 +1336,23 @@
         else:
             print config.username()
 
+class cmd_nick(Command):
+    """\
+    Print or set the branch nickname.  
+    If unset, the tree root directory name is used as the nickname
+    To print the current nickname, execute with no argument.  
+    """
+    takes_args = ['nickname?']
+    def run(self, nickname=None):
+        branch = Branch.open_containing('.')[0]
+        if nickname is None:
+            self.printme(branch)
+        else:
+            branch.nick = nickname
+
+    @display_command
+    def printme(self, branch):
+        print branch.nick 
 
 class cmd_selftest(Command):
     """Run internal test suite.
@@ -1323,7 +1360,7 @@
     This creates temporary test directories in the working directory,
     but not existing data is affected.  These directories are deleted
     if the tests pass, or left behind to help in debugging if they
-    fail.
+    fail and --keep-output is specified.
     
     If arguments are given, they are regular expressions that say
     which tests should run.
@@ -1333,9 +1370,12 @@
     takes_args = ['testspecs*']
     takes_options = ['verbose', 
                      Option('one', help='stop when one test fails'),
+                     Option('keep-output', 
+                            help='keep output directories when tests fail')
                     ]
 
-    def run(self, testspecs_list=None, verbose=False, one=False):
+    def run(self, testspecs_list=None, verbose=False, one=False,
+            keep_output=False):
         import bzrlib.ui
         from bzrlib.selftest import selftest
         # we don't want progress meters from the tests to go to the
@@ -1351,7 +1391,8 @@
                 pattern = ".*"
             result = selftest(verbose=verbose, 
                               pattern=pattern,
-                              stop_on_failure=one)
+                              stop_on_failure=one, 
+                              keep_output=keep_output)
             if result:
                 bzrlib.trace.info('tests passed')
             else:
@@ -1510,6 +1551,66 @@
             log_error(m)
 
 
+class cmd_remerge(Command):
+    """Redo a merge.
+    """
+    takes_args = ['file*']
+    takes_options = ['merge-type', 'reprocess',
+                     Option('show-base', help="Show base revision text in "
+                            "conflicts")]
+
+    def run(self, file_list=None, merge_type=None, show_base=False,
+            reprocess=False):
+        from bzrlib.merge import merge_inner, transform_tree
+        from bzrlib.merge_core import ApplyMerge3
+        if merge_type is None:
+            merge_type = ApplyMerge3
+        tree, file_list = tree_files(file_list)
+        tree.lock_write()
+        try:
+            pending_merges = tree.pending_merges() 
+            if len(pending_merges) != 1:
+                raise BzrCommandError("Sorry, remerge only works after normal"
+                                      + " merges.  Not cherrypicking or"
+                                      + "multi-merges.")
+            base_revision = common_ancestor(tree.branch.last_revision(), 
+                                            pending_merges[0], tree.branch)
+            base_tree = tree.branch.revision_tree(base_revision)
+            other_tree = tree.branch.revision_tree(pending_merges[0])
+            interesting_ids = None
+            if file_list is not None:
+                interesting_ids = set()
+                for filename in file_list:
+                    file_id = tree.path2id(filename)
+                    interesting_ids.add(file_id)
+                    if tree.kind(file_id) != "directory":
+                        continue
+                    
+                    for name, ie in tree.inventory.iter_entries(file_id):
+                        interesting_ids.add(ie.file_id)
+            transform_tree(tree, tree.branch.basis_tree(), interesting_ids)
+            if file_list is None:
+                restore_files = list(tree.iter_conflicts())
+            else:
+                restore_files = file_list
+            for filename in restore_files:
+                try:
+                    restore(tree.abspath(filename))
+                except NotConflicted:
+                    pass
+            conflicts =  merge_inner(tree.branch, other_tree, base_tree, 
+                                     interesting_ids = interesting_ids, 
+                                     other_rev_id=pending_merges[0], 
+                                     merge_type=merge_type, 
+                                     show_base=show_base,
+                                     reprocess=reprocess)
+        finally:
+            tree.unlock()
+        if conflicts > 0:
+            return 1
+        else:
+            return 0
+
 class cmd_revert(Command):
     """Reverse all changes since the last commit.
 
@@ -1759,4 +1860,4 @@
 # TODO: Some more consistent way to split command definitions across files;
 # we do need to load at least some information about them to know of 
 # aliases.
-from bzrlib.conflicts import cmd_resolve, cmd_conflicts
+from bzrlib.conflicts import cmd_resolve, cmd_conflicts, restore

=== modified file 'bzrlib/changeset.py'
--- bzrlib/changeset.py	2005-11-10 03:03:53 +0000
+++ bzrlib/changeset.py	2005-11-17 07:45:38 +0000
@@ -13,25 +13,25 @@
 #    You should have received a copy of the GNU General Public License
 #    along with this program; if not, write to the Free Software
 #    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Represent and apply a changeset.
+
+Conflicts in applying a changeset are represented as exceptions.
+
+This only handles the in-memory objects representing changesets, which are
+primarily used by the merge code. 
+"""
+
 import os.path
 import errno
-import patch
 import stat
 from tempfile import mkdtemp
 from shutil import rmtree
-from bzrlib.trace import mutter
+from itertools import izip
+
+from bzrlib.trace import mutter, warning
 from bzrlib.osutils import rename, sha_file
 import bzrlib
-from itertools import izip
-
-# XXX: mbp: I'm not totally convinced that we should handle conflicts
-# as part of changeset application, rather than only in the merge
-# operation.
-
-"""Represent and apply a changeset
-
-Conflicts in applying a changeset are represented as exceptions.
-"""
 
 __docformat__ = "restructuredtext"
 
@@ -441,6 +441,7 @@
         return out_path
 
     def apply(self, filename, conflict_handler, reverse=False):
+        import bzrlib.patch
         temp_dir = mkdtemp(prefix="bzr-")
         try:
             new_file = filename+".new"
@@ -452,7 +453,7 @@
             else:
                 base = other_file
                 other = base_file
-            status = patch.diff3(new_file, filename, base, other)
+            status = bzrlib.patch.diff3(new_file, filename, base, other)
             if status == 0:
                 os.chmod(new_file, os.stat(filename).st_mode)
                 rename(new_file, filename)
@@ -1208,6 +1209,10 @@
     #apply changes that don't affect filenames
     for entry in changeset.entries.itervalues():
         if not entry.is_creation_or_deletion() and not entry.is_boring():
+            if entry.id not in inventory:
+                warning("entry {%s} no longer present, can't be updated",
+                        entry.id)
+                continue
             path = os.path.join(dir, inventory[entry.id])
             entry.apply(path, conflict_handler, reverse)
 

=== modified file 'bzrlib/check.py'
--- bzrlib/check.py	2005-11-17 21:55:55 +0000
+++ bzrlib/check.py	2005-11-23 07:18:42 +0000
@@ -41,6 +41,7 @@
 
     def __init__(self, branch):
         self.branch = branch
+        self.inventory_weave = branch._get_inventory_weave()
         self.checked_text_cnt = 0
         self.checked_rev_cnt = 0
         self.ghosts = []
@@ -53,24 +54,27 @@
 
     def check(self):
         self.branch.lock_read()
+        self.progress = bzrlib.ui.ui_factory.progress_bar()
         try:
             self.history = self.branch.revision_history()
             if not len(self.history):
                 # nothing to see here
                 return
-            self.planned_revisions = self.branch.get_ancestry(self.history[-1])
-            self.planned_revisions.remove(None)
-            revno = 0
+            if not self.branch.revision_store.listable():
+                raise BzrCheckError("Branch must be local")
+            self.planned_revisions = set(self.branch.revision_store)
+            inventoried = set(self.inventory_weave.names())
+            awol = self.planned_revisions - inventoried
+            if len(awol) > 0:
+                raise BzrCheckError('Stored revisions missing from inventory'
+                    '{%s}' % ','.join([f for f in awol]))
     
-            self.progress = bzrlib.ui.ui_factory.progress_bar()
-            while revno < len(self.planned_revisions):
-                rev_id = self.planned_revisions[revno]
-                self.progress.update('checking revision', revno,
+            for revno, rev_id in enumerate(self.planned_revisions):
+                self.progress.update('checking revision', revno+1,
                                      len(self.planned_revisions))
-                revno += 1
                 self.check_one_rev(rev_id)
+        finally:
             self.progress.clear()
-        finally:
             self.branch.unlock()
 
     def report_results(self, verbose):

=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2005-11-10 03:03:53 +0000
+++ bzrlib/commands.py	2005-11-18 06:39:02 +0000
@@ -168,6 +168,14 @@
         List of argument forms, marked with whether they are optional,
         repeated, etc.
 
+		Examples:
+
+		['to_location', 'from_branch?', 'file*']
+
+		'to_location' is required
+		'from_branch' is optional
+		'file' can be specified 0 or more times
+
     takes_options
         List of options that may be given for this command.  These can
         be either strings, referring to globally-defined options,
@@ -346,6 +354,9 @@
                             # into the array
                             optarg = a[2:]
             
+                if optname not in cmd_options:
+                    raise BzrOptionError('unknown short option %r for command'
+                        ' %s' % (shortopt, command.name()))
             if optname in opts:
                 # XXX: Do we ever want to support this, e.g. for -r?
                 raise BzrError('repeated option %r' % a)
@@ -507,12 +518,18 @@
     return ret or 0
 
 def display_command(func):
+    """Decorator that suppresses pipe/interrupt errors."""
     def ignore_pipe(*args, **kwargs):
         try:
-            return func(*args, **kwargs)
+            result = func(*args, **kwargs)
+            sys.stdout.flush()
+            return result
         except IOError, e:
+            if not hasattr(e, 'errno'):
+                raise
             if e.errno != errno.EPIPE:
                 raise
+            pass
         except KeyboardInterrupt:
             pass
     return ignore_pipe
@@ -532,31 +549,22 @@
         finally:
             # do this here inside the exception wrappers to catch EPIPE
             sys.stdout.flush()
-    except BzrCommandError, e:
-        # command line syntax error, etc
-        log_error(str(e))
-        return 1
-    except BzrError, e:
-        bzrlib.trace.log_exception()
-        return 1
-    except AssertionError, e:
-        bzrlib.trace.log_exception('assertion failed: ' + str(e))
-        return 3
-    except KeyboardInterrupt, e:
-        bzrlib.trace.log_exception('interrupted')
-        return 2
     except Exception, e:
+        # used to handle AssertionError and KeyboardInterrupt
+        # specially here, but hopefully they're handled ok by the logger now
         import errno
         if (isinstance(e, IOError) 
             and hasattr(e, 'errno')
             and e.errno == errno.EPIPE):
             bzrlib.trace.note('broken pipe')
-            return 2
+            return 3
         else:
-            ## import pdb
-            ## pdb.pm()
             bzrlib.trace.log_exception()
-            return 2
+            if os.environ.get('BZR_PDB'):
+                print '**** entering debugger'
+                import pdb
+                pdb.post_mortem(sys.exc_traceback)
+            return 3
 
 if __name__ == '__main__':
     sys.exit(main(sys.argv))

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2005-11-17 22:29:54 +0000
+++ bzrlib/commit.py	2005-11-23 07:18:42 +0000
@@ -206,7 +206,9 @@
         self.rev_id = rev_id
         self.specific_files = specific_files
         self.allow_pointless = allow_pointless
-        self.revprops = revprops
+        self.revprops = {'branch-nick': branch.nick}
+        if revprops:
+            self.revprops.update(revprops)
         self.work_tree = WorkingTree(branch.base, branch)
 
         if strict:
@@ -238,7 +240,9 @@
         else:
             self.timezone = int(timezone)
 
-        assert isinstance(message, basestring), type(message)
+        if isinstance(message, str):
+            message = message.decode(bzrlib.user_encoding)
+        assert isinstance(message, unicode), type(message)
         self.message = message
         self._escape_commit_message()
 
@@ -297,14 +301,8 @@
         # represented in well-formed XML; escape characters that
         # aren't listed in the XML specification
         # (http://www.w3.org/TR/REC-xml/#NT-Char).
-        if isinstance(self.message, unicode):
-            char_pattern = u'[^\x09\x0A\x0D\u0020-\uD7FF\uE000-\uFFFD]'
-        else:
-            # Use a regular 'str' as pattern to avoid having re.subn
-            # return 'unicode' results.
-            char_pattern = '[^x09\x0A\x0D\x20-\xFF]'
         self.message, escape_count = re.subn(
-            char_pattern,
+            u'[^\x09\x0A\x0D\u0020-\uD7FF\uE000-\uFFFD]+',
             lambda match: match.group(0).encode('unicode_escape'),
             self.message)
         if escape_count:

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2005-10-29 23:48:45 +0000
+++ bzrlib/config.py	2005-11-21 09:07:18 +0000
@@ -54,13 +54,14 @@
 
 import errno
 import os
+import sys
 from fnmatch import fnmatch
 import re
 
 import bzrlib
 import bzrlib.errors as errors
 import bzrlib.util.configobj.configobj as configobj
-
+from StringIO import StringIO
 
 CHECK_IF_POSSIBLE=0
 CHECK_ALWAYS=1
@@ -133,12 +134,7 @@
 
     def user_email(self):
         """Return just the email component of a username."""
-        e = self.username()
-        m = re.search(r'[\w+.-]+@[\w+.-]+', e)
-        if not m:
-            raise BzrError("%r doesn't seem to contain "
-                           "a reasonable email address" % e)
-        return m.group(0)
+        return extract_email_address(self.username())
 
     def username(self):
         """Return email-style username.
@@ -147,8 +143,8 @@
         
         $BZREMAIL can be set to override this, then
         the concrete policy type is checked, and finally
-        $EMAIL is examinged.
-        but if none is found, a reasonable default is (hopefully)
+        $EMAIL is examined.
+        If none is found, a reasonable default is (hopefully)
         created.
     
         TODO: Check it's reasonably well-formed.
@@ -419,7 +415,20 @@
     
     TODO: Global option --config-dir to override this.
     """
-    return os.path.join(os.path.expanduser("~"), ".bazaar")
+    base = os.environ.get('BZR_HOME', None)
+    if sys.platform == 'win32':
+        if base is None:
+            base = os.environ.get('APPDATA', None)
+        if base is None:
+            base = os.environ.get('HOME', None)
+        if base is None:
+            raise BzrError('You must have one of BZR_HOME, APPDATA, or HOME set')
+        return os.path.join(base, 'bazaar', '2.0')
+    else:
+        # cygwin, linux, and darwin all have a $HOME directory
+        if base is None:
+            base = os.path.expanduser("~")
+        return os.path.join(base, ".bazaar")
 
 
 def config_filename():
@@ -480,6 +489,55 @@
     """
     m = re.search(r'[\w+.-]+@[\w+.-]+', e)
     if not m:
-        raise BzrError("%r doesn't seem to contain "
-                       "a reasonable email address" % e)
+        raise errors.BzrError("%r doesn't seem to contain "
+                              "a reasonable email address" % e)
     return m.group(0)
+
+class TreeConfig(object):
+    """Branch configuration data associated with its contents, not location"""
+    def __init__(self, branch):
+        self.branch = branch
+
+    def _get_config(self):
+        try:
+            obj = ConfigObj(self.branch.controlfile('branch.conf',
+                                                    'rb').readlines())
+            obj.decode('UTF-8')
+        except errors.NoSuchFile:
+            obj = ConfigObj()
+        return obj
+
+    def get_option(self, name, section=None, default=None):
+        self.branch.lock_read()
+        try:
+            obj = self._get_config()
+            try:
+                if section is not None:
+                    obj[section]
+                result = obj[name]
+            except KeyError:
+                result = default
+        finally:
+            self.branch.unlock()
+        return result
+
+    def set_option(self, value, name, section=None):
+        """Set a per-branch configuration option"""
+        self.branch.lock_write()
+        try:
+            cfg_obj = self._get_config()
+            if section is None:
+                obj = cfg_obj
+            else:
+                try:
+                    obj = cfg_obj[section]
+                except KeyError:
+                    cfg_obj[section] = {}
+                    obj = cfg_obj[section]
+            obj[name] = value
+            cfg_obj.encode('UTF-8')
+            out_file = StringIO(''.join([l+'\n' for l in cfg_obj.write()]))
+            out_file.seek(0)
+            self.branch.put_controlfile('branch.conf', out_file, encode=False)
+        finally:
+            self.branch.unlock()

=== modified file 'bzrlib/conflicts.py'
--- bzrlib/conflicts.py	2005-10-17 23:13:00 +0000
+++ bzrlib/conflicts.py	2005-11-17 01:02:25 +0000
@@ -27,7 +27,7 @@
 
 import bzrlib.status
 from bzrlib.branch import Branch
-from bzrlib.errors import BzrCommandError
+from bzrlib.errors import BzrCommandError, NotConflicted
 from bzrlib.commands import register_command
 from bzrlib.workingtree import CONFLICT_SUFFIXES
 
@@ -43,6 +43,7 @@
 class cmd_resolve(bzrlib.commands.Command):
     """Mark a conflict as resolved.
     """
+    aliases = ['resolved']
     takes_args = ['file*']
     takes_options = ['all']
     def run(self, file_list=None, all=False):
@@ -71,3 +72,30 @@
                     print "%s does not exist" % filename
                 else:
                     print "%s is not conflicted" % filename
+
+def restore(filename):
+    """\
+    Restore a conflicted file to the state it was in before merging.
+    Only text restoration supported at present.
+    """
+    conflicted = False
+    try:
+        os.rename(filename + ".THIS", filename)
+        conflicted = True
+    except OSError, e:
+        if e.errno != errno.ENOENT:
+            raise
+    try:
+        os.unlink(filename + ".BASE")
+        conflicted = True
+    except OSError, e:
+        if e.errno != errno.ENOENT:
+            raise
+    try:
+        os.unlink(filename + ".OTHER")
+        conflicted = True
+    except OSError, e:
+        if e.errno != errno.ENOENT:
+            raise
+    if not conflicted:
+        raise NotConflicted(filename)

=== modified file 'bzrlib/delta.py'
--- bzrlib/delta.py	2005-10-13 21:58:18 +0000
+++ bzrlib/delta.py	2005-11-16 13:46:41 +0000
@@ -114,10 +114,15 @@
             print >>to_file, 'added:'
             show_list(self.added)
 
+        extra_modified = []
+
         if self.renamed:
             print >>to_file, 'renamed:'
             for (oldpath, newpath, fid, kind,
                  text_modified, meta_modified) in self.renamed:
+                if text_modified or meta_modified:
+                    extra_modified.append((newpath, fid, kind,
+                                           text_modified, meta_modified))
                 if meta_modified:
                     newpath += '*'
                 if show_ids:
@@ -125,9 +130,10 @@
                 else:
                     print >>to_file, '  %s => %s' % (oldpath, newpath)
                     
-        if self.modified:
+        if self.modified or extra_modified:
             print >>to_file, 'modified:'
             show_list(self.modified)
+            show_list(extra_modified)
             
         if show_unchanged and self.unchanged:
             print >>to_file, 'unchanged:'
@@ -219,7 +225,7 @@
 
     mutter('start looking for new files')
     for file_id in new_inv:
-        if file_id in old_inv:
+        if file_id in old_inv or file_id not in new_tree:
             continue
         kind = new_inv.get_file_kind(file_id)
         if kind == 'root_directory':

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2005-10-29 23:48:45 +0000
+++ bzrlib/diff.py	2005-11-11 17:46:11 +0000
@@ -22,7 +22,7 @@
 # invoke callbacks on an object.  That object can either accumulate a
 # list, write them out directly, etc etc.
 
-def internal_diff(old_label, oldlines, new_label, newlines, to_file):
+def internal_diff(old_filename, oldlines, new_filename, newlines, to_file):
     import difflib
     
     # FIXME: difflib is wrong if there is no trailing newline.
@@ -42,7 +42,8 @@
         return
 
     ud = difflib.unified_diff(oldlines, newlines,
-                              fromfile=old_label, tofile=new_label)
+                              fromfile=old_filename+'\t', 
+                              tofile=new_filename+'\t')
 
     ud = list(ud)
     # work-around for difflib being too smart for its own good
@@ -62,7 +63,7 @@
     print >>to_file
 
 
-def external_diff(old_label, oldlines, new_label, newlines, to_file,
+def external_diff(old_filename, oldlines, new_filename, newlines, to_file,
                   diff_opts):
     """Display a diff by calling out to the external diff program."""
     import sys
@@ -97,9 +98,9 @@
         if not diff_opts:
             diff_opts = []
         diffcmd = ['diff',
-                   '--label', old_label,
+                   '--label', old_filename+'\t',
                    oldtmpf.name,
-                   '--label', new_label,
+                   '--label', new_filename+'\t',
                    newtmpf.name]
 
         # diff only allows one style to be specified; they don't override.
@@ -141,7 +142,7 @@
         newtmpf.close()
 
 def show_diff(b, from_spec, specific_files, external_diff_options=None,
-              revision2=None, output=None):
+              revision2=None, output=None, b2=None):
     """Shortcut for showing the diff to the working tree.
 
     b
@@ -158,12 +159,18 @@
         output = sys.stdout
 
     if from_spec is None:
-        old_tree = b.basis_tree()
+        if b2 is None:
+            old_tree = b.basis_tree()
+        else:
+            old_tree = b.working_tree()
     else:
         old_tree = b.revision_tree(from_spec.in_history(b).rev_id)
 
     if revision2 is None:
-        new_tree = b.working_tree()
+        if b2 is None:
+            new_tree = b.working_tree()
+        else:
+            new_tree = b2.working_tree()
     else:
         new_tree = b.revision_tree(revision2.in_history(b).rev_id)
 

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2005-11-13 18:57:26 +0000
+++ bzrlib/errors.py	2005-11-19 22:56:37 +0000
@@ -46,6 +46,9 @@
 
  * the printable form of an exception is generated by the base class
    __str__ method
+
+Exception strings should start with a capital letter and not have a final
+fullstop.
 """
 
 # based on Scott James Remnant's hct error classes
@@ -157,6 +160,15 @@
         self.path = path
 
 
+class FileInWrongBranch(BzrNewError):
+    """File %(path)s in not in branch %(branch_base)s."""
+    def __init__(self, branch, path):
+        BzrNewError.__init__(self)
+        self.branch = branch
+        self.branch_base = branch.base
+        self.path = path
+
+
 class UnsupportedFormatError(BzrError):
     """Specified path is a bzr branch that we cannot read."""
     def __str__(self):
@@ -363,6 +375,24 @@
         TransportError.__init__(self, msg=msg, orig_error=orig_error)
         IOError.__init__(self, errno.ENOENT, self.msg)
 
+class ConnectionError(TransportError, IOError):
+    """
+    A connection problem prevents file retrieval.
+    This does not indicate whether the file exists or not; it indicates that a
+    precondition for requesting the file was not met.
+    """
+
+    # XXX: Is multiple inheritance for exceptions really needed?
+
+    def __str__(self):
+        return 'connection error: ' + self.msg
+
+    def __init__(self, msg=None, orig_error=None):
+        import errno
+        TransportError.__init__(self, msg=msg, orig_error=orig_error)
+        IOError.__init__(self, errno.ENOENT, self.msg)
+
+
 class FileExists(TransportError, OSError):
     """An operation was attempted, which would overwrite an entry,
     but overwritting is not supported.
@@ -416,9 +446,22 @@
         BzrNewError.__init__(self)
         self.graph = graph
 
+class NotConflicted(BzrNewError):
+    """File %(filename)s is not conflicted."""
+    def __init__(self, filename):
+        BzrNewError.__init__(self)
+        self.filename = filename
+
 class MustUseDecorated(Exception):
     """A decorating function has requested its original command be used.
     
     This should never escape bzr, so does not need to be printable.
     """
 
+class MissingText(BzrNewError):
+    """Branch %(base)s is missing revision %(text_revision)s of %(file_id)s"""
+    def __init__(self, branch, text_revision, file_id):
+        self.branch = branch
+        self.base = branch.base
+        self.text_revision = text_revision
+        self.file_id = file_id

=== modified file 'bzrlib/fetch.py'
--- bzrlib/fetch.py	2005-10-23 13:50:59 +0000
+++ bzrlib/fetch.py	2005-11-19 22:56:37 +0000
@@ -20,7 +20,8 @@
 
 import bzrlib
 import bzrlib.errors as errors
-from bzrlib.errors import InstallFailed, NoSuchRevision, WeaveError
+from bzrlib.errors import (InstallFailed, NoSuchRevision, WeaveError,
+                           MissingText)
 from bzrlib.trace import mutter, note, warning
 from bzrlib.branch import Branch
 from bzrlib.progress import ProgressBar
@@ -212,22 +213,19 @@
         # in memory until everything's done?  But this way is nicer
         # if it's interrupted.
         for path, ie in inv.iter_entries():
-            if ie.revision != rev_id:
-                continue
-            mutter('%s {%s} is changed in this revision',
-                   path, ie.file_id)
-            self._copy_one_weave(rev_id, ie.file_id)
+            self._copy_one_weave(rev_id, ie.file_id, ie.revision)
 
-    def _copy_one_weave(self, rev_id, file_id):
-        """Copy one file weave."""
-        mutter('copy file {%s} modified in {%s}', file_id, rev_id)
-        if file_id in self.copied_file_ids:
-            mutter('file {%s} already copied', file_id)
+    def _copy_one_weave(self, rev_id, file_id, text_revision):
+        """Copy one file weave, esuring the result contains text_revision."""
+        to_weave = self.to_weaves.get_weave_or_empty(file_id,
+            self.to_branch.get_transaction())
+        if text_revision in to_weave:
             return
         from_weave = self.from_weaves.get_weave(file_id,
             self.from_branch.get_transaction())
-        to_weave = self.to_weaves.get_weave_or_empty(file_id,
-            self.to_branch.get_transaction())
+        if text_revision not in from_weave:
+            raise MissingText(self.from_branch, text_revision, file_id)
+        mutter('copy file {%s} modified in {%s}', file_id, rev_id)
         try:
             to_weave.join(from_weave)
         except errors.WeaveParentMismatch:

=== modified file 'bzrlib/help.py'
--- bzrlib/help.py	2005-10-28 02:34:22 +0000
+++ bzrlib/help.py	2005-11-18 08:10:07 +0000
@@ -113,7 +113,7 @@
     outfile.write(doc)
     if doc[-1] != '\n':
         outfile.write('\n')
-    help_on_command_options(cmd_object, outfile=None)
+    help_on_command_options(cmd_object, outfile)
 
 
 def help_on_command_options(cmd, outfile=None):

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2005-11-17 21:55:55 +0000
+++ bzrlib/inventory.py	2005-11-23 07:18:42 +0000
@@ -648,7 +648,7 @@
 
     def _put_in_tar(self, item, tree):
         """See InventoryEntry._put_in_tar."""
-        iterm.type = tarfile.SYMTYPE
+        item.type = tarfile.SYMTYPE
         fileobj = None
         item.size = 0
         item.mode = 0755

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2005-11-11 00:10:50 +0000
+++ bzrlib/log.py	2005-11-17 07:45:38 +0000
@@ -342,52 +342,40 @@
     def show(self, revno, rev, delta):
         raise NotImplementedError('not implemented in abstract base')
 
+    def short_committer(self, rev):
+        return re.sub('<.*@.*>', '', rev.committer).strip(' ')
+    
     
 class LongLogFormatter(LogFormatter):
     def show(self, revno, rev, delta):
-        from osutils import format_date
-
-        to_file = self.to_file
-
-        print >>to_file,  '-' * 60
-        print >>to_file,  'revno:', revno
-        if self.show_ids:
-            print >>to_file,  'revision-id:', rev.revision_id
-
-            for parent_id in rev.parent_ids:
-                print >>to_file, 'parent:', parent_id
-            
-        print >>to_file,  'committer:', rev.committer
-
-        date_str = format_date(rev.timestamp,
-                               rev.timezone or 0,
-                               self.show_timezone)
-        print >>to_file,  'timestamp: %s' % date_str
-
-        print >>to_file,  'message:'
-        if not rev.message:
-            print >>to_file,  '  (no message)'
-        else:
-            for l in rev.message.split('\n'):
-                print >>to_file,  '  ' + l
-
-        if delta != None:
-            delta.show(to_file, self.show_ids)
+        return self._show_helper(revno=revno, rev=rev)
 
     def show_merge(self, rev):
+        return self._show_helper(rev=rev, indent='    ', merged=True)
+
+    def _show_helper(self, rev=None, revno=None, indent='', merged=False):
         from osutils import format_date
 
         to_file = self.to_file
 
-        indent = '    '
 
         print >>to_file,  indent+'-' * 60
-        print >>to_file,  indent+'merged:', rev.revision_id
+        if revno is not None:
+            print >>to_file,  'revno:', revno
+        if merged:
+            print >>to_file,  indent+'merged:', rev.revision_id
+        elif self.show_ids:
+            print >>to_file,  indent+'revision-id:', rev.revision_id
         if self.show_ids:
             for parent_id in rev.parent_ids:
                 print >>to_file, indent+'parent:', parent_id
             
         print >>to_file,  indent+'committer:', rev.committer
+        try:
+            print >>to_file, indent+'branch nick: %s' % \
+                rev.properties['branch-nick']
+        except KeyError:
+            pass
 
         date_str = format_date(rev.timestamp,
                                rev.timezone or 0,
@@ -409,9 +397,10 @@
         to_file = self.to_file
         date_str = format_date(rev.timestamp, rev.timezone or 0,
                             self.show_timezone)
-        print >>to_file, "%5d %s\t%s" % (revno, rev.committer,
+        print >>to_file, "%5d %s\t%s" % (revno, self.short_committer(rev),
                 format_date(rev.timestamp, rev.timezone or 0,
-                            self.show_timezone))
+                            self.show_timezone, date_fmt="%Y-%m-%d",
+                           show_offset=False))
         if self.show_ids:
             print >>to_file,  '      revision-id:', rev.revision_id
         if not rev.message:
@@ -444,9 +433,6 @@
         else:
             return rev.message
 
-    def short_committer(self, rev):
-        return re.sub('<.*@.*>', '', rev.committer).strip(' ')
-    
     def show(self, revno, rev, delta):
         print >> self.to_file, self.log_string(rev, 79) 
 

=== removed file 'bzrlib/mdiff.py'
--- bzrlib/mdiff.py	2005-09-26 08:56:15 +0000
+++ bzrlib/mdiff.py	1970-01-01 00:00:00 +0000
@@ -1,166 +0,0 @@
-# (C) 2005 Matt Mackall
-# (C) 2005 Canonical Ltd
-
-# based on code by Matt Mackall, hacked by Martin Pool
-
-# mm's code works line-by-line; this just works on byte strings.
-# Possibly slower; possibly gives better results for code not
-# regularly separated by newlines and anyhow a bit simpler.
-
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-# TODO: maybe work on files not strings?
-
-# FIXME: doesn't work properly on files without trailing newlines
-
-import difflib
-import struct
-import sys
-import unittest
-from cStringIO import StringIO
-
-
-def linesplit(a):
-    """Split into two lists: content and line positions.
-
-    This returns (al, ap).
-
-    al[i] is the string content of line i of the file, including its
-    newline (if any).
-
-    ap[i] is the byte position in the file where that line starts.
-
-    ap[-1] is the byte position of the end of the file (i.e. the
-    length of the file.)
-
-    This transformation allows us to do a line-based diff and then map
-    back to byte positions.
-    """
-
-    al, ap = [], []
-    last = 0
-
-    n = a.find("\n") + 1
-    while n > 0:
-        ap.append(last)
-        al.append(a[last:n])
-        last = n
-        n = a.find("\n", n) + 1
-
-    if last < len(a):
-        al.append(a[last:])
-        ap.append(last)
-
-    # position at the end
-    ap.append(len(a))
-
-    return (al, ap)
-
-
-def diff(a, b):
-    # TODO: Use different splits, perhaps rsync-like, for binary files?
-    
-    (al, ap) = linesplit(a)
-    (bl, bp) = linesplit(b)
-
-    d = difflib.SequenceMatcher(None, al, bl)
-    
-    ## sys.stderr.write('  ~ real_quick_ratio: %.4f\n' % d.real_quick_ratio())
-    
-    for o, m, n, s, t in d.get_opcodes():
-        if o == 'equal': continue
-        # a[m:n] should be replaced by b[s:t]
-        if s == t:
-            yield ap[m], ap[n], ''
-        else:
-            yield ap[m], ap[n], ''.join(bl[s:t])
-
-
-def tobinary(ops):
-    b = StringIO()
-    for f in ops:
-        b.write(struct.pack(">III", f[0], f[1], len(f[2])))
-        b.write(f[2])
-    return b.getvalue()
-
-
-def bdiff(a, b):
-    return tobinary(diff(a, b))
-
-
-def patch(t, ops):
-    last = 0
-    b = StringIO()
-
-    for m, n, r in ops:
-        b.write(t[last:m])
-        if r:
-            b.write(r)
-        last = n
-        
-    b.write(t[last:])
-    return b.getvalue()
-
-
-def frombinary(b):
-    bin = StringIO(b)
-    while True:
-        p = bin.read(12)
-        if not p:
-            break
-
-        m, n, l = struct.unpack(">III", p)
-        
-        if l == 0:
-            r = ''
-        else:
-            r = bin.read(l)
-            if len(r) != l:
-                raise Exception("truncated patch data")
-            
-        yield m, n, r
-
-
-def bpatch(t, b):
-    return patch(t, frombinary(b))
-
-
-
-
-class TestDiffPatch(unittest.TestCase):
-    def doDiffPatch(self, old, new):
-        diff = bdiff(old, new)
-        result = bpatch(old, diff)
-        self.assertEquals(new, result)
-
-
-    def testSimpleDiff(self):
-        """Simply add a line at the end"""
-        self.doDiffPatch('a\nb\n', 'a\nb\nc\n')
-        
-
-        
-    def testTrailingLine(self):
-        """Test diff that adds an unterminated line.
-
-        (Old versions didn't do this properly.)"""
-        self.doDiffPatch('a\nb\nc\n',
-                         'a\nb\nc\nd')
-
-
-if __name__ == '__main__':
-    unittest.main()

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2005-11-17 22:43:42 +0000
+++ bzrlib/merge.py	2005-11-23 07:18:42 +0000
@@ -33,7 +33,8 @@
                            NoCommits,
                            WorkingTreeNotRevision,
                            NotBranchError,
-                           NotVersionedError)
+                           NotVersionedError,
+                           BzrError)
 from bzrlib.delta import compare_trees
 from bzrlib.trace import mutter, warning, note
 from bzrlib.fetch import greedy_fetch, fetch
@@ -148,7 +149,7 @@
         Handle weave conflicts by producing a .THIS, and .OTHER.  The
         main file will be a version with diff3-style conflicts.
         """
-        self.add_suffix(filename, ".THIS")
+        self.add_suffix(filename, ".THIS", fix_inventory=False)
         out_file.commit()
         self.dump(weave.get_iter(other_i), filename+".OTHER")
         self.conflict("Text conflict encountered in %s" % filename)
@@ -273,8 +274,9 @@
     transform_tree(this_branch.working_tree(), this_branch.basis_tree())
 
 
-def transform_tree(from_tree, to_tree):
-    merge_inner(from_tree.branch, to_tree, from_tree, ignore_zero=True)
+def transform_tree(from_tree, to_tree, interesting_ids=None):
+    merge_inner(from_tree.branch, to_tree, from_tree, ignore_zero=True,
+                interesting_ids=interesting_ids)
 
 
 def merge(other_revision, base_revision,
@@ -322,6 +324,9 @@
     merger.check_basis(check_clean)
     merger.set_other(other_revision)
     merger.set_base(base_revision)
+    if merger.base_rev_id == merger.other_rev_id:
+        note('Nothing to do.')
+        return 0
     merger.backup_files = backup_files
     merger.merge_type = merge_type 
     merger.set_interesting_files(file_list)
@@ -336,8 +341,12 @@
     return conflicts
 
 def merge_inner(this_branch, other_tree, base_tree, ignore_zero=False,
-                backup_files=False, merge_type=ApplyMerge3, 
-                interesting_ids=None, show_base=False, reprocess=False,
+                backup_files=False, 
+                merge_type=ApplyMerge3, 
+                interesting_ids=None, 
+                show_base=False, 
+                reprocess=False, 
+                other_rev_id=None,
                 interesting_files=None):
     """Primary interface for merging. 
 
@@ -358,6 +367,8 @@
     merger.conflict_handler = MergeConflictHandler(merger.this_tree, base_tree, 
                                                    other_tree,
                                                    ignore_zero=ignore_zero)
+    merger.other_rev_id = other_rev_id
+    merger.other_basis = other_rev_id
     return merger.do_merge()
 
 
@@ -369,6 +380,7 @@
         self.this_rev_id = None
         self.this_tree = this_branch.working_tree()
         self.this_revision_tree = None
+        self.this_basis_tree = None
         self.other_tree = other_tree
         self.base_tree = base_tree
         self.ignore_zero = False
@@ -384,12 +396,11 @@
 
     def ensure_revision_trees(self):
         if self.this_revision_tree is None:
-            if self.this_rev_id is None:
-                self.compare_basis()
-            if self.this_rev_id is None:
-                raise WorkingTreeNotRevision(self.this_tree)
-            self.this_revision_tree = self.this_branch.revision_tree(
-                self.this_rev_id)
+            self.this_basis_tree = self.this_branch.revision_tree(
+                self.this_basis)
+            if self.this_basis == self.this_rev_id:
+                self.this_revision_tree = self.this_basis_tree
+
 
         if self.other_rev_id is None:
             other_basis_tree = self.revision_tree(self.other_basis)
@@ -406,14 +417,24 @@
             revision_id = tree.inventory[file_id].revision
             assert revision_id is not None
             return revision_id
-        trees = (self.this_revision_tree, self.other_tree)
+        if self.this_rev_id is None:
+            if self.this_basis_tree.get_file_sha1(file_id) != \
+                self.this_tree.get_file_sha1(file_id):
+                raise WorkingTreeNotRevision(self.this_tree)
+
+        trees = (self.this_basis_tree, self.other_tree)
         return [get_id(tree, file_id) for tree in trees]
             
 
     def merge_factory(self, file_id, base, other):
         if self.merge_type.history_based:
+            if self.show_base is True:
+                raise BzrError("Cannot show base for hisory-based merges")
+            if self.reprocess is True:
+                raise BzrError("Cannot reprocess history-based merges")
+                
             t_revid, o_revid = self.file_revisions(file_id)
-            weave = self.this_revision_tree.get_weave(file_id)
+            weave = self.this_basis_tree.get_weave(file_id)
             contents_change = self.merge_type(weave, t_revid, o_revid)
         else:
             if self.show_base is True or self.reprocess is True:
@@ -522,7 +543,7 @@
     def do_merge(self):
         def get_inventory(tree):
             return tree.inventory
-
+        
         inv_changes = merge_flex(self.this_tree, self.base_tree, 
                                  self.other_tree,
                                  generate_changeset, get_inventory,

=== modified file 'bzrlib/missing.py'
--- bzrlib/missing.py	2005-09-29 12:49:59 +0000
+++ bzrlib/missing.py	2005-11-12 15:33:37 +0000
@@ -60,7 +60,7 @@
     for revno, rev_id in missing_remote:
         rev = br_remote.get_revision(rev_id)
         if verbose:
-            parent_rev_id = rev.parents[0].revision_id
+            parent_rev_id = rev.parent_ids[0]
             if last_rev_id == parent_rev_id:
                 parent_tree = last_tree
             else:

=== modified file 'bzrlib/option.py'
--- bzrlib/option.py	2005-10-28 02:34:22 +0000
+++ bzrlib/option.py	2005-11-21 08:51:56 +0000
@@ -200,6 +200,7 @@
 _global_option('remember', help='Remember the specified location as a'
                ' default.')
 _global_option('reprocess', help='Reprocess to reduce spurious conflicts')
+_global_option('kind', type=str)
 
 
 def _global_short(short_name, long_name):

=== modified file 'bzrlib/plugin.py'
--- bzrlib/plugin.py	2005-11-10 03:03:53 +0000
+++ bzrlib/plugin.py	2005-11-21 09:07:18 +0000
@@ -79,7 +79,7 @@
         #raise BzrError("plugins already initialized")
     _loaded = True
 
-    dirs = os.environ.get('BZR_PLUGIN_PATH', DEFAULT_PLUGIN_PATH).split(":")
+    dirs = os.environ.get('BZR_PLUGIN_PATH', DEFAULT_PLUGIN_PATH).split(os.pathsep)
     dirs.insert(0, os.path.dirname(plugins.__file__))
 
     # The problem with imp.get_suffixes() is that it doesn't include

=== removed file 'bzrlib/revfile.py'
--- bzrlib/revfile.py	2005-11-04 14:37:48 +0000
+++ bzrlib/revfile.py	1970-01-01 00:00:00 +0000
@@ -1,582 +0,0 @@
-#! /usr/bin/env python
-
-# (C) 2005 Canonical Ltd
-
-# based on an idea by Matt Mackall
-# modified to squish into bzr by Martin Pool
-
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-
-"""Packed file revision storage.
-
-A Revfile holds the text history of a particular source file, such
-as Makefile.  It can represent a tree of text versions for that
-file, allowing for microbranches within a single repository.
-
-This is stored on disk as two files: an index file, and a data file.
-The index file is short and always read completely into memory; the
-data file is much longer and only the relevant bits of it,
-identified by the index file, need to be read.
-
-Each text version is identified by the SHA-1 of the full text of
-that version.  It also has a sequence number within the file.
-
-The index file has a short header and then a sequence of fixed-length
-records:
-
-* byte[20]    SHA-1 of text (as binary, not hex)
-* uint32      sequence number this is based on, or -1 for full text
-* uint32      flags: 1=zlib compressed
-* uint32      offset in text file of start
-* uint32      length of compressed delta in text file
-* uint32[3]   reserved
-
-total 48 bytes.
-
-The header is also 48 bytes for tidyness and easy calculation.
-
-Both the index and the text are only ever appended to; a consequence
-is that sequence numbers are stable references.  But not every
-repository in the world will assign the same sequence numbers,
-therefore the SHA-1 is the only universally unique reference.
-
-This is meant to scale to hold 100,000 revisions of a single file, by
-which time the index file will be ~4.8MB and a bit big to read
-sequentially.
-
-Some of the reserved fields could be used to implement a (semi?)
-balanced tree indexed by SHA1 so we can much more efficiently find the
-index associated with a particular hash.  For 100,000 revs we would be
-able to find it in about 17 random reads, which is not too bad.
-
-This performs pretty well except when trying to calculate deltas of
-really large files.  For that the main thing would be to plug in
-something faster than difflib, which is after all pure Python.
-Another approach is to just store the gzipped full text of big files,
-though perhaps that's too perverse?
-
-The iter method here will generally read through the whole index file
-in one go.  With readahead in the kernel and python/libc (typically
-128kB) this means that there should be no seeks and often only one
-read() call to get everything into memory.
-"""
- 
-
-# TODO: Something like pread() would make this slightly simpler and
-# perhaps more efficient.
-
-# TODO: Could also try to mmap things...  Might be faster for the
-# index in particular?
-
-# TODO: Some kind of faster lookup of SHAs?  The bad thing is that probably means
-# rewriting existing records, which is not so nice.
-
-# TODO: Something to check that regions identified in the index file
-# completely butt up and do not overlap.  Strictly it's not a problem
-# if there are gaps and that can happen if we're interrupted while
-# writing to the datafile.  Overlapping would be very bad though.
-
-# TODO: Shouldn't need to lock if we always write in append mode and
-# then ftell after writing to see where it went.  In any case we
-# assume the whole branch is protected by a lock.
-
-import os
-import sha
-import stat
-import struct
-import sys
-import zlib
-from binascii import hexlify, unhexlify
-
-import bzrlib.mdiff as mdiff
-
-
-_RECORDSIZE = 48
-
-_HEADER = "bzr revfile v1\n"
-_HEADER = _HEADER + ('\xff' * (_RECORDSIZE - len(_HEADER)))
-_NO_RECORD = 0xFFFFFFFFL
-
-# fields in the index record
-I_SHA = 0
-I_BASE = 1
-I_FLAGS = 2
-I_OFFSET = 3
-I_LEN = 4
-
-FL_GZIP = 1
-
-# maximum number of patches in a row before recording a whole text.
-CHAIN_LIMIT = 10
-
-
-class RevfileError(Exception):
-    pass
-
-class LimitHitException(Exception):
-    pass
-
-class Revfile(object):
-    def __init__(self, basename, mode):
-        # TODO: Lock file  while open
-
-        # TODO: advise of random access
-
-        self.basename = basename
-
-        if mode not in ['r', 'w']:
-            raise RevfileError("invalid open mode %r" % mode)
-        self.mode = mode
-        
-        idxname = basename + '.irev'
-        dataname = basename + '.drev'
-
-        idx_exists = os.path.exists(idxname)
-        data_exists = os.path.exists(dataname)
-
-        if idx_exists != data_exists:
-            raise RevfileError("half-assed revfile")
-        
-        if not idx_exists:
-            if mode == 'r':
-                raise RevfileError("Revfile %r does not exist" % basename)
-            
-            self.idxfile = open(idxname, 'w+b')
-            self.datafile = open(dataname, 'w+b')
-            
-            self.idxfile.write(_HEADER)
-            self.idxfile.flush()
-        else:
-            if mode == 'r':
-                diskmode = 'rb'
-            else:
-                diskmode = 'r+b'
-                
-            self.idxfile = open(idxname, diskmode)
-            self.datafile = open(dataname, diskmode)
-            
-            h = self.idxfile.read(_RECORDSIZE)
-            if h != _HEADER:
-                raise RevfileError("bad header %r in index of %r"
-                                   % (h, self.basename))
-
-
-    def _check_index(self, idx):
-        if idx < 0 or idx > len(self):
-            raise RevfileError("invalid index %r" % idx)
-
-    def _check_write(self):
-        if self.mode != 'w':
-            raise RevfileError("%r is open readonly" % self.basename)
-
-
-    def find_sha(self, s):
-        assert isinstance(s, str)
-        assert len(s) == 20
-        
-        for idx, idxrec in enumerate(self):
-            if idxrec[I_SHA] == s:
-                return idx
-        else:
-            return _NO_RECORD
-
-
-
-    def _add_compressed(self, text_sha, data, base, compress):
-        # well, maybe compress
-        flags = 0
-        if compress:
-            data_len = len(data)
-            if data_len > 50:
-                # don't do compression if it's too small; it's unlikely to win
-                # enough to be worthwhile
-                compr_data = zlib.compress(data)
-                compr_len = len(compr_data)
-                if compr_len < data_len:
-                    data = compr_data
-                    flags = FL_GZIP
-                    ##print '- compressed %d -> %d, %.1f%%' \
-                    ##      % (data_len, compr_len, float(compr_len)/float(data_len) * 100.0)
-        return self._add_raw(text_sha, data, base, flags)
-        
-
-
-    def _add_raw(self, text_sha, data, base, flags):
-        """Add pre-processed data, can be either full text or delta.
-
-        This does the compression if that makes sense."""
-        idx = len(self)
-        self.datafile.seek(0, 2)        # to end
-        self.idxfile.seek(0, 2)
-        assert self.idxfile.tell() == _RECORDSIZE * (idx + 1)
-        data_offset = self.datafile.tell()
-
-        assert isinstance(data, str) # not unicode or anything weird
-
-        self.datafile.write(data)
-        self.datafile.flush()
-
-        assert isinstance(text_sha, str)
-        entry = text_sha
-        entry += struct.pack(">IIII12x", base, flags, data_offset, len(data))
-        assert len(entry) == _RECORDSIZE
-
-        self.idxfile.write(entry)
-        self.idxfile.flush()
-
-        return idx
-        
-
-
-    def _add_full_text(self, text, text_sha, compress):
-        """Add a full text to the file.
-
-        This is not compressed against any reference version.
-
-        Returns the index for that text."""
-        return self._add_compressed(text_sha, text, _NO_RECORD, compress)
-
-
-    # NOT USED
-    def _choose_base(self, seed, base):
-        while seed & 3 == 3:
-            if base == _NO_RECORD:
-                return _NO_RECORD
-            idxrec = self[base]
-            if idxrec[I_BASE] == _NO_RECORD:
-                return base
-
-            base = idxrec[I_BASE]
-            seed >>= 2
-                
-        return base        # relative to this full text
-        
-
-
-    def _add_delta(self, text, text_sha, base, compress):
-        """Add a text stored relative to a previous text."""
-        self._check_index(base)
-
-        try:
-            base_text = self.get(base, CHAIN_LIMIT)
-        except LimitHitException:
-            return self._add_full_text(text, text_sha, compress)
-        
-        data = mdiff.bdiff(base_text, text)
-
-
-        if True: # paranoid early check for bad diff
-            result = mdiff.bpatch(base_text, data)
-            assert result == text
-            
-        
-        # If the delta is larger than the text, we might as well just
-        # store the text.  (OK, the delta might be more compressible,
-        # but the overhead of applying it probably still makes it
-        # bad, and I don't want to compress both of them to find out.)
-        if len(data) >= len(text):
-            return self._add_full_text(text, text_sha, compress)
-        else:
-            return self._add_compressed(text_sha, data, base, compress)
-
-
-    def add(self, text, base=None, compress=True):
-        """Add a new text to the revfile.
-
-        If the text is already present them its existing id is
-        returned and the file is not changed.
-
-        If compress is true then gzip compression will be used if it
-        reduces the size.
-
-        If a base index is specified, that text *may* be used for
-        delta compression of the new text.  Delta compression will
-        only be used if it would be a size win and if the existing
-        base is not at too long of a delta chain already.
-        """
-        if base == None:
-            base = _NO_RECORD
-        
-        self._check_write()
-        
-        text_sha = sha.new(text).digest()
-
-        idx = self.find_sha(text_sha)
-        if idx != _NO_RECORD:
-            # TODO: Optional paranoid mode where we read out that record and make sure
-            # it's the same, in case someone ever breaks SHA-1.
-            return idx                  # already present
-        
-        # base = self._choose_base(ord(text_sha[0]), base)
-
-        if base == _NO_RECORD:
-            return self._add_full_text(text, text_sha, compress)
-        else:
-            return self._add_delta(text, text_sha, base, compress)
-
-
-
-    def get(self, idx, recursion_limit=None):
-        """Retrieve text of a previous revision.
-
-        If recursion_limit is an integer then walk back at most that
-        many revisions and then raise LimitHitException, indicating
-        that we ought to record a new file text instead of another
-        delta.  Don't use this when trying to get out an existing
-        revision."""
-        
-        idxrec = self[idx]
-        base = idxrec[I_BASE]
-        if base == _NO_RECORD:
-            text = self._get_full_text(idx, idxrec)
-        else:
-            text = self._get_patched(idx, idxrec, recursion_limit)
-
-        if sha.new(text).digest() != idxrec[I_SHA]:
-            raise RevfileError("corrupt SHA-1 digest on record %d in %s"
-                               % (idx, self.basename))
-
-        return text
-
-
-
-    def _get_raw(self, idx, idxrec):
-        flags = idxrec[I_FLAGS]
-        if flags & ~FL_GZIP:
-            raise RevfileError("unsupported index flags %#x on index %d"
-                               % (flags, idx))
-        
-        l = idxrec[I_LEN]
-        if l == 0:
-            return ''
-
-        self.datafile.seek(idxrec[I_OFFSET])
-
-        data = self.datafile.read(l)
-        if len(data) != l:
-            raise RevfileError("short read %d of %d "
-                               "getting text for record %d in %r"
-                               % (len(data), l, idx, self.basename))
-
-        if flags & FL_GZIP:
-            data = zlib.decompress(data)
-
-        return data
-        
-
-    def _get_full_text(self, idx, idxrec):
-        assert idxrec[I_BASE] == _NO_RECORD
-
-        text = self._get_raw(idx, idxrec)
-
-        return text
-
-
-    def _get_patched(self, idx, idxrec, recursion_limit):
-        base = idxrec[I_BASE]
-        assert base >= 0
-        assert base < idx    # no loops!
-
-        if recursion_limit == None:
-            sub_limit = None
-        else:
-            sub_limit = recursion_limit - 1
-            if sub_limit < 0:
-                raise LimitHitException()
-            
-        base_text = self.get(base, sub_limit)
-        patch = self._get_raw(idx, idxrec)
-
-        text = mdiff.bpatch(base_text, patch)
-
-        return text
-
-
-
-    def __len__(self):
-        """Return number of revisions."""
-        l = os.fstat(self.idxfile.fileno())[stat.ST_SIZE]
-        if l % _RECORDSIZE:
-            raise RevfileError("bad length %d on index of %r" % (l, self.basename))
-        if l < _RECORDSIZE:
-            raise RevfileError("no header present in index of %r" % (self.basename))
-        return int(l / _RECORDSIZE) - 1
-
-
-    def __getitem__(self, idx):
-        """Index by sequence id returns the index field"""
-        ## TODO: Can avoid seek if we just moved there...
-        self._seek_index(idx)
-        idxrec = self._read_next_index()
-        if idxrec == None:
-            raise IndexError("no index %d" % idx)
-        else:
-            return idxrec
-
-
-    def _seek_index(self, idx):
-        if idx < 0:
-            raise RevfileError("invalid index %r" % idx)
-        self.idxfile.seek((idx + 1) * _RECORDSIZE)
-
-
-
-    def __iter__(self):
-        """Read back all index records.
-
-        Do not seek the index file while this is underway!"""
-        ## sys.stderr.write(" ** iter called ** \n")
-        self._seek_index(0)
-        while True:
-            idxrec = self._read_next_index()
-            if not idxrec:
-                break
-            yield idxrec
-        
-
-    def _read_next_index(self):
-        rec = self.idxfile.read(_RECORDSIZE)
-        if not rec:
-            return None
-        elif len(rec) != _RECORDSIZE:
-            raise RevfileError("short read of %d bytes getting index %d from %r"
-                               % (len(rec), idx, self.basename))
-        
-        return struct.unpack(">20sIIII12x", rec)
-
-        
-    def dump(self, f=sys.stdout):
-        f.write('%-8s %-40s %-8s %-8s %-8s %-8s\n' 
-                % tuple('idx sha1 base flags offset len'.split()))
-        f.write('-------- ---------------------------------------- ')
-        f.write('-------- -------- -------- --------\n')
-
-        for i, rec in enumerate(self):
-            f.write("#%-7d %40s " % (i, hexlify(rec[0])))
-            if rec[1] == _NO_RECORD:
-                f.write("(none)   ")
-            else:
-                f.write("#%-7d " % rec[1])
-                
-            f.write("%8x %8d %8d\n" % (rec[2], rec[3], rec[4]))
-
-
-    def total_text_size(self):
-        """Return the sum of sizes of all file texts.
-
-        This is how much space they would occupy if they were stored without
-        delta and gzip compression.
-
-        As a side effect this completely validates the Revfile, checking that all
-        texts can be reproduced with the correct SHA-1."""
-        t = 0L
-        for idx in range(len(self)):
-            t += len(self.get(idx))
-        return t
-
-
-    def check(self, pb=None):
-        """Extract every version and check its hash."""
-        total = len(self)
-        for i in range(total):
-            if pb:
-                pb.update("check revision", i, total)
-            # the get method implicitly checks the SHA-1
-            self.get(i)
-        if pb:
-            pb.clear()
-        
-
-
-def main(argv):
-    try:
-        cmd = argv[1]
-        filename = argv[2]
-    except IndexError:
-        sys.stderr.write("usage: revfile dump REVFILE\n"
-                         "       revfile add REVFILE < INPUT\n"
-                         "       revfile add-delta REVFILE BASE < INPUT\n"
-                         "       revfile add-series REVFILE BASE FILE...\n"
-                         "       revfile get REVFILE IDX\n"
-                         "       revfile find-sha REVFILE HEX\n"
-                         "       revfile total-text-size REVFILE\n"
-                         "       revfile last REVFILE\n")
-        return 1
-
-    if filename.endswith('.drev') or filename.endswith('.irev'):
-        filename = filename[:-5]
-
-    def rw():
-        return Revfile(filename, 'w')
-
-    def ro():
-        return Revfile(filename, 'r')
-
-    if cmd == 'add':
-        print rw().add(sys.stdin.read())
-    elif cmd == 'add-delta':
-        print rw().add(sys.stdin.read(), int(argv[3]))
-    elif cmd == 'add-series':
-        r = rw()
-        rev = int(argv[3])
-        for fn in argv[4:]:
-            print rev
-            rev = r.add(file(fn).read(), rev)
-    elif cmd == 'dump':
-        ro().dump()
-    elif cmd == 'get':
-        try:
-            idx = int(argv[3])
-        except IndexError:
-            sys.stderr.write("usage: revfile get FILE IDX\n")
-            return 1
-
-        r = ro()
-
-        if idx < 0 or idx >= len(r):
-            sys.stderr.write("invalid index %r\n" % idx)
-            return 1
-
-        sys.stdout.write(r.get(idx))
-    elif cmd == 'find-sha':
-        try:
-            s = unhexlify(argv[3])
-        except IndexError:
-            sys.stderr.write("usage: revfile find-sha FILE HEX\n")
-            return 1
-
-        idx = ro().find_sha(s)
-        if idx == _NO_RECORD:
-            sys.stderr.write("no such record\n")
-            return 1
-        else:
-            print idx
-    elif cmd == 'total-text-size':
-        print ro().total_text_size()
-    elif cmd == 'last':
-        print len(ro())-1
-    elif cmd == 'check':
-        import bzrlib.progress
-        pb = bzrlib.progress.ProgressBar()
-        ro().check(pb)
-    else:
-        sys.stderr.write("unknown command %r\n" % cmd)
-        return 1
-    
-
-if __name__ == '__main__':
-    import sys
-    sys.exit(main(sys.argv) or 0)

=== modified file 'bzrlib/selftest/HTTPTestUtil.py'
--- bzrlib/selftest/HTTPTestUtil.py	2005-10-24 02:20:02 +0000
+++ bzrlib/selftest/HTTPTestUtil.py	2005-10-28 19:38:52 +0000
@@ -44,7 +44,7 @@
             try:
                 self.raw_requestline = self.rfile.readline()
             except socket.error, e:
-                if e.args[0] == errno.EAGAIN:
+                if e.args[0] in (errno.EAGAIN, errno.EWOULDBLOCK):
                     # omitted for now because some tests look at the log of
                     # the server and expect to see no errors.  see recent
                     # email thread. -- mbp 20051021. 

=== modified file 'bzrlib/selftest/__init__.py'
--- bzrlib/selftest/__init__.py	2005-11-01 12:33:26 +0000
+++ bzrlib/selftest/__init__.py	2005-11-21 09:07:18 +0000
@@ -27,18 +27,19 @@
 import unittest
 import time
 
+from logging import debug, warning, error
+
 import bzrlib.commands
 import bzrlib.trace
-import bzrlib.fetch
 import bzrlib.osutils as osutils
 from bzrlib.selftest import TestUtil
 from bzrlib.selftest.TestUtil import TestLoader, TestSuite
 from bzrlib.selftest.treeshape import build_tree_contents
+from bzrlib.errors import BzrError
 
 MODULES_TO_TEST = []
 MODULES_TO_DOCTEST = []
 
-from logging import debug, warning, error
 
 
 class EarlyStoppingTestResultAdapter(object):
@@ -222,12 +223,7 @@
         """
         fileno, name = tempfile.mkstemp(suffix='.log', prefix='testbzr')
         self._log_file = os.fdopen(fileno, 'w+')
-        hdlr = logging.StreamHandler(self._log_file)
-        hdlr.setLevel(logging.DEBUG)
-        hdlr.setFormatter(logging.Formatter('%(levelname)8s  %(message)s'))
-        logging.getLogger('').addHandler(hdlr)
-        logging.getLogger('').setLevel(logging.DEBUG)
-        self._log_hdlr = hdlr
+        bzrlib.trace.enable_test_log(self._log_file)
         debug('opened log file %s', name)
         self._log_file_name = name
         self.addCleanup(self._finishLogFile)
@@ -237,6 +233,7 @@
 
         Read contents into memory, close, and delete.
         """
+        bzrlib.trace.disable_test_log()
         self._log_file.seek(0)
         self._log_contents = self._log_file.read()
         self._log_file.close()
@@ -255,31 +252,40 @@
         self._cleanups.append(callable)
 
     def _cleanEnvironment(self):
-        self.oldenv = os.environ.get('HOME', None)
-        os.environ['HOME'] = os.getcwd()
-        self.bzr_email = os.environ.get('BZREMAIL')
-        if self.bzr_email is not None:
-            del os.environ['BZREMAIL']
-        self.email = os.environ.get('EMAIL')
-        if self.email is not None:
-            del os.environ['EMAIL']
+        new_env = {
+            'HOME': os.getcwd(),
+            'APPDATA': os.getcwd(),
+            'BZREMAIL': None,
+            'EMAIL': None,
+        }
+        self.__old_env = {}
         self.addCleanup(self._restoreEnvironment)
+        for name, value in new_env.iteritems():
+            self._captureVar(name, value)
+
+
+    def _captureVar(self, name, newvalue):
+        """Set an environment variable, preparing it to be reset when finished."""
+        self.__old_env[name] = os.environ.get(name, None)
+        if newvalue is None:
+            if name in os.environ:
+                del os.environ[name]
+        else:
+            os.environ[name] = newvalue
+
+    @staticmethod
+    def _restoreVar(name, value):
+        if value is None:
+            if name in os.environ:
+                del os.environ[name]
+        else:
+            os.environ[name] = value
 
     def _restoreEnvironment(self):
-        os.environ['HOME'] = self.oldenv
-        if os.environ.get('BZREMAIL') is not None:
-            del os.environ['BZREMAIL']
-        if self.bzr_email is not None:
-            os.environ['BZREMAIL'] = self.bzr_email
-        if os.environ.get('EMAIL') is not None:
-            del os.environ['EMAIL']
-        if self.email is not None:
-            os.environ['EMAIL'] = self.email
+        for name, value in self.__old_env.iteritems():
+            self._restoreVar(name, value)
 
     def tearDown(self):
-        logging.getLogger('').removeHandler(self._log_hdlr)
-        bzrlib.trace.enable_default_logging()
-        logging.debug('%s teardown', self.id())
         self._runCleanups()
         unittest.TestCase.tearDown(self)
 
@@ -478,13 +484,17 @@
             os.chdir(_currentdir)
         self.addCleanup(_leaveDirectory)
         
-    def build_tree(self, shape):
+    def build_tree(self, shape, line_endings='native'):
         """Build a test tree according to a pattern.
 
         shape is a sequence of file specifications.  If the final
         character is '/', a directory is created.
 
         This doesn't add anything to a branch.
+        :param line_endings: Either 'binary' or 'native'
+                             in binary mode, exact contents are written
+                             in native mode, the line endings match the
+                             default platform endings.
         """
         # XXX: It's OK to just create them using forward slashes on windows?
         for name in shape:
@@ -492,7 +502,12 @@
             if name[-1] == '/':
                 os.mkdir(name[:-1])
             else:
-                f = file(name, 'wt')
+                if line_endings == 'binary':
+                    f = file(name, 'wb')
+                elif line_endings == 'native':
+                    f = file(name, 'wt')
+                else:
+                    raise BzrError('Invalid line ending request %r' % (line_endings,))
                 print >>f, "contents of", name
                 f.close()
 
@@ -512,9 +527,8 @@
 class MetaTestLog(TestCase):
     def test_logging(self):
         """Test logs are captured when a test fails."""
-        logging.info('an info message')
-        warning('something looks dodgy...')
-        logging.debug('hello, test is running')
+        self.log('a test message')
+        self.assertContainsRe(self._get_log(), 'a test message\n')
 
 
 def filter_suite_by_re(suite, pattern):
@@ -527,7 +541,7 @@
 
 
 def run_suite(suite, name='test', verbose=False, pattern=".*",
-              stop_on_failure=False):
+              stop_on_failure=False, keep_output=False):
     TestCaseInTempDir._TEST_NAME = name
     if verbose:
         verbosity = 2
@@ -543,7 +557,7 @@
     # This is still a little bogus, 
     # but only a little. Folk not using our testrunner will
     # have to delete their temp directories themselves.
-    if result.wasSuccessful():
+    if result.wasSuccessful() or not keep_output:
         if TestCaseInTempDir.TEST_ROOT is not None:
             shutil.rmtree(TestCaseInTempDir.TEST_ROOT) 
     else:
@@ -551,10 +565,11 @@
     return result.wasSuccessful()
 
 
-def selftest(verbose=False, pattern=".*", stop_on_failure=True):
+def selftest(verbose=False, pattern=".*", stop_on_failure=True,
+             keep_output=False):
     """Run the whole test suite under the enhanced runner"""
     return run_suite(test_suite(), 'testbzr', verbose=verbose, pattern=pattern,
-                     stop_on_failure=stop_on_failure)
+                     stop_on_failure=stop_on_failure, keep_output=keep_output)
 
 
 def test_suite():
@@ -565,6 +580,9 @@
 
     global MODULES_TO_TEST, MODULES_TO_DOCTEST
 
+    # FIXME: If these fail to load, e.g. because of a syntax error, the
+    # exception is hidden by unittest.  Sucks.  Should either fix that or
+    # perhaps import them and pass them to unittest as modules.
     testmod_names = \
                   ['bzrlib.selftest.MetaTestLog',
                    'bzrlib.selftest.testapi',
@@ -613,6 +631,7 @@
                    'bzrlib.selftest.testnonascii',
                    'bzrlib.selftest.testreweave',
                    'bzrlib.selftest.testtsort',
+                   'bzrlib.selftest.testtrace',
                    ]
 
     for m in (bzrlib.store, bzrlib.inventory, bzrlib.branch,

=== modified file 'bzrlib/selftest/blackbox.py'
--- bzrlib/selftest/blackbox.py	2005-11-17 22:29:54 +0000
+++ bzrlib/selftest/blackbox.py	2005-11-23 07:18:42 +0000
@@ -24,6 +24,11 @@
 """
 
 
+# XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
+# Note: Please don't add new tests here, it's too big and bulky.  Instead add
+# them into small suites for the particular function that's tested.
+
+
 from cStringIO import StringIO
 import os
 import re
@@ -67,11 +72,11 @@
         self.assert_(os.path.exists('subdir1'))
         self.assert_(os.path.exists('subdir1/.bzr'))
 
-        self.runbzr('init subdir2/nothere', retcode=2)
+        self.runbzr('init subdir2/nothere', retcode=3)
         
         os.mkdir('subdir2')
         self.runbzr('init subdir2')
-        self.runbzr('init subdir2', retcode=1)
+        self.runbzr('init subdir2', retcode=3)
 
         self.runbzr('init subdir2/subsubdir1')
         self.assert_(os.path.exists('subdir2/subsubdir1/.bzr'))
@@ -107,23 +112,35 @@
         if bzr_email is not None:
             os.environ['BZREMAIL'] = bzr_email
 
+    def test_nick_command(self):
+        """bzr nick for viewing, setting nicknames"""
+        os.mkdir('me.dev')
+        os.chdir('me.dev')
+        self.runbzr('init')
+        nick = self.runbzr("nick",backtick=True)
+        self.assertEqual(nick, 'me.dev\n')
+        nick = self.runbzr("nick moo")
+        nick = self.runbzr("nick",backtick=True)
+        self.assertEqual(nick, 'moo\n')
+
+
     def test_invalid_commands(self):
-        self.runbzr("pants", retcode=1)
-        self.runbzr("--pants off", retcode=1)
-        self.runbzr("diff --message foo", retcode=1)
+        self.runbzr("pants", retcode=3)
+        self.runbzr("--pants off", retcode=3)
+        self.runbzr("diff --message foo", retcode=3)
 
     def test_empty_commit(self):
         self.runbzr("init")
         self.build_tree(['hello.txt'])
-        self.runbzr("commit -m empty", retcode=1)
+        self.runbzr("commit -m empty", retcode=3)
         self.runbzr("add hello.txt")
-        self.runbzr("commit -m added")
+        self.runbzr("commit -m added")       
 
     def test_empty_commit_message(self):
         self.runbzr("init")
         file('foo.c', 'wt').write('int main() {}')
         self.runbzr(['add', 'foo.c'])
-        self.runbzr(["commit", "-m", ""] , retcode=1) 
+        self.runbzr(["commit", "-m", ""] , retcode=3) 
 
     def test_remove_deleted(self):
         self.runbzr("init")
@@ -148,10 +165,10 @@
         self.runbzr(['add', 'branch/foo.c'])
         self.runbzr(['add', 'branch'])
         # can't commit files in different trees; sane error
-        self.runbzr('commit -m newstuff branch/foo.c .', retcode=1)
+        self.runbzr('commit -m newstuff branch/foo.c .', retcode=3)
         self.runbzr('commit -m newstuff branch/foo.c')
         self.runbzr('commit -m newstuff branch')
-        self.runbzr('commit -m newstuff branch', retcode=1)
+        self.runbzr('commit -m newstuff branch', retcode=3)
 
     def test_ignore_patterns(self):
         from bzrlib.branch import Branch
@@ -228,6 +245,21 @@
         self.runbzr('revert')
         os.chdir('..')
 
+    def test_status(self):
+        self.runbzr("init")
+        self.build_tree(['hello.txt'])
+        result = self.runbzr("status")
+        self.assert_("unknown:\n  hello.txt\n" in result, result)
+        self.runbzr("add hello.txt")
+        result = self.runbzr("status")
+        self.assert_("added:\n  hello.txt\n" in result, result)
+        self.runbzr("commit -m added")
+        result = self.runbzr("status -r 0..1")
+        self.assert_("added:\n  hello.txt\n" in result, result)
+        self.build_tree(['world.txt'])
+        result = self.runbzr("status -r 0")
+        self.assert_("added:\n  hello.txt\n" \
+                     "unknown:\n  world.txt\n" in result, result)
 
     def test_mv_modes(self):
         """Test two modes of operation for mv"""
@@ -309,14 +341,18 @@
         self.assert_('\n+hello world!' in output)
         output = self.runbzr('diff -r last:3..last:1', backtick=1, retcode=1)
         self.assert_('\n+baz' in output)
+        file('moo', 'wb').write('moo')
+        self.runbzr('add moo')
+        os.unlink('moo')
+        self.runbzr('diff')
 
     def test_diff_branches(self):
-        self.build_tree(['branch1/', 'branch1/file', 'branch2/'])
+        self.build_tree(['branch1/', 'branch1/file', 'branch2/'], line_endings='binary')
         branch = Branch.initialize('branch1')
         branch.working_tree().add(['file'])
         branch.working_tree().commit('add file')
         copy_branch(branch, 'branch2')
-        print >> open('branch2/file', 'w'), 'new content'
+        print >> open('branch2/file', 'wb'), 'new content'
         branch2 = Branch.open('branch2')
         branch2.working_tree().commit('update file')
         # should open branch1 and diff against branch2, 
@@ -324,12 +360,22 @@
                                         'branch1'],
                                        retcode=1)
         self.assertEquals(("=== modified file 'file'\n"
-                           "--- file\n"
-                           "+++ file\n"
+                           "--- file\t\n"
+                           "+++ file\t\n"
                            "@@ -1,1 +1,1 @@\n"
                            "-new content\n"
                            "+contents of branch1/file\n"
                            "\n", ''), output)
+        output = self.run_bzr_captured(['diff', 'branch2', 'branch1'],
+                                       retcode=1)
+        self.assertEqualDiff(("=== modified file 'file'\n"
+                              "--- file\t\n"
+                              "+++ file\t\n"
+                              "@@ -1,1 +1,1 @@\n"
+                              "-new content\n"
+                              "+contents of branch1/file\n"
+                              "\n", ''), output)
+
 
     def test_branch(self):
         """Branch from one branch to another."""
@@ -365,10 +411,10 @@
         os.chdir('../a')
         file('hello', 'wt').write('quuux')
         # We can't merge when there are in-tree changes
-        self.runbzr('merge ../b', retcode=1)
+        self.runbzr('merge ../b', retcode=3)
         self.runbzr(['commit', '-m', "Like an epidemic of u's"])
         self.runbzr('merge ../b -r last:1..last:1 --merge-type blooof',
-                    retcode=1)
+                    retcode=3)
         self.runbzr('merge ../b -r last:1..last:1 --merge-type merge3')
         self.runbzr('revert --no-backup')
         self.runbzr('merge ../b -r last:1..last:1 --merge-type weave')
@@ -428,12 +474,12 @@
         os.chdir('a')
 
         self.example_branch()
-        self.runbzr('pull', retcode=1)
-        self.runbzr('missing', retcode=1)
+        self.runbzr('pull', retcode=3)
+        self.runbzr('missing', retcode=3)
         self.runbzr('missing .')
         self.runbzr('missing')
         self.runbzr('pull')
-        self.runbzr('pull /', retcode=1)
+        self.runbzr('pull /', retcode=3)
         self.runbzr('pull')
 
         os.chdir('..')
@@ -453,7 +499,7 @@
         os.chdir('../b')
         self.runbzr('commit -m blah3 --unchanged')
         # no overwrite
-        self.runbzr('pull ../a', retcode=1)
+        self.runbzr('pull ../a', retcode=3)
         os.chdir('..')
         self.runbzr('branch b overwriteme')
         os.chdir('overwriteme')
@@ -478,6 +524,22 @@
         self.runbzr('pull ../b')
         self.runbzr('pull ../b')
 
+    def test_inventory(self):
+        bzr = self.runbzr
+        def output_equals(value, *args):
+            out = self.runbzr(['inventory'] + list(args), backtick=True)
+            self.assertEquals(out, value)
+
+        bzr('init')
+        open('a', 'wb').write('hello\n')
+        os.mkdir('b')
+
+        bzr('add a b')
+        bzr('commit -m add')
+
+        output_equals('a\n', '--kind', 'file')
+        output_equals('b\n', '--kind', 'directory')        
+
     def test_ls(self):
         """Test the abilities of 'bzr ls'"""
         bzr = self.runbzr
@@ -493,7 +555,7 @@
         open('a', 'wb').write('hello\n')
 
         # Can't supply both
-        bzr('ls --verbose --null', retcode=1)
+        bzr('ls --verbose --null', retcode=3)
 
         ls_equals('a\n')
         ls_equals('?        a\n', '--verbose')
@@ -599,13 +661,13 @@
         out = bzr('pull --verbose ../b', backtick=True)
         self.failIfEqual(out.find('Added Revisions:'), -1)
         self.failIfEqual(out.find('message:\n  added b'), -1)
-        self.failIfEqual(out.find('added:\n  b'), -1)
+        self.failIfEqual(out.find('added b'), -1)
 
         # Check that --overwrite --verbose prints out the removed entries
         bzr('commit -m foo --unchanged')
         os.chdir('../b')
         bzr('commit -m baz --unchanged')
-        bzr('pull ../a', retcode=1)
+        bzr('pull ../a', retcode=3)
         out = bzr('pull --overwrite --verbose ../a', backtick=1)
 
         remove_loc = out.find('Removed Revisions:')
@@ -627,8 +689,8 @@
         os.chdir('a')
         self.runbzr('init')
         self.runbzr('commit -m unchanged --unchanged')
-        self.runbzr('pull', retcode=1)
-        self.runbzr('merge', retcode=1)
+        self.runbzr('pull', retcode=3)
+        self.runbzr('merge', retcode=3)
         self.runbzr('branch . ../b')
         os.chdir('../b')
         self.runbzr('pull')
@@ -645,7 +707,7 @@
         os.chdir('../b')
         self.runbzr('pull')
         os.chdir('../d')
-        self.runbzr('pull', retcode=1)
+        self.runbzr('pull', retcode=3)
         self.runbzr('pull ../a --remember')
         self.runbzr('pull')
         
@@ -653,7 +715,7 @@
         """add command prints the names of added files."""
         b = Branch.initialize('.')
         self.build_tree(['top.txt', 'dir/', 'dir/sub.txt'])
-        out = self.run_bzr_captured(['add'], retcode = 0)[0]
+        out = self.run_bzr_captured(['add'], retcode=0)[0]
         # the ordering is not defined at the moment
         results = sorted(out.rstrip('\n').split('\n'))
         self.assertEquals(['added dir',
@@ -665,7 +727,7 @@
         """add -q does not print the names of added files."""
         b = Branch.initialize('.')
         self.build_tree(['top.txt', 'dir/', 'dir/sub.txt'])
-        out = self.run_bzr_captured(['add', '-q'], retcode = 0)[0]
+        out = self.run_bzr_captured(['add', '-q'], retcode=0)[0]
         # the ordering is not defined at the moment
         results = sorted(out.rstrip('\n').split('\n'))
         self.assertEquals([''], results)
@@ -741,12 +803,12 @@
     def test_unknown_command(self):
         """Handling of unknown command."""
         out, err = self.run_bzr_captured(['fluffy-badger'],
-                                         retcode=1)
+                                         retcode=3)
         self.assertEquals(out, '')
         err.index('unknown command')
 
-    def test_conflicts(self):
-        """Handling of merge conflicts"""
+    def create_conflicts(self):
+        """Create a conflicted tree"""
         os.mkdir('base')
         os.chdir('base')
         file('hello', 'wb').write("hi world")
@@ -766,6 +828,41 @@
         file('question', 'wb').write("What do you get when you multiply six"
                                    "times nine?")
         self.runbzr('commit -m this')
+
+    def test_remerge(self):
+        """Remerge command works as expected"""
+        self.create_conflicts()
+        self.runbzr('merge ../other --show-base', retcode=1)
+        conflict_text = file('hello').read()
+        assert '|||||||' in conflict_text
+        assert 'hi world' in conflict_text
+        self.runbzr('remerge', retcode=1)
+        conflict_text = file('hello').read()
+        assert '|||||||' not in conflict_text
+        assert 'hi world' not in conflict_text
+        os.unlink('hello.OTHER')
+        self.runbzr('remerge hello --merge-type weave', retcode=1)
+        assert os.path.exists('hello.OTHER')
+        file_id = self.runbzr('file-id hello')
+        file_id = self.runbzr('file-id hello.THIS', retcode=3)
+        self.runbzr('remerge --merge-type weave', retcode=1)
+        assert os.path.exists('hello.OTHER')
+        assert not os.path.exists('hello.BASE')
+        assert '|||||||' not in conflict_text
+        assert 'hi world' not in conflict_text
+        self.runbzr('remerge . --merge-type weave --show-base', retcode=3)
+        self.runbzr('remerge . --merge-type weave --reprocess', retcode=3)
+        self.runbzr('remerge . --show-base --reprocess', retcode=3)
+        self.runbzr('remerge hello --show-base', retcode=1)
+        self.runbzr('remerge hello --reprocess', retcode=1)
+        self.runbzr('resolve --all')
+        self.runbzr('commit -m done',)
+        self.runbzr('remerge', retcode=3)
+
+
+    def test_conflicts(self):
+        """Handling of merge conflicts"""
+        self.create_conflicts()
         self.runbzr('merge ../other --show-base', retcode=1)
         conflict_text = file('hello').read()
         self.assert_('<<<<<<<' in conflict_text)
@@ -786,7 +883,7 @@
         self.runbzr('resolve hello')
         result = self.runbzr('conflicts', backtick=1)
         self.assertEquals(result, "question\n")
-        self.runbzr('commit -m conflicts', retcode=1)
+        self.runbzr('commit -m conflicts', retcode=3)
         self.runbzr('resolve --all')
         result = self.runbzr('conflicts', backtick=1)
         self.runbzr('commit -m conflicts')
@@ -836,7 +933,7 @@
         self.example_branch()
 
         # with no push target, fail
-        self.runbzr('push', retcode=1)
+        self.runbzr('push', retcode=3)
         # with an explicit target work
         self.runbzr('push ../output-branch')
         # with an implicit target work
@@ -856,16 +953,17 @@
         self.runbzr('commit --unchanged -m unchanged')
         os.chdir('../my-branch')
         # cannot push now
-        self.runbzr('push', retcode=1)
+        self.runbzr('push', retcode=3)
         # and there are difference
         self.runbzr('missing ../output-branch', retcode=1)
+        self.runbzr('missing --verbose ../output-branch', retcode=1)
         # but we can force a push
         self.runbzr('push --overwrite')
         # nothing missing
         self.runbzr('missing ../output-branch')
         
         # pushing to a new dir with no parent should fail
-        self.runbzr('push ../missing/new-branch', retcode=1)
+        self.runbzr('push ../missing/new-branch', retcode=3)
         # unless we provide --create-prefix
         self.runbzr('push --create-prefix ../missing/new-branch')
         # nothing missing
@@ -900,7 +998,7 @@
 
             # It should not find the command in the local 
             # directory by default, since it is not in my path
-            bzr(cmd_name, retcode=1)
+            bzr(cmd_name, retcode=3)
 
             # Now put it into my path
             os.environ['BZRPATH'] = '.'
@@ -915,7 +1013,7 @@
             # Make sure empty path elements are ignored
             os.environ['BZRPATH'] = os.pathsep
 
-            bzr(cmd_name, retcode=1)
+            bzr(cmd_name, retcode=3)
 
         finally:
             if oldpath:
@@ -987,13 +1085,13 @@
         runbzr("help st")
         runbzr("help")
         runbzr("help commands")
-        runbzr("help slartibartfast", 1)
+        runbzr("help slartibartfast", 3)
 
         out = capture("help ci")
         out.index('aliases: ')
 
         progress("can't rename unversioned file")
-        runbzr("rename test.txt new-test.txt", 1)
+        runbzr("rename test.txt new-test.txt", 3)
 
         progress("adding a file")
 
@@ -1013,9 +1111,9 @@
 
         progress("more complex renames")
         os.mkdir("sub1")
-        runbzr("rename hello.txt sub1", 1)
-        runbzr("rename hello.txt sub1/hello.txt", 1)
-        runbzr("move hello.txt sub1", 1)
+        runbzr("rename hello.txt sub1", 3)
+        runbzr("rename hello.txt sub1/hello.txt", 3)
+        runbzr("move hello.txt sub1", 3)
 
         runbzr("add sub1")
         runbzr("rename sub1 sub2")
@@ -1073,7 +1171,7 @@
         runbzr('log')
         runbzr('log -v')
         runbzr('log -v --forward')
-        runbzr('log -m', retcode=1)
+        runbzr('log -m', retcode=3)
         log_out = capture('log -m commit')
         self.assert_("this is my new commit\n  and" in log_out)
         self.assert_("rename nested" not in log_out)
@@ -1220,4 +1318,4 @@
         branch.working_tree().commit('add file', rev_id='A')
         url = self.get_remote_url('branch/file')
         output = self.capture('log %s' % url)
-        self.assertEqual(7, len(output.split('\n')))
+        self.assertEqual(8, len(output.split('\n')))

=== modified file 'bzrlib/selftest/test_bad_files.py'
--- bzrlib/selftest/test_bad_files.py	2005-09-18 16:09:41 +0000
+++ bzrlib/selftest/test_bad_files.py	2005-11-07 21:40:55 +0000
@@ -89,5 +89,5 @@
 
         # We should raise an error if we are adding a bogus file
         # Is there a way to test the actual error that should be raised?
-        self.run_bzr('add', 'a-fifo', retcode=1)
+        self.run_bzr('add', 'a-fifo', retcode=3)
 

=== modified file 'bzrlib/selftest/test_command.py'
--- bzrlib/selftest/test_command.py	2005-10-19 19:01:25 +0000
+++ bzrlib/selftest/test_command.py	2005-11-16 04:07:29 +0000
@@ -20,6 +20,7 @@
 
 class TestCommands(TestCase):
     def test_display_command(self):
+        """EPIPE message is selectively suppressed"""
         def pipe_thrower():
             raise IOError(errno.EPIPE, "Bogus pipe error")
         self.assertRaises(IOError, pipe_thrower)

=== modified file 'bzrlib/selftest/test_commit.py'
--- bzrlib/selftest/test_commit.py	2005-11-17 22:57:58 +0000
+++ bzrlib/selftest/test_commit.py	2005-11-23 07:18:42 +0000
@@ -146,7 +146,7 @@
         """Test commit of a revision where a file is renamed."""
         b = Branch.initialize('.')
         tree = WorkingTree('.', b)
-        self.build_tree(['hello'])
+        self.build_tree(['hello'], line_endings='binary')
         tree.add(['hello'], ['hello-id'])
         tree.commit(message='one', rev_id='test@rev-1', allow_pointless=False)
 
@@ -169,7 +169,6 @@
         ie = tree2.inventory['hello-id']
         eq(ie.revision, 'test@rev-2')
 
-
     def test_reused_rev_id(self):
         """Test that a revision id cannot be reused in a branch"""
         b = Branch.initialize('.')
@@ -179,8 +178,6 @@
                           message='reused id',
                           rev_id='test@rev-1',
                           allow_pointless=True)
-                          
-
 
     def test_commit_move(self):
         """Test commit of revisions with moved files and directories"""

=== modified file 'bzrlib/selftest/test_conflicts.py'
--- bzrlib/selftest/test_conflicts.py	2005-10-31 20:40:26 +0000
+++ bzrlib/selftest/test_conflicts.py	2005-11-04 23:22:54 +0000
@@ -20,7 +20,8 @@
 from bzrlib.selftest import TestCaseInTempDir
 from bzrlib.branch import Branch
 from bzrlib.commit import Commit
-
+from bzrlib.conflicts import restore
+from bzrlib.errors import NotConflicted
 
 # TODO: Test commit with some added, and added-but-missing files
 
@@ -29,16 +30,22 @@
     def test_conflicts(self):
         """Conflicts are detected properly"""
         b = Branch.initialize('.')
-        file('hello', 'w').write('hello world')
-        file('hello.BASE', 'w').write('hello world')
+        file('hello', 'w').write('hello world4')
+        file('hello.THIS', 'w').write('hello world2')
+        file('hello.BASE', 'w').write('hello world1')
+        file('hello.OTHER', 'w').write('hello world3')
         file('hello.sploo.BASE', 'w').write('yellow world')
+        file('hello.sploo.OTHER', 'w').write('yellow world2')
         tree = b.working_tree()
-        self.assertEqual(len(list(tree.list_files())), 3)
+        self.assertEqual(len(list(tree.list_files())), 6)
         conflicts = list(tree.iter_conflicts())
         self.assertEqual(len(conflicts), 2)
         self.assert_('hello' in conflicts)
         self.assert_('hello.sploo' in conflicts)
-        os.unlink('hello.BASE')
-        os.unlink('hello.sploo.BASE')
+        restore('hello')
+        restore('hello.sploo')
         self.assertEqual(len(list(tree.iter_conflicts())), 0)
-
+        self.assertFileEqual('hello world2', 'hello')
+        assert not os.path.lexists('hello.sploo')
+        self.assertRaises(NotConflicted, restore, 'hello')
+        self.assertRaises(NotConflicted, restore, 'hello.sploo')

=== modified file 'bzrlib/selftest/test_merge_core.py'
--- bzrlib/selftest/test_merge_core.py	2005-11-18 01:13:19 +0000
+++ bzrlib/selftest/test_merge_core.py	2005-11-23 07:18:42 +0000
@@ -3,6 +3,7 @@
 import tempfile
 import unittest
 import stat
+import sys
 
 from bzrlib.selftest import TestCaseInTempDir, TestCase
 from bzrlib.branch import ScratchBranch, Branch
@@ -14,8 +15,8 @@
 from bzrlib import changeset
 from bzrlib.merge_core import (ApplyMerge3, make_merge_changeset,
                                BackupBeforeChange, ExecFlagMerge, WeaveMerge)
-from bzrlib.changeset import Inventory, apply_changeset, invert_dict
-from bzrlib.changeset import get_contents, ReplaceContents
+from bzrlib.changeset import Inventory, apply_changeset, invert_dict, \
+    get_contents, ReplaceContents, ChangeExecFlag
 from bzrlib.clone import copy_branch
 from bzrlib.merge import merge
 from bzrlib.workingtree import WorkingTree
@@ -468,9 +469,10 @@
         builder.apply_changeset(cset)
         self.assert_(file(builder.this.full_path("1"), "rb").read() == "text4" )
         self.assert_(file(builder.this.full_path("2"), "rb").read() == "text2" )
-        self.assert_(os.stat(builder.this.full_path("1")).st_mode &0777 == 0755)
-        self.assert_(os.stat(builder.this.full_path("2")).st_mode &0777 == 0655)
-        self.assert_(os.stat(builder.this.full_path("3")).st_mode &0777 == 0744)
+        if sys.platform != "win32":
+            self.assert_(os.stat(builder.this.full_path("1")).st_mode &0777 == 0755)
+            self.assert_(os.stat(builder.this.full_path("2")).st_mode &0777 == 0655)
+            self.assert_(os.stat(builder.this.full_path("3")).st_mode &0777 == 0744)
         return builder
 
     def contents_test_conflicts(self, merge_factory):
@@ -483,29 +485,31 @@
         builder.cleanup()
 
     def test_symlink_conflicts(self):
-        builder = MergeBuilder()
-        builder.add_symlink("2", "0", "name2", "target1")
-        builder.change_target("2", other="target4", base="text3")
-        self.assertRaises(changeset.ThreewayContentsConflict,
-                          builder.merge_changeset, ApplyMerge3)
-        builder.cleanup()
+        if sys.platform != "win32":
+            builder = MergeBuilder()
+            builder.add_symlink("2", "0", "name2", "target1")
+            builder.change_target("2", other="target4", base="text3")
+            self.assertRaises(changeset.ThreewayContentsConflict,
+                              builder.merge_changeset, ApplyMerge3)
+            builder.cleanup()
 
     def test_symlink_merge(self):
-        builder = MergeBuilder()
-        builder.add_symlink("1", "0", "name1", "target1")
-        builder.add_symlink("2", "0", "name2", "target1")
-        builder.add_symlink("3", "0", "name3", "target1")
-        builder.change_target("1", this="target2")
-        builder.change_target("2", base="target2")
-        builder.change_target("3", other="target2")
-        self.assertNotEqual(builder.cset.entries['2'].contents_change,
-                            builder.cset.entries['3'].contents_change)
-        cset = builder.merge_changeset(ApplyMerge3)
-        builder.apply_changeset(cset)
-        self.assertEqual(builder.this.get_symlink_target("1"), "target2")
-        self.assertEqual(builder.this.get_symlink_target("2"), "target1")
-        self.assertEqual(builder.this.get_symlink_target("3"), "target2")
-        builder.cleanup()
+        if sys.platform != "win32":
+            builder = MergeBuilder()
+            builder.add_symlink("1", "0", "name1", "target1")
+            builder.add_symlink("2", "0", "name2", "target1")
+            builder.add_symlink("3", "0", "name3", "target1")
+            builder.change_target("1", this="target2")
+            builder.change_target("2", base="target2")
+            builder.change_target("3", other="target2")
+            self.assertNotEqual(builder.cset.entries['2'].contents_change,
+                                builder.cset.entries['3'].contents_change)
+            cset = builder.merge_changeset(ApplyMerge3)
+            builder.apply_changeset(cset)
+            self.assertEqual(builder.this.get_symlink_target("1"), "target2")
+            self.assertEqual(builder.this.get_symlink_target("2"), "target1")
+            self.assertEqual(builder.this.get_symlink_target("3"), "target2")
+            builder.cleanup()
 
     def test_perms_merge(self):
         builder = MergeBuilder()
@@ -521,9 +525,10 @@
         self.assert_(isinstance(cset.entries["2"].metadata_change, ExecFlagMerge))
         self.assert_(cset.entries["3"].is_boring())
         builder.apply_changeset(cset)
-        self.assert_(os.lstat(builder.this.full_path("1")).st_mode &0100 == 0000)
-        self.assert_(os.lstat(builder.this.full_path("2")).st_mode &0100 == 0100)
-        self.assert_(os.lstat(builder.this.full_path("3")).st_mode &0100 == 0000)
+        if sys.platform != "win32":
+            self.assert_(os.lstat(builder.this.full_path("1")).st_mode &0100 == 0000)
+            self.assert_(os.lstat(builder.this.full_path("2")).st_mode &0100 == 0100)
+            self.assert_(os.lstat(builder.this.full_path("3")).st_mode &0100 == 0000)
         builder.cleanup();
 
 
@@ -628,3 +633,23 @@
         self.assert_(os.path.lexists('a/file'))
         self.assert_(os.path.lexists('a/file.moved'))
         self.assertEqual(a.working_tree().pending_merges(), [b.last_revision()])
+
+    def test_merge_metadata_vs_deletion(self):
+        """Conflict deletion vs metadata change"""
+        os.mkdir('a')
+        a = Branch.initialize('a')
+        file('a/file', 'wb').write('contents\n')
+        a_wt = a.working_tree()
+        a_wt.add('file')
+        a_wt.commit('r0')
+        copy_branch(a, 'b')
+        b = Branch.open('b')
+        b_wt = b.working_tree()
+        os.chmod('b/file', 0755)
+        os.remove('a/file')
+        a_wt.commit('removed a')
+        self.assertEqual(a.revno(), 2)
+        self.assertFalse(os.path.exists('a/file'))
+        b_wt.commit('exec a')
+        merge(['b', -1], ['b', 0], this_dir='a')
+        self.assert_(os.path.exists('a/file'))

=== modified file 'bzrlib/selftest/test_revision_info.py'
--- bzrlib/selftest/test_revision_info.py	2005-11-07 20:17:57 +0000
+++ bzrlib/selftest/test_revision_info.py	2005-11-17 07:45:38 +0000
@@ -28,7 +28,7 @@
         The output is supplied first, so that you can supply a variable
         number of arguments to bzr.
         """
-        self.assertEquals(self.run_bzr_captured(args, retcode=1)[1], output)
+        self.assertContainsRe(self.run_bzr_captured(args, retcode=3)[1], output)
 
     def check_output(self, output, *args):
         """Verify that the expected output matches what bzr says.
@@ -49,7 +49,8 @@
         b.working_tree().commit('Commit three', rev_id='a@r-0-3')
 
         # Make sure revision-info without any arguments throws an exception
-        self.check_error('bzr: ERROR: You must supply a revision identifier\n',
+        self.check_error('bzr: ERROR: bzrlib.errors.BzrCommandError: '
+                         'You must supply a revision identifier\n',
                          'revision-info')
 
         values = {

=== modified file 'bzrlib/selftest/testannotate.py'
--- bzrlib/selftest/testannotate.py	2005-11-17 21:55:55 +0000
+++ bzrlib/selftest/testannotate.py	2005-11-23 07:18:42 +0000
@@ -42,10 +42,13 @@
     def setUp(self):
         super(TestAnnotate, self).setUp()
         b = Branch.initialize('.')
-        self.build_tree_contents([('hello.txt', 'my helicopter\n')])
+        self.build_tree_contents([('hello.txt', 'my helicopter\n'),
+                                  ('nomail.txt', 'nomail\n')])
         b.working_tree().add(['hello.txt'])
         b.working_tree().commit('add hello', 
                                 committer='test@user')
+        b.working_tree().add(['nomail.txt'])
+        b.working_tree().commit('add nomail', committer='no mail')
 
     def test_help_annotate(self):
         """Annotate command exists"""
@@ -57,3 +60,10 @@
         self.assertEqualDiff(out, '''\
     1 test@us | my helicopter
 ''')
+
+    def test_no_mail(self):
+        out, err = self.run_bzr_captured(['annotate', 'nomail.txt'])
+        self.assertEquals(err, '')
+        self.assertEqualDiff(out, '''\
+    2 no mail | nomail
+''')

=== modified file 'bzrlib/selftest/testbranch.py'
--- bzrlib/selftest/testbranch.py	2005-11-17 21:55:55 +0000
+++ bzrlib/selftest/testbranch.py	2005-11-23 07:18:42 +0000
@@ -191,6 +191,34 @@
         branch = Branch.initialize('.')
         self.assertEqual('.bzr', branch._rel_controlfilename(''))
 
+    def test_nicks(self):
+        """Branch nicknames"""
+        os.mkdir('bzr.dev')
+        branch = Branch.initialize('bzr.dev')
+        self.assertEqual(branch.nick, 'bzr.dev')
+        os.rename('bzr.dev', 'bzr.ab')
+        branch = Branch.open('bzr.ab')
+        self.assertEqual(branch.nick, 'bzr.ab')
+        branch.nick = "Aaron's branch"
+        branch.nick = "Aaron's branch"
+        self.failUnless(os.path.exists(branch.controlfilename("branch.conf")))
+        self.assertEqual(branch.nick, "Aaron's branch")
+        os.rename('bzr.ab', 'integration')
+        branch = Branch.open('integration')
+        self.assertEqual(branch.nick, "Aaron's branch")
+        branch.nick = u"\u1234"
+        self.assertEqual(branch.nick, u"\u1234")
+
+    def test_commit_nicks(self):
+        """Nicknames are committed to the revision"""
+        os.mkdir('bzr.dev')
+        branch = Branch.initialize('bzr.dev')
+        branch.nick = "My happy branch"
+        branch.working_tree().commit('My commit respect da nick.')
+        committed = branch.get_revision(branch.last_revision())
+        self.assertEqual(committed.properties["branch-nick"], 
+                         "My happy branch")
+
 
 class TestRemote(TestCaseWithWebserver):
 

=== modified file 'bzrlib/selftest/testconfig.py'
--- bzrlib/selftest/testconfig.py	2005-11-04 23:27:47 +0000
+++ bzrlib/selftest/testconfig.py	2005-11-21 09:07:18 +0000
@@ -175,23 +175,45 @@
 
     def setUp(self):
         super(TestConfigPath, self).setUp()
-        self.oldenv = os.environ.get('HOME', None)
+        self.old_home = os.environ.get('HOME', None)
+        self.old_appdata = os.environ.get('APPDATA', None)
         os.environ['HOME'] = '/home/bogus'
+        os.environ['APPDATA'] = \
+            r'C:\Documents and Settings\bogus\Application Data'
 
     def tearDown(self):
-        os.environ['HOME'] = self.oldenv
+        if self.old_home is None:
+            del os.environ['HOME']
+        else:
+            os.environ['HOME'] = self.old_home
+        if self.old_appdata is None:
+            del os.environ['APPDATA']
+        else:
+            os.environ['APPDATA'] = self.old_appdata
         super(TestConfigPath, self).tearDown()
     
     def test_config_dir(self):
-        self.assertEqual(config.config_dir(), '/home/bogus/.bazaar')
+        if sys.platform == 'win32':
+            self.assertEqual(config.config_dir(), 
+                r'C:\Documents and Settings\bogus\Application Data\bazaar\2.0')
+        else:
+            self.assertEqual(config.config_dir(), '/home/bogus/.bazaar')
 
     def test_config_filename(self):
-        self.assertEqual(config.config_filename(),
-                         '/home/bogus/.bazaar/bazaar.conf')
+        if sys.platform == 'win32':
+            self.assertEqual(config.config_filename(), 
+                r'C:\Documents and Settings\bogus\Application Data\bazaar\2.0\bazaar.conf')
+        else:
+            self.assertEqual(config.config_filename(),
+                             '/home/bogus/.bazaar/bazaar.conf')
 
     def test_branches_config_filename(self):
-        self.assertEqual(config.branches_config_filename(),
-                         '/home/bogus/.bazaar/branches.conf')
+        if sys.platform == 'win32':
+            self.assertEqual(config.branches_config_filename(), 
+                r'C:\Documents and Settings\bogus\Application Data\bazaar\2.0\branches.conf')
+        else:
+            self.assertEqual(config.branches_config_filename(),
+                             '/home/bogus/.bazaar/branches.conf')
 
 class TestIniConfig(TestCase):
 
@@ -489,6 +511,10 @@
         self.get_location_config('/a/c')
         record = InstrumentedConfigObj("foo")
         self.my_config._parser = record
+        return
+        # XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
+        # broken: creates .bazaar in the top-level directory, not 
+        # inside the test directory
         self.my_config.set_user_option('foo', 'bar')
         self.assertEqual([('__contains__', '/a/c'),
                           ('__contains__', '/a/c/'),
@@ -564,3 +590,12 @@
         my_config._get_location_config()._get_parser(branch_file)
         self.assertEqual('bzrlib.selftest.testconfig.post_commit',
                          my_config.post_commit())
+
+
+class TestMailAddressExtraction(TestCase):
+
+    def test_extract_email_address(self):
+        self.assertEqual('jane@test.com',
+                         config.extract_email_address('Jane <jane@test.com>'))
+        self.assertRaises(errors.BzrError,
+                          config.extract_email_address, 'Jane Tester')

=== modified file 'bzrlib/selftest/testhashcache.py'
--- bzrlib/selftest/testhashcache.py	2005-09-27 07:24:40 +0000
+++ bzrlib/selftest/testhashcache.py	2005-10-28 20:17:38 +0000
@@ -15,6 +15,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 import os
+import sys
 import time
 from bzrlib.selftest import TestCaseInTempDir
 
@@ -28,7 +29,7 @@
 def pause():
     if False:
         return
-    if os.name == 'nt':
+    if sys.platform in ('win32', 'cygwin'):
         time.sleep(3)
         return
     # allow it to stabilize

=== modified file 'bzrlib/selftest/testinv.py'
--- bzrlib/selftest/testinv.py	2005-11-17 21:55:55 +0000
+++ bzrlib/selftest/testinv.py	2005-11-23 07:18:42 +0000
@@ -165,8 +165,8 @@
                           "old_label", self.tree_1,
                           "/dev/null", None, None,
                           output)
-        self.assertEqual(output.getvalue(), "--- old_label\n"
-                                            "+++ /dev/null\n"
+        self.assertEqual(output.getvalue(), "--- old_label\t\n"
+                                            "+++ /dev/null\t\n"
                                             "@@ -1,1 +0,0 @@\n"
                                             "-foo\n"
                                             "\n")
@@ -177,8 +177,8 @@
                           "new_label", self.tree_1,
                           "/dev/null", None, None,
                           output, reverse=True)
-        self.assertEqual(output.getvalue(), "--- /dev/null\n"
-                                            "+++ new_label\n"
+        self.assertEqual(output.getvalue(), "--- /dev/null\t\n"
+                                            "+++ new_label\t\n"
                                             "@@ -0,0 +1,1 @@\n"
                                             "+foo\n"
                                             "\n")
@@ -189,8 +189,8 @@
                           "/dev/null", self.tree_1, 
                           "new_label", self.file_2, self.tree_2,
                           output)
-        self.assertEqual(output.getvalue(), "--- /dev/null\n"
-                                            "+++ new_label\n"
+        self.assertEqual(output.getvalue(), "--- /dev/null\t\n"
+                                            "+++ new_label\t\n"
                                             "@@ -1,1 +1,1 @@\n"
                                             "-foo\n"
                                             "+bar\n"
@@ -241,7 +241,7 @@
         # with fake parent entries.
         super(TestSnapshot, self).setUp()
         self.branch = Branch.initialize('.')
-        self.build_tree(['subdir/', 'subdir/file'])
+        self.build_tree(['subdir/', 'subdir/file'], line_endings='binary')
         self.branch.working_tree().add(['subdir', 'subdir/file'],
                                        ['dirid', 'fileid'])
         if has_symlinks():

=== modified file 'bzrlib/selftest/testlog.py'
--- bzrlib/selftest/testlog.py	2005-11-17 21:55:55 +0000
+++ bzrlib/selftest/testlog.py	2005-11-23 07:18:42 +0000
@@ -112,7 +112,6 @@
         # no entries yet
         eq(lf.logs, [])
 
-
         b.working_tree().commit('empty commit')
         lf = LogCatcher()
         show_log(b, lf, verbose=True)
@@ -123,7 +122,6 @@
         self.log('log delta: %r' % d)
         self.checkDelta(d)
 
-
         self.build_tree(['hello'])
         b.working_tree().add('hello')
         b.working_tree().commit('add one file')
@@ -153,6 +151,7 @@
         
         # commit a log message with control characters
         msg = "All 8-bit chars: " +  ''.join([unichr(x) for x in range(256)])
+        self.log("original commit message: %r", msg)
         b.working_tree().commit(msg)
         lf = LogCatcher()
         show_log(b, lf, verbose=True)
@@ -160,3 +159,17 @@
         self.log("escaped commit message: %r", committed_msg)
         self.assert_(msg != committed_msg)
         self.assert_(len(committed_msg) > len(msg))
+
+        # Check that log message with only XML-valid characters isn't
+        # escaped.  As ElementTree apparently does some kind of
+        # newline conversion, neither LF (\x0A) nor CR (\x0D) are
+        # included in the test commit message, even though they are
+        # valid XML 1.0 characters.
+        msg = "\x09" + ''.join([unichr(x) for x in range(0x20, 256)])
+        self.log("original commit message: %r", msg)
+        b.working_tree().commit(msg)
+        lf = LogCatcher()
+        show_log(b, lf, verbose=True)
+        committed_msg = lf.logs[0].rev.message
+        self.log("escaped commit message: %r", committed_msg)
+        self.assert_(msg == committed_msg)

=== modified file 'bzrlib/selftest/testoptions.py'
--- bzrlib/selftest/testoptions.py	2005-10-28 02:34:22 +0000
+++ bzrlib/selftest/testoptions.py	2005-11-09 15:50:22 +0000
@@ -42,6 +42,10 @@
         self.assertEquals(err, '')
         self.assertContainsRe(out, r'--file[ =]MSGFILE')
 
+    def test_unknown_short_opt(self):
+        out, err = self.run_bzr_captured(['help', '-r'], retcode=3)
+        self.assertContainsRe(err, r'unknown short option')
+
 
 #     >>> parse_args('log -r 500'.split())
 #     (['log'], {'revision': [<RevisionSpec_int 500>]})

=== modified file 'bzrlib/selftest/testrevprops.py'
--- bzrlib/selftest/testrevprops.py	2005-11-07 20:17:57 +0000
+++ bzrlib/selftest/testrevprops.py	2005-11-17 07:45:38 +0000
@@ -9,6 +9,7 @@
     def test_simple_revprops(self):
         """Simple revision properties"""
         b = Branch.initialize('.')
+        b.nick = 'Nicholas'
         props = dict(flavor='choc-mint', 
                      condiment='orange\n  mint\n\tcandy')
         b.working_tree().commit(message='initial null commit', 
@@ -19,7 +20,8 @@
         self.assertTrue('flavor' in rev.properties)
         self.assertEquals(rev.properties['flavor'], 'choc-mint')
         self.assertEquals(sorted(rev.properties.items()),
-                          [('condiment', 'orange\n  mint\n\tcandy'),
+                          [('branch-nick', 'Nicholas'), 
+                           ('condiment', 'orange\n  mint\n\tcandy'),
                            ('flavor', 'choc-mint')])
 
     def test_invalid_revprops(self):

=== modified file 'bzrlib/selftest/testtestament.py'
--- bzrlib/selftest/testtestament.py	2005-11-17 21:55:55 +0000
+++ bzrlib/selftest/testtestament.py	2005-11-23 07:18:42 +0000
@@ -35,6 +35,7 @@
     def setUp(self):
         super(TestamentTests, self).setUp()
         b = self.b = Branch.initialize('.')
+        b.nick = "test branch"
         b.working_tree().commit(message='initial null commit',
                  committer='test@user',
                  timestamp=1129025423, # 'Tue Oct 11 20:10:23 2005'
@@ -136,6 +137,9 @@
 message:
   initial null commit
 inventory:
+properties:
+  branch-nick:
+    test branch
 """
 
 REV_1_SHORT = """\
@@ -159,6 +163,9 @@
   file hello hello-id 34dd0ac19a24bf80c4d33b5c8960196e8d8d1f73
   directory src src-id
   file src/foo.c foo.c-id a2a049c20f908ae31b231d98779eb63c66448f24
+properties:
+  branch-nick:
+    test branch
 """
 
 
@@ -184,6 +191,8 @@
   directory src src-id
   file src/foo.c foo.c-id a2a049c20f908ae31b231d98779eb63c66448f24
 properties:
+  branch-nick:
+    test branch
   flavor:
     sour cherry
     cream cheese
@@ -207,4 +216,7 @@
   symlink link link-id wibble/linktarget
   directory src src-id
   file src/foo.c foo.c-id a2a049c20f908ae31b231d98779eb63c66448f24
+properties:
+  branch-nick:
+    test branch
 """

=== added file 'bzrlib/selftest/testtrace.py'
--- bzrlib/selftest/testtrace.py	1970-01-01 00:00:00 +0000
+++ bzrlib/selftest/testtrace.py	2005-11-10 22:55:32 +0000
@@ -0,0 +1,51 @@
+# Copyright (C) 2005 by Canonical Ltd
+#   Authors: Robert Collins <robert.collins@canonical.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+# "weren't nothing promised to you.  do i look like i got a promise face?"
+
+"""Tests for trace library"""
+
+import os
+import sys
+
+from bzrlib.selftest import TestCaseInTempDir, TestCase
+from bzrlib.trace import format_exception_short
+from bzrlib.errors import NotBranchError
+
+class TestTrace(TestCase):
+    def test_format_sys_exception(self):
+        """Short formatting of exceptions"""
+        try:
+            raise NotImplementedError, "time travel"
+        except NotImplementedError:
+            pass
+        error_lines = format_exception_short(sys.exc_info()).splitlines()
+        self.assertEqualDiff(error_lines[0], 
+                'exceptions.NotImplementedError: time travel')
+        self.assertContainsRe(error_lines[1], 
+                r'^  at .*testtrace\.py line \d+$')  
+        self.assertContainsRe(error_lines[2], 
+                r'^  in test_format_sys_exception$')
+
+    def test_format_exception(self):
+        """Short formatting of exceptions"""
+        try:
+            raise NotBranchError, 'wibble'
+        except NotBranchError:
+            pass
+        msg = format_exception_short(sys.exc_info())
+        self.assertEqualDiff(msg, 'Not a branch: wibble')

=== modified file 'bzrlib/selftest/testtransport.py'
--- bzrlib/selftest/testtransport.py	2005-11-10 01:31:41 +0000
+++ bzrlib/selftest/testtransport.py	2005-11-17 07:45:38 +0000
@@ -18,7 +18,8 @@
 import os
 from cStringIO import StringIO
 
-from bzrlib.errors import NoSuchFile, FileExists, TransportNotPossible
+from bzrlib.errors import (NoSuchFile, FileExists, TransportNotPossible,
+                           ConnectionError)
 from bzrlib.selftest import TestCase, TestCaseInTempDir
 from bzrlib.selftest.HTTPTestUtil import TestCaseWithWebserver
 from bzrlib.transport import memory, urlescape
@@ -463,7 +464,14 @@
         # TODO: Test Transport.move
         pass
 
+    def test_connection_error(self):
+        """ConnectionError is raised when connection is impossible"""
+        if not hasattr(self, "get_bogus_transport"):
+            return
+        t = self.get_bogus_transport()
+        self.assertRaises(ConnectionError, t.get, '.bzr/branch')
 
+        
 class LocalTransportTest(TestCaseInTempDir, TestTransportMixIn):
     def get_transport(self):
         from bzrlib.transport.local import LocalTransport
@@ -479,6 +487,10 @@
         url = self.get_remote_url('.')
         return HttpTransport(url)
 
+    def get_bogus_transport(self):
+        from bzrlib.transport.http import HttpTransport
+        return HttpTransport('http://jasldkjsalkdjalksjdkljasd')
+
 
 class TestMemoryTransport(TestCase):
 
@@ -569,4 +581,4 @@
         transport.put('bar', StringIO('phowar'))
         self.assertEqual(7, transport.stat('foo').st_size)
         self.assertEqual(6, transport.stat('bar').st_size)
-        
+

=== modified file 'bzrlib/selftest/versioning.py'
--- bzrlib/selftest/versioning.py	2005-11-17 22:29:54 +0000
+++ bzrlib/selftest/versioning.py	2005-11-23 07:18:42 +0000
@@ -24,10 +24,7 @@
 
 from bzrlib.selftest import BzrTestBase, TestCaseInTempDir
 from bzrlib.branch import Branch
-
-import logging
-logger = logging.getLogger('bzr.test.versioning')
-debug = logger.debug
+from bzrlib.trace import mutter
 
 
 class TestVersioning(TestCaseInTempDir):
@@ -39,7 +36,7 @@
         self.run_bzr('mkdir', 'foo')
         self.assert_(os.path.isdir('foo'))
 
-        self.run_bzr('mkdir', 'foo', retcode=2)
+        self.run_bzr('mkdir', 'foo', retcode=3)
 
         from bzrlib.diff import compare_trees
         from bzrlib.branch import Branch
@@ -142,9 +139,9 @@
 
         The upgrade should be a no-op."""
         b = Branch.open('.')
-        debug('branch has %d revisions', b.revno())
+        mutter('branch has %d revisions', b.revno())
         
-        debug('check branch...')
+        mutter('check branch...')
         from bzrlib.check import check
         check(b, False)
 
@@ -170,7 +167,7 @@
         for fn in ('a/one', 'b/two', 'top'):
             file(fn, 'w').write('new contents')
             
-        debug('start selective subdir commit')
+        mutter('start selective subdir commit')
         run_bzr('commit', 'a', '-m', 'commit a only')
         
         old = b.revision_tree(b.get_rev_id(1))

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2005-10-28 07:20:11 +0000
+++ bzrlib/trace.py	2005-11-16 03:21:19 +0000
@@ -13,17 +13,34 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-"""Messages and logging for bazaar-ng
-
-Messages are sent out through the Python logging library.
-
-They can be sent to two places: to stderr, and to ~/.bzr.log.
-
-~/.bzr.log gets all messages, and tracebacks of all uncaught
-exceptions.
-
-Normally stderr only gets messages of level INFO and higher, and gets
-only a summary of exceptions, not the traceback.
+"""Messages and logging for bazaar-ng.
+
+Messages are supplied by callers as a string-formatting template, plus values
+to be inserted into it.  The actual %-formatting is deferred to the log
+library so that it doesn't need to be done for messages that won't be emitted.
+
+Messages are classified by severity levels: critical, error, warning, info,
+and debug.
+
+They can be sent to two places: to stderr, and to ~/.bzr.log.  For purposes
+such as running the test suite, they can also be redirected away from both of
+those two places to another location.
+
+~/.bzr.log gets all messages, and full tracebacks for uncaught exceptions.
+
+Output to stderr depends on the mode chosen by the user.  By default, messages
+of info and above are sent out, which results in progress messages such as the
+list of files processed by add and commit.  In quiet mode, only warnings and
+above are shown.  In debug mode, stderr gets debug messages too.
+
+Errors that terminate an operation are generally passed back as exceptions;
+others may be just emitted as messages.
+
+Exceptions are reported in a brief form to stderr so as not to look scary.
+BzrErrors are required to be able to format themselves into a properly
+explanatory message.  This is not true for builtin excexceptions such as
+KeyError, which typically just str to "0".  They're printed in a different
+form.
 """
 
 
@@ -41,13 +58,14 @@
 import sys
 import os
 import logging
-import traceback
+
+import bzrlib
+from bzrlib.errors import BzrNewError
 
 
 _file_handler = None
 _stderr_handler = None
 
-
 class QuietFormatter(logging.Formatter):
     """Formatter that supresses the details of errors.
 
@@ -62,20 +80,9 @@
             s = 'bzr: ' + record.levelname + ': '
         else:
             s = ''
-            
         s += record.getMessage()
-
-        ##import textwrap
-        ##s = textwrap.fill(s)
-            
         if record.exc_info:
-            # give just a summary of the exception, not the whole thing
-            exinfo = traceback.extract_tb(record.exc_info[2])
-            # the format of this string matches one of the REs
-            s += '\n'
-            s += ('  at %s line %d, in %s()\n' % exinfo[-1][:3])
-            s += '  see ~/.bzr.log for debug information'
-
+            s += '\n' + format_exception_short(record.exc_info)
         return s
         
 
@@ -94,12 +101,6 @@
 debug =     _bzr_logger.debug
 
 
-
-
-# we do the rollover using this code, rather than the default from python
-# logging, because we only want to rollover at program startup, not on each
-# message.  maybe that's not a good enough reason.
-
 def _rollover_trace_maybe(trace_fname):
     import stat
     try:
@@ -107,15 +108,12 @@
         if size <= 4 << 20:
             return
         old_fname = trace_fname + '.old'
-
         from osutils import rename
         rename(trace_fname, old_fname)
-
     except OSError:
         return
 
 
-
 def open_tracefile(tracefilename='~/.bzr.log'):
     # Messages are always written to here, so that we have some
     # information if something goes wrong.  In a future version this
@@ -125,10 +123,9 @@
 
     trace_fname = os.path.join(os.path.expanduser(tracefilename))
     _rollover_trace_maybe(trace_fname)
-
-    # buffering=1 means line buffered
     try:
-        tf = codecs.open(trace_fname, 'at', 'utf8', buffering=1)
+        LINE_BUFFERED = 1
+        tf = codecs.open(trace_fname, 'at', 'utf8', buffering=LINE_BUFFERED)
 
         if os.fstat(tf.fileno())[stat.ST_SIZE] == 0:
             tf.write("\nthis is a debug log for diagnosing/reporting problems in bzr\n")
@@ -141,19 +138,15 @@
         _file_handler.setFormatter(logging.Formatter(fmt, datefmt))
         _file_handler.setLevel(logging.DEBUG)
         logging.getLogger('').addHandler(_file_handler)
-
     except IOError, e:
         warning("failed to open trace file: %s" % (e))
 
 
 def log_startup(argv):
-    import bzrlib
-
     debug('bzr %s invoked on python %s (%s)',
           bzrlib.__version__,
           '.'.join(map(str, sys.version_info)),
           sys.platform)
-
     debug('  arguments: %r', argv)
     debug('  working dir: %r', os.getcwdu())
 
@@ -164,15 +157,10 @@
     The exception string representation is used as the error
     summary, unless msg is given.
     """
-    ei = sys.exc_info()
-    if msg == None:
-        msg = str(ei[1])
-    if msg and (msg[-1] == '\n'):
-        msg = msg[:-1]
-    msg += '\n  command: %s' % ' '.join(repr(arg) for arg in sys.argv)
-    msg += '\n      pwd: %r' % os.getcwdu()
-    msg += '\n    error: %s' % ei[0]        # exception type
-    _bzr_logger.exception(msg)
+    exc_str = format_exception_short(sys.exc_info())
+    if msg:
+        _bzr_logger.exception(msg)
+    _bzr_logger.error(exc_str)
 
 
 def log_exception_quietly():
@@ -182,6 +170,7 @@
     interesting to developers but not to users.  For example, 
     errors loading plugins.
     """
+    import traceback
     debug(traceback.format_exc())
 
 
@@ -191,9 +180,7 @@
 
     _stderr_handler = logging.StreamHandler()
     _stderr_handler.setFormatter(QuietFormatter())
-
-    if not _file_handler:
-        open_tracefile()
+    logging.getLogger('').addHandler(_stderr_handler)
 
     if os.environ.get('BZR_DEBUG'):
         level = logging.DEBUG
@@ -201,12 +188,15 @@
         level = logging.INFO
 
     _stderr_handler.setLevel(logging.INFO)
-    _file_handler.setLevel(level)
+
+    if not _file_handler:
+        open_tracefile()
+
+    if _file_handler:
+        _file_handler.setLevel(level)
+
     _bzr_logger.setLevel(level) 
 
-    logging.getLogger('').addHandler(_stderr_handler)
-
-
 def disable_default_logging():
     """Turn off default log handlers.
 
@@ -218,3 +208,49 @@
     l.removeHandler(_stderr_handler)
     if _file_handler:
         l.removeHandler(_file_handler)
+
+
+def enable_test_log(to_file):
+    """Redirect logging to a temporary file for a test"""
+    disable_default_logging()
+    global _test_log_hdlr
+    hdlr = logging.StreamHandler(to_file)
+    hdlr.setLevel(logging.DEBUG)
+    hdlr.setFormatter(logging.Formatter('%(levelname)8s  %(message)s'))
+    logging.getLogger('').addHandler(hdlr)
+    logging.getLogger('').setLevel(logging.DEBUG)
+    _test_log_hdlr = hdlr
+
+
+def disable_test_log():
+    logging.getLogger('').removeHandler(_test_log_hdlr)
+    enable_default_logging()
+
+
+def format_exception_short(exc_info):
+    """Make a short string form of an exception.
+
+    This is used for display to stderr.  It specially handles exception
+    classes without useful string methods.
+
+    The result has no trailing newline.
+
+    exc_info - typically an exception from sys.exc_info()
+    """
+    exc_type, exc_object, exc_tb = exc_info
+    try:
+        if exc_type is None:
+            return '(no exception)'
+        if isinstance(exc_object, BzrNewError):
+            return str(exc_object)
+        else:
+            import traceback
+            tb = traceback.extract_tb(exc_tb)
+            msg = '%s: %s' % (exc_type, exc_object)
+            if msg[-1] == '\n':
+                msg = msg[:-1]
+            if tb:
+                msg += '\n  at %s line %d\n  in %s' % (tb[-1][:3])
+            return msg
+    except:
+        return '(error formatting exception of type %s)' % exc_type

=== modified file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2005-11-10 00:50:06 +0000
+++ bzrlib/transport/__init__.py	2005-11-17 08:07:57 +0000
@@ -390,3 +390,5 @@
 register_lazy_transport('sftp://', 'bzrlib.transport.sftp', 'SFTPTransport')
 register_lazy_transport('http://', 'bzrlib.transport.http', 'HttpTransport')
 register_lazy_transport('https://', 'bzrlib.transport.http', 'HttpTransport')
+register_lazy_transport('ftp://', 'bzrlib.transport.ftp', 'FtpTransport')
+register_lazy_transport('aftp://', 'bzrlib.transport.ftp', 'FtpTransport')

=== added file 'bzrlib/transport/ftp.py'
--- bzrlib/transport/ftp.py	1970-01-01 00:00:00 +0000
+++ bzrlib/transport/ftp.py	2005-11-16 16:24:12 +0000
@@ -0,0 +1,313 @@
+# Copyright (C) 2005 Canonical Ltd
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+"""Implementation of Transport over ftp.
+
+Written by Daniel Silverstone <dsilvers@digital-scurf.org> with serious
+cargo-culting from the sftp transport and the http transport.
+
+It provides the ftp:// and aftp:// protocols where ftp:// is passive ftp
+and aftp:// is active ftp. Most people will want passive ftp for traversing
+NAT and other firewalls, so it's best to use it unless you explicitly want
+active, in which case aftp:// will be your friend.
+"""
+
+from bzrlib.transport import Transport
+
+from bzrlib.errors import (TransportNotPossible, NoSuchFile, 
+                           NonRelativePath, TransportError, ConnectionError)
+
+import os, errno
+from cStringIO import StringIO
+import ftplib
+import urlparse
+import urllib
+import stat
+
+from bzrlib.errors import BzrError, BzrCheckError
+from bzrlib.branch import Branch
+from bzrlib.trace import mutter
+
+
+class FtpTransportError(TransportError):
+    pass
+
+
+class FtpStatResult(object):
+    def __init__(self, f, relpath):
+        try:
+            self.st_size = f.size(relpath)
+            self.st_mode = stat.S_IFREG
+        except ftplib.error_perm:
+            pwd = f.pwd()
+            try:
+                f.cwd(relpath)
+                self.st_mode = stat.S_IFDIR
+            finally:
+                f.cwd(pwd)
+
+
+class FtpTransport(Transport):
+    """This is the transport agent for ftp:// access."""
+
+    def __init__(self, base, _provided_instance=None):
+        """Set the base path where files will be stored."""
+        assert base.startswith('ftp://') or base.startswith('aftp://')
+        super(FtpTransport, self).__init__(base)
+        self.is_active = base.startswith('aftp://')
+        if self.is_active:
+            base = base[1:]
+        (self._proto, self._host,
+            self._path, self._parameters,
+            self._query, self._fragment) = urlparse.urlparse(self.base)
+        self._FTP_instance = _provided_instance
+
+
+    def _get_FTP(self):
+        """Return the ftplib.FTP instance for this object."""
+        if self._FTP_instance is not None:
+            return self._FTP_instance
+        
+        try:
+            username = ''
+            password = ''
+            hostname = self._host
+            if '@' in hostname:
+                username, hostname = hostname.split("@", 1)
+            if ':' in username:
+                username, password = username.split(":", 1)
+
+            mutter("Constructing FTP instance")
+            self._FTP_instance = ftplib.FTP(hostname, username, password)
+            self._FTP_instance.set_pasv(not self.is_active)
+            return self._FTP_instance
+        except ftplib.error_perm, e:
+            raise FtpTransportError(msg="Error setting up connection: %s"
+                                    % str(e), orig_error=e)
+
+    def should_cache(self):
+        """Return True if the data pulled across should be cached locally.
+        """
+        return True
+
+    def clone(self, offset=None):
+        """Return a new FtpTransport with root at self.base + offset.
+        """
+        mutter("FTP clone")
+        if offset is None:
+            return FtpTransport(self.base, self._FTP_instance)
+        else:
+            return FtpTransport(self.abspath(offset), self._FTP_instance)
+
+    def _abspath(self, relpath):
+        assert isinstance(relpath, basestring)
+        relpath = urllib.unquote(relpath)
+        if isinstance(relpath, basestring):
+            relpath_parts = relpath.split('/')
+        else:
+            # TODO: Don't call this with an array - no magic interfaces
+            relpath_parts = relpath[:]
+        if len(relpath_parts) > 1:
+            if relpath_parts[0] == '':
+                raise ValueError("path %r within branch %r seems to be absolute"
+                                 % (relpath, self._path))
+        basepath = self._path.split('/')
+        if len(basepath) > 0 and basepath[-1] == '':
+            basepath = basepath[:-1]
+        for p in relpath_parts:
+            if p == '..':
+                if len(basepath) == 0:
+                    # In most filesystems, a request for the parent
+                    # of root, just returns root.
+                    continue
+                basepath.pop()
+            elif p == '.' or p == '':
+                continue # No-op
+            else:
+                basepath.append(p)
+        # Possibly, we could use urlparse.urljoin() here, but
+        # I'm concerned about when it chooses to strip the last
+        # portion of the path, and when it doesn't.
+        return '/'.join(basepath)
+    
+    def abspath(self, relpath):
+        """Return the full url to the given relative path.
+        This can be supplied with a string or a list
+        """
+        path = self._abspath(relpath)
+        return urlparse.urlunparse((self._proto,
+                self._host, path, '', '', ''))
+
+    def has(self, relpath):
+        """Does the target location exist?
+
+        XXX: I assume we're never asked has(dirname) and thus I use
+        the FTP size command and assume that if it doesn't raise,
+        all is good.
+        """
+        try:
+            f = self._get_FTP()
+            s = f.size(self._abspath(relpath))
+            mutter("FTP has: %s" % self._abspath(relpath))
+            return True
+        except ftplib.error_perm:
+            mutter("FTP has not: %s" % self._abspath(relpath))
+            return False
+
+    def get(self, relpath, decode=False):
+        """Get the file at the given relative path.
+
+        :param relpath: The relative path to the file
+
+        We're meant to return a file-like object which bzr will
+        then read from. For now we do this via the magic of StringIO
+        """
+        try:
+            mutter("FTP get: %s" % self._abspath(relpath))
+            f = self._get_FTP()
+            ret = StringIO()
+            f.retrbinary('RETR '+self._abspath(relpath), ret.write, 8192)
+            ret.seek(0)
+            return ret
+        except ftplib.error_perm, e:
+            raise NoSuchFile(msg="Error retrieving %s: %s"
+                             % (self.abspath(relpath), str(e)),
+                             orig_error=e)
+
+    def put(self, relpath, fp):
+        """Copy the file-like or string object into the location.
+
+        :param relpath: Location to put the contents, relative to base.
+        :param f:       File-like or string object.
+        """
+        if not hasattr(fp, 'read'):
+            fp = StringIO(fp)
+        try:
+            mutter("FTP put: %s" % self._abspath(relpath))
+            f = self._get_FTP()
+            f.storbinary('STOR '+self._abspath(relpath), fp, 8192)
+        except ftplib.error_perm, e:
+            raise FtpTransportError(orig_error=e)
+
+    def mkdir(self, relpath):
+        """Create a directory at the given path."""
+        try:
+            mutter("FTP mkd: %s" % self._abspath(relpath))
+            f = self._get_FTP()
+            try:
+                f.mkd(self._abspath(relpath))
+            except ftplib.error_perm, e:
+                s = str(e)
+                if 'File exists' in s:
+                    # Swallow attempts to mkdir something which is already
+                    # present. Hopefully this will shush some errors.
+                    return
+                else:
+                    raise
+        except ftplib.error_perm, e:
+            raise FtpTransportError(orig_error=e)
+
+    def append(self, relpath, f):
+        """Append the text in the file-like object into the final
+        location.
+        """
+        raise TransportNotPossible('ftp does not support append()')
+
+    def copy(self, rel_from, rel_to):
+        """Copy the item at rel_from to the location at rel_to"""
+        raise TransportNotPossible('ftp does not (yet) support copy()')
+
+    def move(self, rel_from, rel_to):
+        """Move the item at rel_from to the location at rel_to"""
+        try:
+            mutter("FTP mv: %s => %s" % (self._abspath(rel_from),
+                                         self._abspath(rel_to)))
+            f = self._get_FTP()
+            f.rename(self._abspath(rel_from), self._abspath(rel_to))
+        except ftplib.error_perm, e:
+            raise FtpTransportError(orig_error=e)
+
+    def delete(self, relpath):
+        """Delete the item at relpath"""
+        try:
+            mutter("FTP rm: %s" % self._abspath(relpath))
+            f = self._get_FTP()
+            f.delete(self._abspath(relpath))
+        except ftplib.error_perm, e:
+            raise FtpTransportError(orig_error=e)
+
+    def listable(self):
+        """See Transport.listable."""
+        return True
+
+    def list_dir(self, relpath):
+        """See Transport.list_dir."""
+        try:
+            mutter("FTP nlst: %s" % self._abspath(relpath))
+            f = self._get_FTP()
+            basepath = self._abspath(relpath)
+            # FTP.nlst returns paths prefixed by relpath, strip 'em
+            the_list = f.nlst(basepath)
+            stripped = [path[len(basepath)+1:] for path in the_list]
+            # Remove . and .. if present, and return
+            return [path for path in stripped if path not in (".", "..")]
+        except ftplib.error_perm, e:
+            raise FtpTransportError(orig_error=e)
+
+    def iter_files_recursive(self):
+        """See Transport.iter_files_recursive.
+
+        This is cargo-culted from the SFTP transport"""
+        mutter("FTP iter_files_recursive")
+        queue = list(self.list_dir("."))
+        while queue:
+            relpath = urllib.quote(queue.pop(0))
+            st = self.stat(relpath)
+            if stat.S_ISDIR(st.st_mode):
+                for i, basename in enumerate(self.list_dir(relpath)):
+                    queue.insert(i, relpath+"/"+basename)
+            else:
+                yield relpath
+
+    def stat(self, relpath):
+        """Return the stat information for a file.
+        """
+        try:
+            mutter("FTP stat: %s" % self._abspath(relpath))
+            f = self._get_FTP()
+            return FtpStatResult(f, self._abspath(relpath))
+        except ftplib.error_perm, e:
+            raise FtpTransportError(orig_error=e)
+
+    def lock_read(self, relpath):
+        """Lock the given file for shared (read) access.
+        :return: A lock object, which should be passed to Transport.unlock()
+        """
+        # The old RemoteBranch ignore lock for reading, so we will
+        # continue that tradition and return a bogus lock object.
+        class BogusLock(object):
+            def __init__(self, path):
+                self.path = path
+            def unlock(self):
+                pass
+        return BogusLock(relpath)
+
+    def lock_write(self, relpath):
+        """Lock the given file for exclusive (write) access.
+        WARNING: many transports do not support this, so trying avoid using it
+
+        :return: A lock object, which should be passed to Transport.unlock()
+        """
+        return self.lock_read(relpath)

=== modified file 'bzrlib/transport/http.py'
--- bzrlib/transport/http.py	2005-11-04 15:13:02 +0000
+++ bzrlib/transport/http.py	2005-11-15 21:09:09 +0000
@@ -18,7 +18,7 @@
 
 from bzrlib.transport import Transport, register_transport
 from bzrlib.errors import (TransportNotPossible, NoSuchFile, 
-                           NonRelativePath, TransportError)
+                           NonRelativePath, TransportError, ConnectionError)
 import os, errno
 from cStringIO import StringIO
 import urllib2
@@ -142,14 +142,14 @@
         """
         try:
             return get_url(self.abspath(relpath))
-        except urllib2.URLError, e:
-            if getattr(e, 'code', None) == 404:
+        except urllib2.HTTPError, e:
+            if e.code == 404:
                 raise NoSuchFile(msg = "Error retrieving %s: %s" 
                                  % (self.abspath(relpath), str(e)),
                                  orig_error=e)
             raise
         except (BzrError, IOError), e:
-            raise NoSuchFile(msg = "Error retrieving %s: %s" 
+            raise ConnectionError(msg = "Error retrieving %s: %s" 
                              % (self.abspath(relpath), str(e)),
                              orig_error=e)
 

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2005-11-10 03:03:53 +0000
+++ bzrlib/tree.py	2005-11-18 05:45:04 +0000
@@ -297,7 +297,8 @@
     mutter('export version %r', tree)
     inv = tree.inventory
     for dp, ie in inv.iter_entries():
-        ie.put_on_disk(dest, dp, tree)
+        if dp != ".bzrignore":
+            ie.put_on_disk(dest, dp, tree)
 
 exporters['dir'] = dir_exporter
 
@@ -346,9 +347,10 @@
         mutter('export version %r', tree)
         inv = tree.inventory
         for dp, ie in inv.iter_entries():
-            mutter("  export {%s} kind %s to %s", ie.file_id, ie.kind, dest)
-            item, fileobj = ie.get_tar_item(root, dp, now, tree)
-            ball.addfile(item, fileobj)
+            if dp != ".bzrignore":
+                mutter("  export {%s} kind %s to %s" % (ie.file_id, ie.kind, dest))
+                item, fileobj = ie.get_tar_item(root, dp, now, tree)
+                ball.addfile(item, fileobj)
         ball.close()
 
     exporters['tar'] = tar_exporter

=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2005-11-04 14:37:48 +0000
+++ bzrlib/upgrade.py	2005-11-17 07:45:38 +0000
@@ -66,34 +66,21 @@
 # versions.
 
 
-# TODO: Don't create a progress bar here, have it passed by the caller.  
-# At least do it from the UI factory.
-
-if False:
-    try:
-        import psyco
-        psyco.full()
-    except ImportError:
-        pass
-
-
 import os
 import tempfile
 import sys
-import logging
 import shutil
 
 from bzrlib.branch import Branch, find_branch
 from bzrlib.branch import BZR_BRANCH_FORMAT_5, BZR_BRANCH_FORMAT_6
 import bzrlib.hashcache as hashcache
-from bzrlib.revfile import Revfile
 from bzrlib.weave import Weave
 from bzrlib.weavefile import read_weave, write_weave
 from bzrlib.ui import ui_factory
 from bzrlib.atomicfile import AtomicFile
 from bzrlib.xml4 import serializer_v4
 from bzrlib.xml5 import serializer_v5
-from bzrlib.trace import mutter, note, warning, enable_default_logging
+from bzrlib.trace import mutter, note, warning
 from bzrlib.osutils import sha_strings, sha_string
 
 

=== modified file 'bzrlib/weave.py'
--- bzrlib/weave.py	2005-10-27 02:01:53 +0000
+++ bzrlib/weave.py	2005-11-19 20:07:56 +0000
@@ -176,6 +176,9 @@
         self._name_map = {}
         self._weave_name = weave_name
 
+    def __repr__(self):
+        return "Weave(%r)" % self._weave_name
+
 
     def copy(self):
         """Return a deep copy of self.

=== modified file 'doc/random.txt'
--- doc/random.txt	2005-04-26 05:20:17 +0000
+++ doc/random.txt	2005-11-18 08:10:07 +0000
@@ -14,7 +14,7 @@
 
 * It is possibly nice that tla by default forbids you from committing
   if emacs autosave or lock files exist -- I find it confusing to
-  commit somethin other than what is shown in the editor window
+  commit something other than what is shown in the editor window
   because there are unsaved changes. 
 
   However, grumbling about unknown files is annoying, and requiring

=== removed file 'patches/cache-remote-revisions.diff'
--- patches/cache-remote-revisions.diff	2005-06-15 04:17:12 +0000
+++ patches/cache-remote-revisions.diff	1970-01-01 00:00:00 +0000
@@ -1,105 +0,0 @@
-***************
-*** 738,777 ****
-          revisions = []
-          pb = ProgressBar(show_spinner=True)
-          total = len(revision_ids)
--         for i,f in enumerate(revision_ids):
--             revisions.append(other.get_revision(f))
--             pb.update('retrieving revisions', i+1, total)
--         pb.clear()
--         
--         needed_texts = sets.Set()
-- 
--         for index, rev in enumerate(revisions):
--             pb.update('Scanning revisions for file contents', index, total)
--             inv = other.get_inventory(str(rev.inventory_id))
--             for key, entry in inv.iter_entries():
--                 if entry.text_id is None:
--                     continue
--                 if entry.text_id not in self.text_store:
--                     needed_texts.add(entry.text_id)
--         pb.clear()
--         count = self.text_store.copy_multi(other.text_store, needed_texts, pb,
--                                            "Copying file contents")
--         pb.clear()
--         print "Added %d file contents." % count 
--         inventory_ids = [ f.inventory_id for f in revisions ]
--         count = self.inventory_store.copy_multi(other.inventory_store, 
--                                                 inventory_ids, pb,
--                                                 "Copying inventories")
--         pb.clear()
--         print "Added %d inventories." % count 
--         revision_ids = [ f.revision_id for f in revisions]
--         count = self.revision_store.copy_multi(other.revision_store, 
--                                                revision_ids, pb, 
--                                                "Copying revisions")
--         pb.clear()
--         for revision_id in revision_ids:
--             self.append_revision(revision_id)
--         print "Added %d revisions." % count
-                      
-          
-      def commit(self, *args, **kw):
---- 738,799 ----
-          revisions = []
-          pb = ProgressBar(show_spinner=True)
-          total = len(revision_ids)
-+         tmp_dir = tempfile.mkdtemp(prefix = "temp-stores-")
-+         try:
-+             tmp_rev_dir = os.path.join(tmp_dir, "revisions")
-+             os.mkdir(tmp_rev_dir)
-+             tmp_revs = ImmutableStore(tmp_rev_dir)
-+             count = tmp_revs.copy_multi(other.revision_store, revision_ids, pb, 
-+                                         "Caching revisions")
-+             #EVIL! Substituting a local partial store for a complete one
-+             #This is a significant performance boost when complete one is
-+             #a remote store. 
-+             other.revision_store = tmp_revs
-+             pb.clear()
-+ 
-+             for i,f in enumerate(revision_ids):
-+                 revisions.append(other.get_revision(f))
-+                 pb.update("Parsing revisions", i, len(revision_ids))
-+             
-+             needed_texts = sets.Set()
-+ 
-+             #Again with the EVIL.
-+             tmp_rev_dir = os.path.join(tmp_dir, "inventories")
-+             os.mkdir(tmp_rev_dir)
-+             inv_ids = [r.inventory_id for r in revisions]
-+             tmp_revs = ImmutableStore(tmp_rev_dir)
-+             count = tmp_revs.copy_multi(other.inventory_store, inv_ids, pb, 
-+                                         "Caching inventories")
-+             other.inventory_store = tmp_revs
-+             pb.clear()
-+             for index, rev in enumerate(revisions):
-+                 pb.update('Scanning revisions for file contents', index, total)
-+                 inv = other.get_inventory(str(rev.inventory_id))
-+                 for key, entry in inv.iter_entries():
-+                     if entry.text_id is None:
-+                         continue
-+                     if entry.text_id not in self.text_store:
-+                         needed_texts.add(entry.text_id)
-+             pb.clear()
-+             count = self.text_store.copy_multi(other.text_store, needed_texts, pb,
-+                                                "Copying file contents")
-+             pb.clear()
-+             print "Added %d file contents." % count 
-+             inventory_ids = [ f.inventory_id for f in revisions ]
-+             count = self.inventory_store.copy_multi(other.inventory_store, 
-+                                                     inventory_ids, pb,
-+                                                     "Copying inventories")
-+             pb.clear()
-+             print "Added %d inventories." % count 
-+             revision_ids = [ f.revision_id for f in revisions]
-+             count = self.revision_store.copy_multi(other.revision_store, 
-+                                                    revision_ids)
-+             pb.clear()
-+             for revision_id in revision_ids:
-+                 self.append_revision(revision_id)
-+             print "Added %d revisions." % count
-+         finally:
-+             shutil.rmtree(tmp_dir)
-                      
-          
-      def commit(self, *args, **kw):

=== removed file 'patches/cache_weave_inclusions.diff'
--- patches/cache_weave_inclusions.diff	2005-09-19 10:46:28 +0000
+++ patches/cache_weave_inclusions.diff	1970-01-01 00:00:00 +0000
@@ -1,85 +0,0 @@
-=== modified file 'bzrlib/weave.py'
---- bzrlib/weave.py
-+++ bzrlib/weave.py
-@@ -83,6 +83,10 @@
- 
- # TODO: Perhaps the API should work only in names to hide the integer
- # indexes from the user?
-+
-+# TODO: Is there any potential performance win by having an add()
-+# variant that is passed a pre-cooked version of the single basis
-+# version?
- 
- 
- 
-@@ -191,8 +195,8 @@
-         Set by read_weave.
-     """
- 
--    __slots__ = ['_weave', '_parents', '_sha1s', '_names', '_name_map',
--                 '_weave_name']
-+    ##__slots__ = ['_weave', '_parents', '_sha1s', '_names', '_name_map',
-+    ##             '_weave_name', '_inclusion_cache']
-     
-     def __init__(self, weave_name=None):
-         self._weave = []
-@@ -201,7 +205,7 @@
-         self._names = []
-         self._name_map = {}
-         self._weave_name = weave_name
--
-+        self._inclusion_cache = {}
- 
-     def __eq__(self, other):
-         if not isinstance(other, Weave):
-@@ -300,7 +304,6 @@
-                 self._weave.append(('{', new_version))
-                 self._weave.extend(text)
-                 self._weave.append(('}', None))
--        
-             return new_version
- 
-         if len(parents) == 1:
-@@ -308,10 +311,9 @@
-             if sha1 == self._sha1s[pv]:
-                 # special case: same as the single parent
-                 return new_version
--            
- 
-         ancestors = self.inclusions(parents)
--
-+        self._inclusion_cache[(new_version,)] = ancestors | set([new_version])
-         l = self._weave
- 
-         # basis a list of (origin, lineno, line)
-@@ -379,17 +381,19 @@
- 
-     def inclusions(self, versions):
-         """Return set of all ancestors of given version(s)."""
-+        tv = tuple(sorted(versions))
-+        cached_val = self._inclusion_cache.get(tv)
-+        if cached_val is not None:
-+            return cached_val
-         i = set(versions)
--        v = max(versions)
--        try:
--            while v >= 0:
--                if v in i:
--                    # include all its parents
--                    i.update(self._parents[v])
--                v -= 1
--            return i
--        except IndexError:
--            raise ValueError("version %d not present in weave" % v)
-+        for v in xrange(max(versions), 0, -1):
-+            if v in i:
-+                # include all its parents
-+                i.update(self._parents[v])
-+        self._inclusion_cache[tv] = i
-+        return i
-+        ## except IndexError:
-+        ##     raise ValueError("version %d not present in weave" % v)
- 
- 
-     def parents(self, version):
-

=== removed file 'patches/find-touching-from-seq.diff'
--- patches/find-touching-from-seq.diff	2005-06-06 12:33:11 +0000
+++ patches/find-touching-from-seq.diff	1970-01-01 00:00:00 +0000
@@ -1,83 +0,0 @@
-*** modified file 'bzrlib/commands.py'
---- bzrlib/commands.py 
-+++ bzrlib/commands.py 
-@@ -610,11 +610,13 @@
-     hidden = True
-     takes_args = ["filename"]
-     def run(self, filename):
-+        from bzrlib.log import find_touching_revisions
-         b = Branch(filename, lock_mode='r')
-         inv = b.read_working_inventory()
-         file_id = inv.path2id(b.relpath(filename))
--        for revno, revision_id, what in bzrlib.log.find_touching_revisions(b, file_id):
--            print "%6d %s" % (revno, what)
-+        rh = b.revision_history()
-+        for revision_id, what in find_touching_revisions(b, file_id, rh):
-+            print "%-40s %s" % (revision_id, what)
- 
- 
- class cmd_ls(Command):
-
-*** modified file 'bzrlib/log.py'
---- bzrlib/log.py 
-+++ bzrlib/log.py 
-@@ -17,7 +17,7 @@
- 
- 
- 
--def find_touching_revisions(branch, file_id):
-+def find_touching_revisions(branch, file_id, revisions):
-     """Yield a description of revisions which affect the file_id.
- 
-     Each returned element is (revno, revision_id, description)
-@@ -25,13 +25,20 @@
-     This is the list of revisions where the file is either added,
-     modified, renamed or deleted.
- 
--    TODO: Perhaps some way to limit this to only particular revisions,
--    or to traverse a non-mainline set of revisions?
-+    branch
-+        Branch to examine
-+
-+    file_id
-+        File to consider
-+
-+    revisions
-+        Sequence of revisions to search, can be
-+        branch.revision_history() or a filtered version of that
-+        or some sequence of non-mailine revisions.
-     """
-     last_ie = None
-     last_path = None
--    revno = 1
--    for revision_id in branch.revision_history():
-+    for revision_id in revisions:
-         this_inv = branch.get_revision_inventory(revision_id)
-         if file_id in this_inv:
-             this_ie = this_inv[file_id]
-@@ -46,19 +53,19 @@
-             # not present in either
-             pass
-         elif this_ie and not last_ie:
--            yield revno, revision_id, "added " + this_path
-+            yield revision_id, "added " + this_path
-         elif not this_ie and last_ie:
-             # deleted here
--            yield revno, revision_id, "deleted " + last_path
-+            yield revision_id, "deleted " + last_path
-         elif this_path != last_path:
--            yield revno, revision_id, ("renamed %s => %s" % (last_path, this_path))
-+            yield revision_id, ("renamed %s => %s" % (last_path, this_path))
-         elif (this_ie.text_size != last_ie.text_size
-               or this_ie.text_sha1 != last_ie.text_sha1):
--            yield revno, revision_id, "modified " + this_path
-+            yield revision_id, "modified " + this_path
- 
-         last_ie = this_ie
-         last_path = this_path
--        revno += 1
-+
- 
- 
- def show_log(branch,
-

=== removed file 'patches/meta-data-in-inventory.patch'
--- patches/meta-data-in-inventory.patch	2005-06-13 12:14:52 +0000
+++ patches/meta-data-in-inventory.patch	1970-01-01 00:00:00 +0000
@@ -1,300 +0,0 @@
-*** modified file 'bzrlib/commands.py'
---- bzrlib/commands.py 
-+++ bzrlib/commands.py 
-@@ -1175,7 +1175,68 @@
-         b = Branch('.')
-         statcache.update_cache(b.base, b.read_working_inventory())
- 
--
-+class cmd_meta(Command):
-+    """Get or set the meta information properties about a file.
-+
-+    bzr meta FILENAME # Display all meta information
-+    bzr meta FILENAME prop # Display the value of meta-info named prop, return error if not found
-+    bzr meta FILENAME --set prop value # Set the value of prop to value
-+    echo "the value" | bzr meta FILENAME --set prop # Set the value to whatever is read from stdin
-+    bzr meta FILENAME --unset prop # Remove the property
-+
-+    bzr meta FILENAME --revision=10 # Display the meta information for a given revision
-+        (Not supported yet)
-+    """
-+    hidden = True
-+    takes_args = ['filename', 'property?', 'value?']
-+    takes_options = ['revision', 'set', 'unset']
-+
-+    def run(self, filename, property=None, value=None, revision=None, set=False, unset=False):
-+        if isinstance(revision, list) and len(revision) > 1:
-+            raise BzrCommandError('bzr meta takes at most 1 revision.')
-+        if revision is not None and (set or unset):
-+            raise BzrCommandError('Cannot set/unset meta information in an old version.')
-+        if set and unset:
-+            raise BzrCommandError('Cannot set and unset at the same time')
-+        if not set and value:
-+            raise BzrCommandError('You must supply --set if you want to set the value of a property.')
-+
-+        b = Branch(filename)
-+        inv = b.inventory
-+        file_id = inv.path2id(b.relpath(filename))
-+        inv_entry = inv[file_id]
-+        if not property:
-+            meta = inv_entry.meta
-+            if meta: # Not having meta is the same as having an empty meta
-+                keys = meta.properties.keys()
-+                keys.sort()
-+                # The output really needs to be parseable
-+                for key in keys:
-+                    print '%s: %r' % (key, meta.properties[key])
-+        else:
-+            meta = inv_entry.meta
-+            if set:
-+                if value is None:
-+                    value = sys.stdin.read()
-+                if not meta:
-+                    from bzrlib.inventory import Meta
-+                    inv_entry.meta = Meta({property:value})
-+                else:
-+                    inv_entry.meta.properties[property] = value
-+                b.inventory = inv # This should cause it to be saved
-+            elif unset:
-+                if not meta or not meta.properties.has_key(property):
-+                    return 3 # Cannot unset a property that doesn't exist
-+                    # I wonder if this should be a different return code
-+                del inv_entry.meta.properties[property]
-+                b.inventory = inv
-+            else:
-+                if not meta or not meta.properties.has_key(property):
-+                    return 3 # Missing property
-+                # Probably this should not be print, but 
-+                # sys.stdout.write() so that you get back exactly
-+                # what was given. But I'm leaving it this way for now
-+                print meta.properties[property]
- 
- # list of all available options; the rhs can be either None for an
- # option that takes no argument, or a constructor function that checks
-@@ -1196,6 +1257,8 @@
-     'verbose':                None,
-     'version':                None,
-     'email':                  None,
-+    'set':                    None,
-+    'unset':                  None,
-     }
- 
- SHORT_OPTIONS = {
-
-*** modified file 'bzrlib/diff.py'
---- bzrlib/diff.py 
-+++ bzrlib/diff.py 
-@@ -226,8 +226,10 @@
-                       new_tree.get_file(file_id).readlines(),
-                       to_file)
- 
--    for old_path, new_path, file_id, kind, text_modified in delta.renamed:
-+    for old_path, new_path, file_id, kind, text_modified, meta_modified in delta.renamed:
-         print '*** renamed %s %r => %r' % (kind, old_path, new_path)
-+        if meta_modified:
-+            print '## Meta-info modified'
-         if text_modified:
-             diff_file(old_label + old_path,
-                       old_tree.get_file(file_id).readlines(),
-@@ -235,9 +237,11 @@
-                       new_tree.get_file(file_id).readlines(),
-                       to_file)
- 
--    for path, file_id, kind in delta.modified:
-+    for path, file_id, kind, text_modified, meta_modified in delta.modified:
-         print '*** modified %s %r' % (kind, path)
--        if kind == 'file':
-+        if meta_modified:
-+            print '## Meta-info modified'
-+        if kind == 'file' and text_modified:
-             diff_file(old_label + path,
-                       old_tree.get_file(file_id).readlines(),
-                       new_label + path,
-@@ -316,7 +320,7 @@
- 
-         if self.renamed:
-             print >>to_file, 'renamed:'
--            for oldpath, newpath, fid, kind, text_modified in self.renamed:
-+            for oldpath, newpath, fid, kind, text_modified, meta_modified in self.renamed:
-                 if show_ids:
-                     print >>to_file, '  %s => %s %s' % (oldpath, newpath, fid)
-                 else:
-@@ -324,7 +328,16 @@
-                     
-         if self.modified:
-             print >>to_file, 'modified:'
--            show_list(self.modified)
-+            for path, fid, kind, text_modified, meta_modified in self.modified:
-+                if kind == 'directory':
-+                    path += '/'
-+                elif kind == 'symlink':
-+                    path += '@'
-+                    
-+                if show_ids:
-+                    print >>to_file, '  %-30s %s' % (path, fid)
-+                else:
-+                    print >>to_file, ' ', path
-             
-         if show_unchanged and self.unchanged:
-             print >>to_file, 'unchanged:'
-@@ -388,6 +401,14 @@
-                 ## mutter("no text to check for %r %r" % (file_id, kind))
-                 text_modified = False
- 
-+            old_meta = old_inv[file_id].meta
-+            new_meta = new_inv[file_id].meta
-+
-+            if old_meta != new_meta:
-+                meta_modified = True
-+            else:
-+                meta_modified = False
-+
-             # TODO: Can possibly avoid calculating path strings if the
-             # two files are unchanged and their names and parents are
-             # the same and the parents are unchanged all the way up.
-@@ -395,9 +416,10 @@
-             
-             if old_path != new_path:
-                 delta.renamed.append((old_path, new_path, file_id, kind,
--                                      text_modified))
--            elif text_modified:
--                delta.modified.append((new_path, file_id, kind))
-+                                      text_modified, meta_modified))
-+            elif text_modified or meta_modified:
-+                delta.modified.append((new_path, file_id, kind,
-+                                       text_modified, meta_modified))
-             elif want_unchanged:
-                 delta.unchanged.append((new_path, file_id, kind))
-         else:
-
-*** modified file 'bzrlib/inventory.py'
---- bzrlib/inventory.py 
-+++ bzrlib/inventory.py 
-@@ -33,6 +33,67 @@
- import bzrlib
- from bzrlib.osutils import uuid, quotefn, splitpath, joinpath, appendpath
- from bzrlib.trace import mutter
-+
-+class Meta(XMLMixin):
-+    """Meta information about a single inventory entry.
-+
-+    This is basically just a set of key->value pairs.
-+
-+    In general, bzr does not handle this information, it only provides
-+    a location for plugins and other data sources to store this data.
-+
-+    """
-+    def __init__(self, properties):
-+        self.properties = properties
-+
-+    def __eq__(self, other):
-+        if other is None:
-+            return False
-+        if not isinstance(other, Meta):
-+            return NotImplemented
-+
-+        return (self.properties == other.properties)
-+
-+    def __ne__(self, other):
-+        return not (self == other)
-+
-+    def __hash__(self):
-+        raise ValueError('not hashable')
-+
-+    def from_element(cls, elt):
-+        assert elt.tag == 'meta'
-+
-+        properties = {}
-+        for child in elt:
-+            if child.tag == 'property':
-+                if child.text is None:
-+                    properties[child.get('name')] = ''
-+                else:
-+                    properties[child.get('name')] = child.text
-+        self = cls(properties)
-+        return self
-+
-+    from_element = classmethod(from_element)
-+
-+    def to_element(self):
-+        e = Element('meta')
-+        keys = self.properties.keys()
-+        keys.sort()
-+
-+        # The blah.text is just to make things look pretty in the files
-+        # We may want to remove it
-+        if len(keys) > 0:
-+            e.text = '\n'
-+
-+        for key in keys:
-+            prop = Element('property')
-+            prop.set('name', key)
-+            prop.text=self.properties[key]
-+            prop.tail='\n'
-+            e.append(prop)
-+
-+        return e
-+
- 
- class InventoryEntry(XMLMixin):
-     """Description of a versioned file.
-@@ -100,6 +161,7 @@
- 
-     text_sha1 = None
-     text_size = None
-+    meta = None
-     
-     def __init__(self, file_id, name, kind, parent_id, text_id=None):
-         """Create an InventoryEntry
-@@ -124,6 +186,7 @@
-         self.kind = kind
-         self.text_id = text_id
-         self.parent_id = parent_id
-+        self.meta = None
-         if kind == 'directory':
-             self.children = {}
-         elif kind == 'file':
-@@ -146,6 +209,10 @@
-         other.text_size = self.text_size
-         # note that children are *not* copied; they're pulled across when
-         # others are added
-+        if self.meta:
-+            other.meta = Meta(self.meta.properties)
-+        else:
-+            other.meta = None
-         return other
- 
- 
-@@ -182,6 +249,9 @@
-             e.set('parent_id', self.parent_id)
- 
-         e.tail = '\n'
-+
-+        if self.meta:
-+            e.append(self.meta.to_element())
-             
-         return e
- 
-@@ -205,6 +275,11 @@
-         v = elt.get('text_size')
-         self.text_size = v and int(v)
- 
-+        self.meta = None
-+        for child in elt:
-+            if child.tag == 'meta':
-+                self.meta = Meta.from_element(child)
-+
-         return self
-             
- 
-@@ -220,7 +295,8 @@
-                and (self.text_size == other.text_size) \
-                and (self.text_id == other.text_id) \
-                and (self.parent_id == other.parent_id) \
--               and (self.kind == other.kind)
-+               and (self.kind == other.kind) \
-+               and (self.meta == other.meta)
- 
- 
-     def __ne__(self, other):
-

=== removed file 'patches/ndiff.patch'
--- patches/ndiff.patch	2005-07-04 12:11:40 +0000
+++ patches/ndiff.patch	1970-01-01 00:00:00 +0000
@@ -1,149 +0,0 @@
-*** modified file 'bzrlib/commands.py'
---- bzrlib/commands.py 
-+++ bzrlib/commands.py 
-@@ -721,10 +721,11 @@
-     """
-     
-     takes_args = ['file*']
--    takes_options = ['revision', 'diff-options']
-+    takes_options = ['revision', 'diff-options', 'ndiff']
-     aliases = ['di', 'dif']
- 
--    def run(self, revision=None, file_list=None, diff_options=None):
-+    def run(self, revision=None, file_list=None, diff_options=None,
-+            ndiff=None):
-         from bzrlib.diff import show_diff
- 
-         if file_list:
-@@ -735,9 +736,15 @@
-                 file_list = None
-         else:
-             b = find_branch('.')
--    
-+
-+        if ndiff:
-+            format = 'ndiff'
-+        else:
-+            format = None
-+
-         show_diff(b, revision, specific_files=file_list,
--                  external_diff_options=diff_options)
-+                  external_diff_options=diff_options,
-+                  format=format)
- 
- 
-         
-@@ -1344,6 +1351,7 @@
-     'format':                 unicode,
-     'forward':                None,
-     'message':                unicode,
-+    'ndiff':                  None,
-     'no-recurse':             None,
-     'profile':                None,
-     'revision':               _parse_revision_str,
-
-*** modified file 'bzrlib/diff.py'
---- bzrlib/diff.py 
-+++ bzrlib/diff.py 
-@@ -70,6 +70,13 @@
-     print >>to_file
- 
- 
-+
-+def internal_ndiff(old_label, oldlines,
-+                   new_label, newlines,
-+                   to_file):
-+    """Show diff in python-specific ndiff format."""
-+    from difflib import ndiff
-+    to_file.writelines(ndiff(oldlines, newlines))
- 
- 
- def external_diff(old_label, oldlines, new_label, newlines, to_file,
-@@ -152,7 +159,8 @@
-     
- 
- 
--def show_diff(b, revision, specific_files, external_diff_options=None):
-+def show_diff(b, revision, specific_files, external_diff_options=None,
-+              format=None):
-     """Shortcut for showing the diff to the working tree.
- 
-     b
-@@ -160,6 +168,9 @@
- 
-     revision
-         None for each, or otherwise the old revision to compare against.
-+
-+    format
-+        'unified', 'context', 'ndiff', 'external'
-     
-     The more general form is show_diff_trees(), where the caller
-     supplies any two trees.
-@@ -174,12 +185,13 @@
-     new_tree = b.working_tree()
- 
-     show_diff_trees(old_tree, new_tree, sys.stdout, specific_files,
--                    external_diff_options)
-+                    external_diff_options, format)
- 
- 
- 
- def show_diff_trees(old_tree, new_tree, to_file, specific_files=None,
--                    external_diff_options=None):
-+                    external_diff_options=None,
-+                    format=None):
-     """Show in text form the changes from one tree to another.
- 
-     to_files
-@@ -204,10 +216,12 @@
-     if external_diff_options:
-         assert isinstance(external_diff_options, basestring)
-         opts = external_diff_options.split()
--        def diff_file(olab, olines, nlab, nlines, to_file):
-+        def diff_fn(olab, olines, nlab, nlines, to_file):
-             external_diff(olab, olines, nlab, nlines, to_file, opts)
-+    elif format == 'ndiff':
-+        diff_fn = internal_ndiff
-     else:
--        diff_file = internal_diff
-+        diff_fn = internal_diff
-     
- 
-     delta = compare_trees(old_tree, new_tree, want_unchanged=False,
-@@ -216,7 +230,7 @@
-     for path, file_id, kind in delta.removed:
-         print >>to_file, '*** removed %s %r' % (kind, path)
-         if kind == 'file':
--            diff_file(old_label + path,
-+            diff_fn(old_label + path,
-                       old_tree.get_file(file_id).readlines(),
-                       DEVNULL, 
-                       [],
-@@ -225,7 +239,7 @@
-     for path, file_id, kind in delta.added:
-         print >>to_file, '*** added %s %r' % (kind, path)
-         if kind == 'file':
--            diff_file(DEVNULL,
-+            diff_fn(DEVNULL,
-                       [],
-                       new_label + path,
-                       new_tree.get_file(file_id).readlines(),
-@@ -234,7 +248,7 @@
-     for old_path, new_path, file_id, kind, text_modified in delta.renamed:
-         print >>to_file, '*** renamed %s %r => %r' % (kind, old_path, new_path)
-         if text_modified:
--            diff_file(old_label + old_path,
-+            diff_fn(old_label + old_path,
-                       old_tree.get_file(file_id).readlines(),
-                       new_label + new_path,
-                       new_tree.get_file(file_id).readlines(),
-@@ -243,7 +257,7 @@
-     for path, file_id, kind in delta.modified:
-         print >>to_file, '*** modified %s %r' % (kind, path)
-         if kind == 'file':
--            diff_file(old_label + path,
-+            diff_fn(old_label + path,
-                       old_tree.get_file(file_id).readlines(),
-                       new_label + path,
-                       new_tree.get_file(file_id).readlines(),
-

